Attribute VB_Name = "Archivos"
'******************************************************************************
'Mdulo con subrutinas de acceso a disco.
'                                        Creado Por: Tito Hinostroza 27/02/2004
'                               ltima modificacin: Tito Hinostroza 03/12/2011
'******************************************************************************
Option Explicit

'API's para cuadro de dilogo de abrir archivo. No se usa controles de VB para hacer ms transportable el programa
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public Function DialogoAbrir(hWnd As Long, _
    tipArch As String, extArchiv As String, _
    Optional InitialDir As String = "C:\", _
    Optional titulo As String = "Abrir Archivo") As String
'Si se cancel devuelve "". Si se seleccion un archivo, devuelve diferente de cero.
Dim OpDlg As OPENFILENAME
Dim tmp As String
'Inicia estructura de Nombre de archivo
    OpDlg.lStructSize = Len(OpDlg)
    OpDlg.hwndOwner = hWnd              'Set the parent window
    OpDlg.hInstance = App.hInstance     'Set the application's instance
    'Select a filter
    OpDlg.lpstrFilter = tipArch + Chr$(0) + extArchiv + Chr$(0) + "Todos (*.*)" + Chr$(0) + "*.*" + Chr$(0)
    OpDlg.lpstrFile = Space$(254)       'create a buffer for the file
    OpDlg.nMaxFile = 255                'set the maximum length of a returned file
    OpDlg.lpstrFileTitle = Space$(254)  'Create a buffer for the file title
    OpDlg.nMaxFileTitle = 255           'Set the maximum length of a returned file title
    OpDlg.lpstrInitialDir = InitialDir  'Set the initial directory
    OpDlg.lpstrTitle = titulo           'Set the title
    OpDlg.flags = 0                     'No flags

    If GetOpenFileName(OpDlg) <> 0 Then
        tmp = OpDlg.lpstrFile
    End If
    'Quita caracter nulo final y espacios
    tmp = RTrim(tmp)
    If tmp = "" Then Exit Function
    If Asc(Right$(tmp, 1)) = 0 Then
        DialogoAbrir = Left$(tmp, Len(tmp) - 1)
    End If
End Function

Public Function DialogoGuardar(hWnd As Long, _
    tipArch As String, extArchiv As String, _
    Optional InitialDir As String = "C:\", _
    Optional titulo As String = "Guardar Archivo", _
    Optional nomDef As String = "") As String
Dim OFName As OPENFILENAME
Dim arch As String
'Inicia estructura de Nombre de archivo
    OFName.lStructSize = Len(OFName)    'Set the structure size
    OFName.hwndOwner = hWnd          'Set the owner window
    OFName.hInstance = App.hInstance    'Set the application's instance
    'Set the filter
    OFName.lpstrFilter = tipArch + Chr$(0) + extArchiv + Chr$(0) + "Todos (*.*)" + Chr$(0) + "*.*" + Chr$(0)
    OFName.lpstrFile = Mid$(nomDef & Space$(254), 1, 254)    'Create a buffer
    OFName.nMaxFile = 255               'Set the maximum number of chars
    OFName.lpstrFileTitle = Space$(254)     'Create a buffer
    OFName.nMaxFileTitle = 255          'Set the maximum number of chars
    OFName.lpstrInitialDir = InitialDir       'Set the initial directory
    OFName.lpstrTitle = titulo      'Set the dialog title
    OFName.flags = 0                    'no extra flags
    'Show the 'Save File'-dialog
    If GetSaveFileName(OFName) Then
        arch = Trim$(OFName.lpstrFile)
        'quita chr(0) al final
        If Asc(Right$(arch, 1)) = 0 Then arch = Left$(arch, Len(arch) - 1)
        DialogoGuardar = arch
    Else
        DialogoGuardar = ""
    End If
End Function

'############## Funciones de conversin de datos para acceso a disco ############
Function N2f(n As Single) As String
'Convierte nmero a cadena para guardar en disco. Independiente de la configuracin regional
    N2f = Replace(CStr(n), ",", ".")    'asegura que se usa siempre el punto decimal
End Function

Function f2N(s As String) As Single
'Convierte cadena de disco a nmero. Independiente de la configuracin regional
    f2N = val(s)     'usa siempre el punto decimal
End Function

Function B2f(b As Boolean) As String
'Convierte Boleean a cadena para guardar en disco.
    If b Then B2f = "V" Else B2f = "F"
End Function

Function f2B(s As String) As Boolean
'Convierte cadena de disco a Boleean
    If s = "V" Then f2B = True
    If s = "F" Then f2B = False
End Function

Function D2f(d As Date) As String
'Convierte fecha a cadena para guardar en disco.
    D2f = Format(d, "yyyy:mm:dd:hh:mm:ss")
End Function

Function f2D(s As String) As Date
'Convierte cadena de disco a fecha.
Dim a() As String
    If s = "0" Then Exit Function     'para proteger de las versiones anteriores
    a = Split(s, ":")
    f2D = DateSerial(a(0), a(1), a(2)) + TimeSerial(a(3), a(4), a(5))
End Function

'!!!!!!!!!! Las cadenas que contengan \! o \? pueden dar problema
'No se usa \t o \n porque pueden aparecer facilmente en rutas de archivos
Function S2f(s As String) As String
'Convierte cadena a formato para guardar en disco.
Dim tmp As String
    tmp = Replace(s, vbTab, "\!")   'no se permiten tabulaciones
    S2f = Replace(tmp, vbCrLf, "\?")  'tampoco saltos de lnea
End Function

Function f2S(s As String) As String
'Convierte cadena de disco a cadena.
Dim tmp As String
    tmp = Replace(s, "\!", vbTab)   'recupera tabulaciones
    f2S = Replace(tmp, "\?", vbCrLf)  'y saltos de lnea
End Function

'################################################################################
Public Sub CambiaDir(direct As String)
'Mueve la ruta actual al directorio actual
    If direct Like "?:*" Then
        ChDrive Left(direct, 1)
    End If
    If direct <> "" Then
        ChDir direct
    End If
End Sub

Public Function rutaArc(archivo As String) As String
'Devuelve la carpeta de un archivo. Quita el nombre
Dim a() As String
    If InStr(archivo, "\") = 0 Then
        'No hay referencia de carpeta
        rutaArc = App.Path  'toma la carpeta actual
    Else
        'Hay referencia a carpeta carpeta
        a = Split(archivo, "\") 'separa
        ReDim Preserve a(UBound(a) - 1) 'quita el ltimo
        rutaArc = Join(a, "\")  'reconstruye
    End If
End Function

Public Function nombreArc(archivo As String) As String
'Devuelve el nombre de un archivo. Quita la ruta
Dim a() As String
    If InStr(archivo, "\") = 0 Then
        'No hay referencia de carpeta
        nombreArc = archivo 'toma la carpeta actual
    Else
        'Hay referencia a carpeta carpeta
        a = Split(archivo, "\") 'separa
        nombreArc = a(UBound(a)) 'toma ltimo elemento
    End If
End Function

Function sin_extension(nom_archivo As String) As String
'quita la extension del nombre del archivo (incluido el punto). No toca el camino
Dim temp As String
Dim i As Integer
    temp = nom_archivo
    i = Len(nom_archivo)    'busac desde el final
    While i > 0
        If Mid$(nom_archivo, i, 1) = "." Then
            sin_extension = Left(nom_archivo, i - 1)    'toma hasta antes del punto
            Exit Function
        End If
        i = i - 1   'para buscar el siguiente
    Wend
    sin_extension = nom_archivo 'no hay punto
End Function

Public Function GenNombSal(nomBase As String) As String
'Devuelve el nombre de un archivo de salida
Dim tmp As String
Dim inten As Integer    'Nmero de intentos con el nombre de archivo de salida
Dim cadBase As String   'Cadena base del nombre base
'    IniError
    cadBase = sin_extension(nombreArc(nomBase))      'quita ruta y extensin
    'genera un archivo en \bolsa
    tmp = App.Path & "\bolsa\" & cadBase & ".tmp"
    'verifica si ya existe ese nombre, si es asi busca otro nombre
    inten = 0
    While Dir(tmp) <> ""
        inten = inten + 1       'siguiente numero
        'genera nuevo nombre con cardinal al final
        tmp = App.Path & "\bolsa\" & cadBase & "~" & Format(inten, "00") & ".tmp"
    Wend
    GenNombSal = tmp
End Function

Public Function GenArchTemp(txt As String) As String
'Genera el nombre de un archivo temporal con el contenido indicado
Dim arc As String
Dim nar As Integer
    arc = GenNombSal("temp.tmp")
    nar = FreeFile
    Open arc For Output As #nar
    Print #nar, txt
    Close #nar
    GenArchTemp = arc   'Devuelve nombre de temporal
End Function

Public Function TextoArc(arc As String) As String
'Dervuelve el texto contenido en un archivo
Dim nar As Integer
Dim lin As String, tmp As String
    If Dir(arc) = "" Then
        msjError = "No se encuentra el archivo."
        Exit Function
    End If
    nar = FreeFile
    Open arc For Input As #nar
    While Not EOF(nar)
        Line Input #nar, lin
        tmp = tmp & lin & vbCrLf
    Wend
    Close #nar
    'quita salto de lnea final y devuleve resultado
    If Len(tmp) > 0 Then
        TextoArc = Left$(tmp, Len(tmp) - 2)
    End If
End Function

Public Function CreaArchivo(Optional nom_arc As String = "", _
                            Optional txt As String) As String
'Crea un archivo temporal con un texto. Si no se especifica
'el nombre del archivo, genera un nombre y lo devuelve
Dim nar As Integer
    If nom_arc = "" Then
       nom_arc = App.Path & "\temp.txt"
       CreaArchivo = nom_arc    'devuelve
    End If
    On Error GoTo err_crea
    nar = FreeFile
    Open nom_arc For Output As #nar
    Print #nar, txt
    Close #nar
    On Error GoTo 0
    Exit Function
err_crea:
    MsgBox "Error creando archivo: " & nom_arc
    On Error GoTo 0
End Function

Sub leerArchivoIni()
Dim nar As Integer
Dim tmp As String
Dim a() As String
'    IniError
    On Error GoTo Err_Archivo
    'lee archivo de configuracin
    nar = FreeFile
    Open arIni For Input As nar
    'Lee parmetros con nombre
    While Not EOF(nar)
        Line Input #nar, tmp
        If Left$(tmp, 5) = "[APP]" Then
            frmMain.LeePropiedades Mid$(tmp, 7)
        ElseIf Left$(tmp, 5) = "[TER]" Then
            a = Split(tmp, W)
            TerMaxLin = val(a(1))
            recPrompt = f2B(a(4))
            patPromptIni = f2S(a(5))
            patPromptFin = f2S(a(6))
            TerTraDir = f2N(a(7))
        ElseIf Left$(tmp, 5) = "[CNX]" Then
            a = Split(tmp, W)
            conexiones.Add a(1)
        ElseIf Left$(tmp, 8) = "[TERVER]" Then
            'ventana de terminal
            frmMain.txtTerm.LeePropiedades Mid$(tmp, 10)
        ElseIf Left$(tmp, 8) = "[PANCOM]" Then
            'panel de comandos
            frmMain.edCom.LeePropiedades Mid$(tmp, 10)
        End If
    Wend
    Close nar
    'Agrega la lista de macros
Dim n As Integer
    tmp = Dir(CarpetaMac & "\" & "*.ttm")
    n = 1
    While tmp <> ""
        Load frmMain.mnMacFrec(n)
        frmMain.mnMacFrec(n).Caption = tmp
        tmp = Dir()
        n = n + 1
    Wend
    'Agrega la lista de scripts
    tmp = Dir(CarpetaCom & "\" & "*.sh")
    n = 1
    While tmp <> ""
        Load frmMain.mnComFrec(n)
        frmMain.mnComFrec(n).Caption = tmp
        tmp = Dir()
        n = n + 1
    Wend
    
    On Error GoTo 0
    Exit Sub
Err_Archivo:
    msjError = "Error leyendo archivo " & arIni & vbCrLf & _
               "Error procesando: " & tmp & vbCrLf & "(" & Err.Description & ")"
    Close nar   'Intenta Cerrar el archivo
    On Error GoTo 0
End Sub

Sub escribirArchivoIni()
Dim nar As String
Dim v As Variant
'    IniError     'Limpia error
    On Error GoTo ErrArcIni
    If Dir(arIni) <> "" Then    've si existe
        If GetAttr(arIni) And vbReadOnly Then
            msjError = "Error. Archivo de configuracin es de slo lectura"
            Exit Sub
        End If
        'Crea copia de seguridad antes de modificar
        FileCopy arIni, arIni & ".bak"
    End If
    nar = FreeFile
    Open arIni For Output As nar
    '----------Parmetros con nombre--------------
    'nombre de programa y versin
    Print #nar, "[VER]" & W & NombPrograma & W & W
    'Opciones del entorno
    Print #nar, "[APP]" & W & frmMain.CadPropiedades
    'Opciones del terminal
    Print #nar, "[TER]" & W & TerMaxLin & W & W & W & _
                            B2f(recPrompt) & W & _
                            S2f(patPromptIni) & W & _
                            S2f(patPromptFin) & W & _
                            val(TerTraDir) & W & W & W
    For Each v In conexiones
        Print #nar, "[CNX]" & W & v & W & W & W & W
    Next
    'Opciones del editor de consola
    Print #nar, "[TERVER]" & W & frmMain.txtTerm.CadPropiedades
    'Opciones Colores del editor del Panel de comandos
    Print #nar, "[PANCOM]" & W & frmMain.edCom.CadPropiedades
    
    Close nar
    On Error GoTo 0
    Exit Sub
ErrArcIni:
    msjError = "Error escribiendo en archivo: " & arIni
    Close nar       'Intenta cerrar el archivo
    On Error GoTo 0
End Sub

Function Dispon(arc As String) As Boolean
'Verifica disponibilidad de archivo
Dim pos As Long
Dim cad As String
Dim arc_temp As String
    arc_temp = arc & ".chg"          'inicia
    If Dir(arc_temp) <> "" Then Kill arc_temp   'si ya existe lo borra
    On Error Resume Next
    Name arc As arc_temp
'    MsgBox Err.Description
    If Err.Number = 0 Then    'se cambio de nombre
        Name arc_temp As arc  'devuelve nombre
        Dispon = True
    Else                      'fall, no est listo
        Dispon = False
    End If
    On Error GoTo 0
End Function

Public Sub VerificaCarpeta(carpeta As String)
'Verifica la existencia de una carpeta y la crea previa confirmacin.
'El parmetro "escLog" indica si se debe escribir en el Registro.
'Si hubo error o no se acept la confirmacin de creacin, muestra
'mensaje y termina el programa
    On Error GoTo err_verif
    If Dir(carpeta, vbDirectory) = "" Then
        If MsgBox("No se encuentra carpeta: '" & carpeta & "'. Desea crearla? ", _
                  vbExclamation Or vbYesNo Or vbDefaultButton2) = vbYes Then
            MkDir carpeta
        Else    'No se ha permitido crear la carpeta
            MsgBox "No existe Carpeta: " & carpeta, vbCritical
            End     'Termina el programa
        End If
    End If
    On Error GoTo 0
    Exit Sub
err_verif:
    msjError = "Error creando carpeta: " & carpeta & "(" & Err.Description & ")"
    MsgBox msjError, vbCritical
    On Error GoTo 0
End Sub



