VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CInterprete"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'**************************************************************************************
'                                       CInterprete
'Clase que permite realizar un anlisis lxico y sintctico.
'Basado en los mdulos simialres de los programas Ya-Plus, y TSQL.
'
'                                                     Por Tito Hinostroza 22/08/2010
'**************************************************************************************

Option Explicit

'Propiedades de la clase
Public tip As String
Public arc As String       'nombre de archivo
Public fil As Long         'fila actual
Public col As Integer      'columna actual
Private lin() As String     'Contenido de lneas. Se almacena en matriz porque es rpida
                    'la carga desde un archivo y porque es ms compatible con el
                    'almacenamiento en el Control Editor.
Public linact As String    'La lnea actual
Public nLin As Long        'Nmero de lnea

Public Ejec As Boolean      'Bandera que activa la ejecucin

Private variables(1 To MAX_NUM_VAR) As Tvar
Private nvariables As Integer

'ndice de variables del sistema
Public i_result As Integer      'ndice de result
Public i_timeout As Integer     'ndice de timeout
Public i_0 As Integer           'ndice de $0
Public i_1 As Integer           'ndice de $1
Public i_2 As Integer
Public i_3 As Integer
Public i_4 As Integer
Public i_5 As Integer
Public i_6 As Integer
Public i_7 As Integer
Public i_8 As Integer
Public i_9 As Integer

'******************** Funciones para el manejo de contenidos *******************
Friend Function LeePosContAct() As TPosCont
'Devuelve contenido actual y su posicin
'    LeePosContAct.nCon = ConAct
    LeePosContAct.fil = fil
    LeePosContAct.col = col
    LeePosContAct.arc = arc
    LeePosContAct.linact = linact
'    LeePosContAct.nLin = con.nLin
End Function

Friend Sub FijPosContAct(pc As TPosCont)
'Fija contenido actual y su posicin
'    ConAct = pc.nCon
    fil = pc.fil
    col = pc.col
    arc = pc.arc
    linact = pc.linact
'    nLin = pc.nLin
End Sub

Public Function CreaContenido(txt As String) As Integer
'Carga el contenido actual con un contenido obtenido a partir
'de una cadena.
    tip = TC_TXT
    fil = 1
    col = 1
    'Llena vector de lneas
    'Le agrega un salto al inicio para que inicie en 1
    lin = Split(vbCrLf & txt, vbCrLf)
    'Actualiza nmero de lneas
    nLin = UBound(lin)
    arc = ""
    linact = lin(1)      'actualiza Lnea actual
    CreaContenido = nLin    'Devuelve nmero de lnea
End Function

Public Function CreaContenidoArc(arc As String) As Integer
'Carga el contenido actual con un contenido obtenido a partir
'de un archivo.
Dim nar As Integer
Dim linea As String
    If Dir(arc) = "" Then
        msjError = "No se encuentra archivo: " & arc
        Exit Function
    End If
    tip = TC_ARC
    fil = 1
    col = 1
    'Llena vector de lneas
    nar = FreeFile
    Open arc For Input As #nar
    ReDim lin(0)
    nLin = 0    'prepara para cuenta
    While Not EOF(nar)
        Line Input #nar, linea
        nLin = nLin + 1   'actualiza nuevo nmero de lneas
        ReDim Preserve lin(nLin)  'crea espacio
        lin(nLin) = linea       'escribe la nueva lnea
    Wend
    Close #nar
    'con.nLin = nLin   'Actualiza nmero de lneas
    arc = arc
    If nLin > 0 Then linact = lin(1) Else linact = ""
    CreaContenidoArc = nLin
End Function

Public Function IniCont() As Boolean
'Devuelve verdadero si se est al inicio del contenido actual (fila 1, columna 1)
    If fil = 1 And col = 1 Then
        IniCont = True
    Else
        IniCont = False
    End If
End Function

Public Function FinCont() As Boolean
'Devuelve verdadero si se ha pasado del final del contenido actual
    'Proteccin a contenido vaco
    If nLin = 0 Then
        FinCont = True
        Exit Function
    End If
    'Verifica optimizando por "mayora de casos"
    If fil < nLin Then
        FinCont = False
    ElseIf fil > nLin Then
        FinCont = True
    ElseIf fil = nLin Then
        'Verifica si estamos en la lnea final.
        'OJO, en la lnea final no existe un salto de lnea adicional
        If col >= Len(linact) + 1 Then
            FinCont = True
        Else
            FinCont = False
        End If
    End If
End Function

Public Function FinLin() As Boolean
'Devuelve verdadero si nos encontramos al final de una lnea en el contenido
'actual.
    If col = Len(linact) + 1 Then
        FinLin = True
    End If
End Function

'********************************************************************************
'********************** Funciones de manejo de cadenas **************************
Public Function EsBlanco(c As String) As Boolean
    If c = " " Or c = Chr(9) Then      'espacio o tab
        EsBlanco = True
    End If
End Function

Public Sub eliminaCad(cad As String, ini As Integer, lon As Integer)
'Elimina los caracteres especificados en la cadena dada
Dim temp As String
    If ini + lon - 1 > Len(cad) Then Exit Sub
    temp = Mid$(cad, 1, ini - 1) & Mid$(cad, ini + lon)
    cad = temp
End Sub

Public Sub insertaCad(dest As String, cad As String, ini As Integer)
'Inserta una cadena en otra en la posicion dada
Dim temp As String
    If ini > Len(dest) + 1 Then Exit Sub
    temp = Mid$(dest, 1, ini - 1) & cad & Mid$(dest, ini)
    dest = temp
End Sub

Public Sub quitaEspaciosMultiples(cad As String)
'Quita los espacios mayores a 1 caracter (separacion simple entre palabras)
Dim i As Integer
    cad = LTrim(cad)
    While InStr(1, cad, "  ") <> 0
        i = InStr(1, cad, "  ")
        cad = Mid$(cad, 1, i - 1) & Mid$(cad, i + 1)
    Wend
End Sub

Public Sub quitaComentario(lin As String)
'quita el comentario a una linea
Dim i As Integer
    For i = 1 To Len(lin) - 1
        If Mid$(lin, i, LON_COM_LIN) = CAD_COM_LIN Then
            lin = Left$(lin, i - 1) 'coge hasta antes del comentario
            Exit Sub
        End If
    Next i
End Sub

'********************************************************************************
'************************ Verificacin y Extraccin *****************************
Public Function VerCar(Optional numcar As Integer = 1) As String
'Devuelve el caracter actual (o caracteres a partir de la posicin actual)
'del contenido actual.
'Si no hay texto en el contenido actual o si se ha llegado al final del
'texto, devuelve cadena vaca.
'Si est al final de una lnea devuelve siempre "vbCrLf"
    If FinCont Then Exit Function
    If col = Len(linact) + 1 Then
        'Se est al fin de la lnea. Se considera que cada lnea
        'tiene un salto de lnea al final, excepto la ltima lnea.
        'En este caso siempre se devuelve 2 caracteres
        VerCar = vbCrLf
    Else
        'No se est al fin de la lnea
        VerCar = Mid$(linact, col, numcar)
    End If
End Function

Public Function CogCar(Optional numcar As Integer = 1) As String
'Devuelve el caracter actual del contenido actual e incrementa
'el puntero a la siguiente posicin.
'La siguiente posicin del fin de una lnea es el caracter "salto de
'lnea", que son en realidad dos caracteres.
    If FinCont Then Exit Function
    If col = Len(linact) + 1 Then    'Al fin de lnea
        'Trabaja igual que VerCar().
        CogCar = vbCrLf
        col = 1
        fil = fil + 1       'Pasa a siguiente fila, puede ser que se
                            'haya pasado la cantidad de lneas disponibles
        If fil <= nLin Then     'actualiza lnea actual
            linact = lin(fil)
        Else
            linact = ""
        End If
    Else                       'No est al fin de lnea
        CogCar = Mid$(linact, col, numcar)
        col = col + Len(CogCar)     'se mueve slo hasta lo tomado
    End If
End Function

Public Function CogLinea() As String
'Toma toda la lnea desde la posicin actual hasta el fin de lnea
'y salta a la siguiente lnea
    CogLinea = Mid$(linact, col)     'toma lnea
    'pasa a la siguiente lnea
    col = 1
    fil = fil + 1  'Pasa a siguiente fila, puede ser que se
                   'haya pasado la cantidad de lneas disponibles
    If fil <= nLin Then     'actualiza lnea actual
        linact = lin(fil)
    Else
        linact = ""
    End If
End Function

Public Function VerCarAnt() As String
'echa un vistazo al caracter anterior del contenido
'Si no hay caracter anterior, devuelve cadena vaca
Dim linact As String
    If FinCont Then Exit Function   'Realmente debera devolver el caracter final
    If IniCont Then Exit Function   'No hay caracter anterior
    linact = linact
    If col = 1 Then
        'Est al inicio de una lnea
        VerCarAnt = vbCrLf     'devuelve el salto anterior
    Else
        VerCarAnt = Mid$(linact, col - 1, 1)
    End If
End Function

Public Function CapBlancos() As Boolean
'Coge los blancos iniciales del archivo de entrada.
'Si no encuentra algun blanco al inicio, devuelve falso
Dim i As Integer
Dim car As String
Dim encontrado
    CapBlancos = False
    car = VerCar() 'lee caracter
    While Not FinCont And (car = " " Or car = vbTab)
        Call CogCar
        CapBlancos = True    'se encontro un blanco al menos
        car = VerCar() 'lee caracter
    Wend
End Function

Public Function Capturar(cap As String) As Boolean
'Coge la cadena dada ignorando los blancos iniciales.
'Si no encuentra la cadena "cap" despues de los blancos, devuelve falso
Dim i As Integer
    Call CapBlancos    'quita blancos iniciales
    If VerCar(Len(cap)) = cap Then
        Call CogCar(Len(cap))
        Capturar = True
    End If
End Function

Public Function CogNumero() As Single
'Coge una cifra numerica del contenido actual
'desde la posicion donde se encuentra el archivo
Dim temp As String
Dim car As String
Dim signo As String
    CogNumero = 0 'no hay numero
    Call CapBlancos      'quita blancos iniciales
    If VerCar = ("-") Then signo = CogCar Else signo = ""
    temp = signo
    car = VerCar
    If car = "" Then Exit Function
    If Not car Like "#" And car <> "." Then 'primer caracter no valido
        Exit Function   'no es numero
    End If
    temp = temp & CogCar      'acumula
    'busca hasta encontar fin de identificador
    While VerCar() <> ""
        car = VerCar()
        If car Like "#" Or car = "." Then
            Call CogCar           'toma el caracter
            temp = temp & car  'acumula
        Else
            CogNumero = val(temp)    'copia el numero
            Exit Function
        End If
    Wend
    'se llego al final del archivo
    CogNumero = val(temp) 'copia hasta el final
End Function

Public Function CogCadena() As String
'Coge una constante de tipo cadena (entre apstrofos o comillas) desde
'el contenido actual. Debe verificarse antes de llamar a esta funcin
'que se tiene una cadena.
Dim temp As String
Dim car As String
    temp = ""
    car = CogCar()  'toma primer caracter
    If car = "'" Then   'cadena entre apstrofos
        While Not FinCont    'busca hasta encontar fin de identificador
            If VerCar() = "'" Then
                Call CogCar        'toma el caracter final
                CogCadena = Replace(temp, "\n", vbCrLf) 'devuelve cadena
                Exit Function
            Else
                temp = temp & CogCar     'toma el caracter
            End If
        Wend
    ElseIf car = """" Then   'cadena entre comillas
        While Not FinCont    'busca hasta encontar fin de identificador
            If VerCar() = """" Then
                Call CogCar        'toma el caracter final
                CogCadena = Replace(temp, "\n", vbCrLf) 'devuelve cadena
                Exit Function
            Else
                temp = temp & CogCar     'toma el caracter
            End If
        Wend
    Else    'No es caracter de cadena
        Exit Function
    End If
    'se llego al final del contenido
    msjError = "No se encontro fin de cadena"
End Function

Public Function VerIdentificador() As String
'devuelve una palabra correspondiente a un identificador
'empieza a buscar desde el principio
Dim pos As TPosCont
    pos = LeePosContAct 'guarda posicin
    VerIdentificador = CogIdentificador()
    FijPosContAct pos
End Function

Public Function CogIdentificador() As String
'Coge una palabra correspondiente a un identificador
'desde la posicion donde se encuentra el archivo
Dim temp As String
Dim car As String
    Call CapBlancos      'quita blancos iniciales
    temp = ""
    car = VerCar()
    If FinCont Then Exit Function   'Fin de contenido
    If Not (car Like CAR_VAL_IIDEN) Then   'primer caracter valido
        Exit Function   'no es identificador
    End If
    temp = temp & CogCar()     'acumula
    'busca hasta encontar fin de identificador
    Do While VerCar() Like CAR_VAL_IDEN
        temp = temp + CogCar()  'acumula
        If Right$(temp, 1) = "$" Then Exit Do   'delimitador de identificador
    Loop
    'se llego al final del archivo
    CogIdentificador = temp 'copia hasta el final
End Function

Public Function CogeElemento() As String
'Toma un elemento sintctico del contenido actual. El elemento puede ser un
'identificador, cadena o smbolo. Los elementos se separan por uno o ms caracteres
'blancos. Por ejemplo, la cadena:
' casa 1  nueva
'Tiene 3 elementos: "casa", "1" y "nueva".
'Las frases de varias palabras se deben encerrar entre apstrofos para
'ser consideradas como un solo elemento
Dim tmp As String
    CapBlancos
    If VerCar = "'" Or VerCar = """" Then   'Inicio de cadena
        CogeElemento = CogCadena
        'puede salir con mensaje de error
'No se toma identificadores porque esta funcin se usa tambin para leer
'rutas de archivos y si se toamran identificadores no se tomara la ruta.
'    ElseIf VerCar Like CAR_VAL_IIDEN Then   'Identificador normal
'        CogeElemento = CogIdentificador
    Else                'smbolo, se busca hasta blanco
        Do While Not FinLin     'un salto de lnea es un delimitador
            tmp = tmp & CogCar
            If EsBlanco(VerCar) Then Exit Do
        Loop
        CogeElemento = tmp  'devuelve lo extraido
    End If
End Function


'*************************************************************************************
Sub IniEntorno()
'Inicializa el procesamiento de la unidad Lexico - Sintctico
    nvariables = 0
    CrearVariableNum "result", 0
    i_result = 1    'actualiza ndice de variable
    CrearVariableNum "timeout", 10
    i_timeout = 2    'actualiza ndice de variable
    CrearVariableCad "$0"
    i_0 = 3          'actualiza ndice de variable
    CrearVariableCad "$1"
    i_1 = 4          'actualiza ndice de variable
    CrearVariableCad "$2"
    i_2 = 5          'actualiza ndice de variable
    CrearVariableCad "$3"
    i_3 = 6          'actualiza ndice de variable
    CrearVariableCad "$4"
    i_4 = 7          'actualiza ndice de variable
    CrearVariableCad "$5"
    i_5 = 8          'actualiza ndice de variable
    CrearVariableCad "$6"
    i_6 = 9          'actualiza ndice de variable
    CrearVariableCad "$7"
    i_7 = 10          'actualiza ndice de variable
    CrearVariableCad "$8"
    i_8 = 11          'actualiza ndice de variable
    CrearVariableCad "$9"
    i_9 = 12          'actualiza ndice de variable
    Ejec = True         'Inicia con ejecucin
End Sub

Sub CrearVariableNum(nombre As String, _
                  Optional valor As Single = 0)
'Crea una nueva variable numrica
    nvariables = nvariables + 1
'    ReDim Preserve variables(nvariables)
    variables(nvariables).nomb = UCase(nombre)
    variables(nvariables).tipo = TIP_NUM
    variables(nvariables).valor = valor
End Sub

Function CrearVariableCad(nombre As String, _
                  Optional valor As String = "") As Integer
'Crea una nueva variable de cadena. Devuelve el ndice
    nvariables = nvariables + 1
'    ReDim Preserve variables(nvariables)
    variables(nvariables).nomb = UCase(nombre)
    variables(nvariables).tipo = TIP_CAD
    variables(nvariables).valor = valor
    CrearVariableCad = nvariables
End Function

Public Function ExisteVariable(nombre As String) As Integer
'Verifica si una variable existe y devuelve su indice. Si no existe
'devuelve cero.
Dim i As Integer
Dim tmp As String
    tmp = UCase(nombre)
    For i = 1 To nvariables
        If variables(i).nomb = tmp Then
            ExisteVariable = i: Exit Function
        End If
    Next
End Function

Public Sub FijaValorVar(n As Integer, valor As String)
'Escribe el valor en una variable.
    variables(n).valor = valor
End Sub

Public Sub AgreValorVar(n As Integer, valor As String)
'Agrega una cadena al valor de una variable
    variables(n).valor = variables(n).valor & valor
End Sub

Public Function LeeValorVar(n As Integer) As String
'Lee el valor en una variable.
    LeeValorVar = variables(n).valor
End Function

Public Function ValorVariable(nombre As String) As String
'Lee el valor de una variable. Si no existe devuelve cadena vaca
Dim i As Integer
Dim tmp As String
    tmp = UCase(nombre)
    For i = 1 To nvariables
        If variables(i).nomb = tmp Then
            ValorVariable = variables(i).valor
            Exit Function
        End If
    Next
End Function

Public Function EsFuncion(iden As String) As Boolean
'Devuelve VERDADERO si el identificador que sigue es una funcin.
'Devuelve siempre el identificador siguiente en "iden" an mayscula.
Dim i As Integer
    EsFuncion = False
    iden = UCase(CogIdentificador())
    If iden = "" Then Exit Function
    If iden = "ENT" Or _
      iden = "VAL" Or _
      iden = "ASC" Or _
      iden = "FRC" Or _
      iden = "RDN" Or _
      iden = "ABS" Or _
      iden = "SEN" Or _
      iden = "COS" Or _
      iden = "TAN" Or _
      iden = "EXP" Or _
      iden = "LN" Or _
      iden = "CHR" Or _
      iden = "LON" Or _
      iden = "LONL" Or _
      iden = "MYS" Or _
      iden = "MNS" Or _
      iden = "RPLA" Or _
      iden = "DIVS" Or _
      iden = "SUBS" Or _
      iden = "FILT" Then  'funciones estandar
           EsFuncion = True
           Exit Function
    End If
End Function

Friend Function CogFuncion(iden As String) As Texpre
'Toma la funcin "iden" del contenido actual.
Dim arg As Texpre, arg2 As Texpre, arg3 As Texpre
Dim txt As String
Dim x As Single
Dim a() As String
    If CogCar <> "(" Then
        msjError = "Se esperaba '(' en definicin de funcin: " & iden
        Exit Function   'Sale
    End If
    arg = CogExpresion(0)   'Toma argumento
    txt = arg.val      'valor de cadena
    x = val(txt)   'valor de nmero
    CogFuncion.cat = CAT_OP_FUNCION     'Se trata de una funcin
    Select Case iden
    'Funciones matemticas
    Case "ENT": CogFuncion.tip = TIP_NUM: CogFuncion.val = Int(x)
    Case "VAL": CogFuncion.tip = TIP_NUM: CogFuncion.val = val(x)
    Case "ASC": CogFuncion.tip = TIP_NUM: CogFuncion.val = Asc(txt)
    Case "FRC": CogFuncion.tip = TIP_NUM: CogFuncion.val = x - Int(x)
    Case "RDN": CogFuncion.tip = TIP_NUM: CogFuncion.val = Rnd(x)
    Case "ABS": CogFuncion.tip = TIP_NUM: CogFuncion.val = Abs(x)
    Case "EXP": CogFuncion.tip = TIP_NUM: CogFuncion.val = exp(x)
    Case "LN": CogFuncion.tip = TIP_NUM: CogFuncion.val = Log(x)
    Case "SEN": CogFuncion.tip = TIP_NUM: CogFuncion.val = Sin(x)
    Case "COS": CogFuncion.tip = TIP_NUM: CogFuncion.val = Cos(x)
    Case "TAN": CogFuncion.tip = TIP_NUM: CogFuncion.val = Tan(x)
    'Funciones de cadena
    Case "CHR": CogFuncion.tip = TIP_CAD: CogFuncion.val = Chr(x)
    Case "LON": CogFuncion.tip = TIP_NUM: CogFuncion.val = Len(txt)
    Case "LONL" 'Nmero de lneas
        CogFuncion.tip = TIP_NUM
        CogFuncion.val = UBound(Split(txt, vbCrLf)) + 1
    Case "MYS": CogFuncion.tip = TIP_CAD: CogFuncion.val = UCase(txt)
    Case "MNS": CogFuncion.tip = TIP_CAD: CogFuncion.val = LCase(txt)
    Case "RPLA" 'Reemplazar una cadena
        CogFuncion.tip = TIP_CAD
        If Not Capturar(",") Then
            msjError = "Se esperaba ',' en rpla()": Exit Function
        End If
        arg2 = CogExpresion(0)   'toma segundo parmetro
        If Capturar(",") Then   'hay
            arg3 = CogExpresion(0)  'toma tercer parmetro
            CogFuncion.val = Replace(txt, arg2.val, arg3.val)
        Else    'No hay tecer parmetro, se asume cadena nula
            CogFuncion.val = Replace(txt, arg2.val, "")
        End If
    Case "DIVS" 'Divide una cadena en las variables $1, $2, $3, .. $9
        CogFuncion.tip = TIP_CAD
        'Ve si hay segundo parmetro
        If Capturar(",") Then   'hay
            arg2 = CogExpresion(0)  'toma separador
            a = Split(txt, arg2.val)    'separa
            CogFuncion.val = UBound(a) + 1   'devuelve nmero de elementos
        Else    'No hay segundo parmetro, separa por blancos
            txt = Replace(txt, vbTab, " ")  'considera tabulaciones
            While InStr(txt, "  ") <> 0     'quita espacios mltiples
                txt = Replace(txt, "  ", " ")
            Wend
            txt = Trim(txt)     'quita espacios
            a = Split(txt, " ")    'separa
            CogFuncion.val = UBound(a) + 1  'devuelve nmero de elementos
        End If
        'Se actualiza variables hasta $9
        If Ejec Then    'slo si hay ejecucin
            'Un poco ineficiente
            If UBound(a) >= 0 Then variables(i_1).valor = a(0)
            If UBound(a) >= 1 Then variables(i_2).valor = a(1)
            If UBound(a) >= 2 Then variables(i_3).valor = a(2)
            If UBound(a) >= 3 Then variables(i_4).valor = a(3)
            If UBound(a) >= 4 Then variables(i_5).valor = a(4)
            If UBound(a) >= 5 Then variables(i_6).valor = a(5)
            If UBound(a) >= 6 Then variables(i_7).valor = a(6)
            If UBound(a) >= 7 Then variables(i_8).valor = a(7)
            If UBound(a) >= 8 Then variables(i_9).valor = a(8)
        End If
    Case "SUBS"
        CogFuncion.tip = TIP_CAD   'Sub-string
        If Not Capturar(",") Then
            msjError = "Se esperaba ',' en flt()": Exit Function
        End If
        arg2 = CogExpresion(0)   'toma segundo parmetro
        If Capturar(",") Then
            arg3 = CogExpresion(0)    'toma tercer parmetro
        Else    'No hay tercer parmetro
            'msjError = "Se esperaba ',' en flt()": Exit Function
        End If
        If arg3.txt = "" Then
            CogFuncion.val = Mid$(txt, val(arg2.val))
        Else
            CogFuncion.val = Mid$(txt, val(arg2.val), (arg3.val))
        End If
    Case "FILT"
        CogFuncion.tip = TIP_CAD   'Filtro de lneas
        If Not Capturar(",") Then
            msjError = "Se esperaba ',' en flt()": Exit Function
        End If
        arg2 = CogExpresion(0)   'toma segundo parmetro
        'If arg2.tip <> TIP_NUM Then
        a = Split(txt, vbCrLf)
        a = Filter(a, arg2.val, True)
        CogFuncion.val = Join(a, vbCrLf)
    Case Else
        msjError = "Funcin desconocida"
        Exit Function
    End Select
    CogFuncion.txt = iden & "(" & arg.txt & ")"
    If Not Capturar(")") Then
        msjError = "Se esperaba ')'": Exit Function
    End If
End Function

Public Function cogOperador() As String
'coge un operador en la posicin del contenido actual. Si no encuentra
'devuelve cadena vaca y no modifica la cadena
Dim tmp As String
Dim pos As TPosCont
    Call CapBlancos         'quita blancos iniciales
    If VerCar() Like "[~&|!><=^*/\%+-]" Then  'operador de un caracter
        pos = LeePosContAct     'guarda posicin por si acaso
        tmp = CogCar()
        Select Case tmp 'completa con operador de ms caracteres
        Case "+"
            If VerCar() = "+" Then Call CogCar: tmp = "++"
            If VerCar() = "=" Then Call CogCar: tmp = "+="
        Case "-"
            If VerCar() = "-" Then Call CogCar: tmp = "--"
            If VerCar() = "=" Then Call CogCar: tmp = "-="
        Case "*"
            If VerCar() = "=" Then Call CogCar: tmp = "*="
        Case "/"
            If VerCar() = "/" Then Call FijPosContAct(pos): Exit Function   'es comentario
            If VerCar() = "=" Then Call CogCar: tmp = "/="
        Case "="
            If VerCar() = "=" Then Call CogCar: tmp = "=="
            If VerCar() = "<" Then Call CogCar: tmp = "=<"        'operador "menor"
            If VerCar() = ">" Then Call CogCar: tmp = "=>"        'operador "mayor"
        Case ">"
            If VerCar() = "=" Then Call CogCar: tmp = ">="
            If VerCar() = ">" Then Call CogCar: tmp = ">>"
            If VerCar() = "+" Then Call CogCar: tmp = ">+"
            If VerCar() = "-" Then Call CogCar: tmp = ">-"
        Case "<"
            If VerCar() = "=" Then Call CogCar: tmp = "<="
            If VerCar() = ">" Then Call CogCar: tmp = "<>"
            If VerCar() = "<" Then Call CogCar: tmp = "<<"
        Case "|"
            If VerCar() = "|" Then Call CogCar: tmp = "||"        'OR
            If VerCar() = "!" Then Call CogCar: tmp = "|!"        'XOR
        Case "~"                            'operador LIKE
            tmp = "~"     '
        Case "&"
            If VerCar() = "&" Then Call CogCar: tmp = "&&"         'AND
        End Select
        cogOperador = tmp
    End If
End Function

Function jerOp(oper As String) As Integer
'Devuelve la jerarqua de un operador
'ver documentacin tcnica
    Select Case oper
    Case ">>", "<<", ">+", ">-": jerOp = 1: Exit Function
    Case "=": jerOp = 2: Exit Function
    Case "&&", "||", "!", "|!": jerOp = 3: Exit Function
    Case "==", "<>", ">", ">=", "<", "<=", "~": jerOp = 4: Exit Function
    Case "+", "-", "|", "&": jerOp = 5: Exit Function
    Case "*", "/", "\", "%": jerOp = 6: Exit Function
    Case "=<", "=>": jerOp = 7: Exit Function
    Case "^", "++", "--", "+=", "-=", "*=", "/=": jerOp = 8: Exit Function
    Case Else: jerOp = 0: Exit Function
    End Select
End Function

Friend Function CogOperando() As Texpre
'Coge un operando en la posicin actual del contenido
Dim c As String
Dim tmp As String
Dim pos As Integer
Dim exp As Texpre
    Call CapBlancos     'quita blancos iniciales
    c = UCase(VerCar())
    If c Like "[0-9-]" Then
        tmp = CogNumero()
        CogOperando.val = tmp
        CogOperando.txt = tmp
        CogOperando.tip = TIP_NUM
        CogOperando.cat = CAT_OP_CONST_NUM
    ElseIf c = """" Or c = "'" Then     'Constante cadena
        tmp = CogCadena()
        CogOperando.val = tmp
        'pone comillas para diferenciar de caso en que no hay operador
        CogOperando.txt = """" & tmp & """"
        CogOperando.tip = TIP_CAD
        CogOperando.cat = CAT_OP_CONST_CAD
    ElseIf c = "(" Then
        Call CogCar           'coge parntesis
        exp = CogExpresion(0)
        CogOperando = exp
        If VerCar() = ")" Then
            CogOperando.txt = "(" & exp.txt & CogCar()
            Exit Function
        Else
            Exit Function       'error
        End If
    ElseIf c Like CAR_VAL_IIDEN Then 'Es identificador
        If EsFuncion(tmp) Then  'Toma identificador y ve si es funcin
            CogOperando = CogFuncion(tmp)  'Procesa funcin
            Exit Function     'Sale con "msjError" actualizado
        End If
        'debe ser una variable
        CogOperando.txt = tmp
        CogOperando.cat = CAT_OP_VARIABLE
        CogOperando.tip = TIP_NUM   'se asume numrica
        CogOperando.val = ValorVariable(tmp)
    Else
        Exit Function   'no devuelve nada
    End If
End Function

Friend Function CogExpresion(jerar As Integer, Optional NoAsig As Boolean = False) As Texpre
'Toma una expresin completa, en la posicin actual del contenido.
'Las expresiones completas pueden incluir asgnaciones.
'Para evitar que se ejecuten asiganciones (como puede ser dentro de un IF), se debe
'activar la bandera "NoAisg". En este caso los operadores "=", se convierten a "=="
Dim Op1 As Texpre, Op2 As Texpre
Dim opr As String, opr2 As String
Dim jerOpr As Integer, jerOpr2 As Integer
Dim tmp1 As TPosCont, tmp2 As TPosCont
    Call CapBlancos     'quita blancos iniciales
    Op1 = CogOperando()  'error
    If msjError <> "" Then Exit Function
    If Op1.txt = "" Then
        Exit Function
    End If
    opr = cogOperador()
    If NoAsig And opr = "=" Then opr = "=="
    If opr = "" Then
        CogExpresion = Op1
        Exit Function
    End If
    jerOpr = jerOp(opr)     'Hay operador, tomar su jerarqua
    '-------------------------- Delimitada por jerarqua? ---------------------
    If jerOpr <= jerar Then  'es menor que la que sigue, expres.
        CogExpresion = Op1  'slo devuelve el nico operando que ley
        Exit Function
    End If
    While opr <> ""
        tmp1 = LeePosContAct    'Guarda por si lo necesita
        Op2 = CogOperando()
        If Op2.txt = "" Then 'error
            msjError = "Se esperaba expresin despus de: " & Op1.txt & opr
            Exit Function
        End If
        tmp2 = LeePosContAct  'Guarda por si lo necesita
        opr2 = cogOperador()
        If NoAsig And opr2 = "=" Then opr2 = "=="
        If opr2 <> "" Then  'Hay otro operador
            jerOpr2 = jerOp(opr2)
            'Delimitado por jerarqua de operador?
            If jerOpr2 <= jerar Then  'sigue uno de menor jerarqua, hay que salir
                FijPosContAct tmp2   'antes de coger el operador
                CogExpresion = Evaluar(Op1, opr, Op2)
                Exit Function
            End If
            If jerOpr2 > jerOpr Then     'y es de mayor jerarqua, retrocede
                FijPosContAct tmp1        'retrocede
                Op2 = CogExpresion(jerOpr)     'evalua primero
                opr2 = cogOperador()    'actualiza el siguiente operador
                If NoAsig And opr2 = "=" Then opr2 = "=="
            End If
        End If
        
        Op1 = Evaluar(Op1, opr, Op2) 'evalua resultado
        If msjError <> "" Then Exit Function
        'expres.txt = expres.txt & opr & Op2.txt
        opr = opr2: jerOpr = jerOp(opr)     'actualiza operador anterior
    Wend
    CogExpresion = Op1
    CogExpresion.cat = CAT_OP_EXPRESION
End Function

Friend Function Evaluar(Op1 As Texpre, opr As String, Op2 As Texpre) As Texpre
'Devuelve el resultado y tipo de una operacin
Dim nar As Integer
Dim tmp As String
Dim posi_cod As Long    'posicin de inicio de cdigo de expresin
Dim i As Long
Dim expr As Texpre
    Evaluar.cat = CAT_OP_EXPRESION      'ahora es expresin por defecto
    Select Case opr
    Case ""     'Sin operador. Y se supone sin Op2
        'no hay nada que hacer, ya est en la pila
        Evaluar = Op1
    Case "="    'Asignacin
        If Ejec Then    'Slo cuando hay ejecucin
            If Op1.cat = CAT_OP_VARIABLE Then   'Asignacin a una variable
                Evaluar.val = Op2.val
                Evaluar.tip = Op2.tip
                '!!!!!!!!!! Asignacin
                i = ExisteVariable(Op1.txt)
                If i <> 0 Then  'existe
                    variables(i).tipo = Op2.tip
                    variables(i).valor = Op2.val
                Else    'Es variable nueva
                    Select Case Op2.tip
                    Case TIP_NUM: Call CrearVariableNum(Op1.txt, val(Op2.val))
                    Case TIP_CAD: Call CrearVariableCad(Op1.txt, Op2.val)
                    End Select
                End If
            Else
                msjError = "Slo se puede asignar valor a una variable"
            End If
        End If
    Case "+"
        Evaluar.val = val(Op1.val) + val(Op2.val)
        Evaluar.tip = TIP_NUM
    Case "-"
        Evaluar.val = val(Op1.val) - val(Op2.val)
        Evaluar.tip = TIP_NUM
    Case "*"
        Evaluar.val = val(Op1.val) * val(Op2.val)
        Evaluar.tip = TIP_NUM
    Case "/"
        If val(Op2.val) = 0 Then
            msjError = "No se puede dividir por cero."
        Else    'error
            Evaluar.val = val(Op1.val) / val(Op2.val)
            Evaluar.tip = TIP_NUM
        End If
    Case "\"
        If val(Op2.val) = 0 Then
            msjError = "No se puede dividir por cero."
        Else    'error
            Evaluar.val = val(Op1.val) \ val(Op2.val)
            Evaluar.tip = TIP_NUM
        End If
    Case "%"
        If val(Op2.val) = 0 Then
            msjError = "No se puede dividir por cero."
        Else    'error
            Evaluar.val = val(Op1.val) Mod val(Op2.val)
            Evaluar.tip = TIP_NUM
        End If
    Case "^"
        If val(Op2.val) = 0 And val(Op2.val) = 0 Then
            msjError = "No se puede Evaluar 0^0"
        Else    'error
            Evaluar.val = val(Op1.val) ^ val(Op2.val)
            Evaluar.tip = TIP_NUM
        End If
    Case "++"       'mono-operando, slo Op1
        Op1.val = val(Op1.val) + 1  'incrementa
        Evaluar.val = Op1.val
        Evaluar.tip = TIP_NUM
    Case "--"       'mono-operando
        Op1.val = val(Op1.val) - 1  'decrementa
        Evaluar.val = Op1.val
        Evaluar.tip = TIP_NUM
    'operadores de comparacin
    Case "=="
        If Op1.val = Op2.val Then
            Evaluar.val = 1
        Else    'error
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case "<>"
        If Op1.val <> Op2.val Then
            Evaluar.val = 1
        Else    'error
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case ">"
        If Op1.val > Op2.val Then
            Evaluar.val = 1
        Else    'error
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case "<"
        If Op1.val < Op2.val Then
            Evaluar.val = 1
        Else    'error
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case ">="
        If Op1.val >= Op2.val Then
            Evaluar.val = 1
        Else    'error
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case "<="
        If Op1.val <= Op2.val Then
            Evaluar.val = 1
        Else    'error
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case "|"    'concatenacin de cadenas
        Evaluar.val = Op1.val & Op2.val
        Evaluar.tip = TIP_CAD
    Case "~"    'comparacin de cadenas
        If (Op1.val Like Op2.val) Then
            Evaluar.val = 1
        Else    'no cuadra
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case "&&"   'And lgico
        If (val(Op1.val) = 1 And val(Op2.val) = 1) Then
            Evaluar.val = 1
        Else    'no cuadra
            Evaluar.val = 0
        End If
        Evaluar.tip = TIP_NUM
    Case "||"
        If (val(Op1.val) = 0 And val(Op2.val) = 0) Then
            Evaluar.val = 0
        Else    'no cuadra
            Evaluar.val = 1
        End If
        Evaluar.tip = TIP_NUM
    Case "!"
        If val(Op1.val) = 1 Then
            Evaluar.val = 0
        Else    'no cuadra
            Evaluar.val = 1
        End If
        Evaluar.tip = TIP_NUM
    Case Else
        msjError = "No se reconoce operador: '" & opr & "' "
        Exit Function
    End Select
    'Completa campos de evaluar
    Evaluar.txt = Op1.txt & opr & Op2.txt   'texto de la expresin
    Evaluar.uop = opr   'ltima operacin ejecutada
End Function

