Attribute VB_Name = "ModEdit"
'Declaraciones y funciones necesarias para implementar el editor.
Option Explicit

'Ambitos del alcance para bsquedas
Public Const AMB_TODO = 0      'Todo el texto
Public Const AMB_SELE = 1      'Slo la seleccin

'Direcciones de desplazamiento para "DesplazaCursor()"
Public Const DIR_NUL = 0
Public Const DIR_DER = 1   'Hacia la derecha
Public Const DIR_IZQ = 2   'Hacia la izquierda
Public Const DIR_ARR = 3   'Hacia arriba
Public Const DIR_ABA = 4   'Hacia abajo
Public Const DIR_PARR = 5   'Pagina arriba
Public Const DIR_PABA = 6   'Pagina abajo
Public Const DIR_INI = 7   'Inicio de lneas
Public Const DIR_FIN = 8   'Fin de lneas
Public Const DIR_HOM = 9   'Inicio de texto
Public Const DIR_END = 10   'Fin de texto
Public Const DIR_DERPAL = 11   'Direccin a la derecha por palabra
Public Const DIR_IZQPAL = 12  'Direccin a la izquierda por palabra
Public Const DIR_ARRPAR = 13  'Hacia arriba por prrafo
Public Const DIR_ABAPAR = 14  'Hacia abajo por prrafo

Public Declare Function lstrcpy Lib "kernel32" (ByVal lpString1 As Any, ByVal lpString2 As Any) As Long
Public Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" ( _
        ByVal hdc As Long, lpMetrics As TEXTMETRIC) As Long
  
' Estructura TEXTMETRIC
Public Type TEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
End Type

Public Declare Function ClientToScreen Lib "user32.dll" ( _
     ByVal hWnd As Long, ByRef lpPoint As POINTAPI) As Long
Public Declare Function ScreenToClient Lib "user32.dll" ( _
     ByVal hWnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOZORDER = &H4
Public Const SWP_NOREDRAW = &H8
Public Const SWP_NOACTIVATE = &H10
Public Const SWP_FRAMECHANGED = &H20
Public Const SWP_SHOWWINDOW = &H40
Public Const SWP_HIDEWINDOW = &H80
Public Const SWP_NOCOPYBITS = &H100
Public Const SWP_NOOWNERZORDER = &H200
Public Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Public Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
Public Const HWND_TOP = 0
Public Const HWND_BOTTOM = 1
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2

Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Type SIZE
    cx As Long
    cy As Long
End Type

Type POINTAPI
   X As Long
   Y As Long
End Type

'Posicin en texto. Coordenadas de texto
Type Tpostex
    xt As Integer
    yt As Long
End Type

'Descripcin de segmentos
Type TDesSeg
    'txt As String   'No guarda un campo de tipo texto para no ocupar mucho espacio
    col As Long     'color de identificador
    tam As Integer  'tamao de segmento. Se guarda tamao en lugar de posicion porque
                    'es ms fcil desplazar. Se usa Integer para economizar espacio
    tip As Integer  'tipo de segmento
End Type

'Tipos de segmentos
Public Const TSEG_DES = 0      'Segmento desconocido
Public Const TSEG_NOR = 1      'Segmento normal
Public Const TSEG_COM = 2      'Segmento comentario
Public Const TSEG_CAD = 3      'Segmento cadena
Public Const TSEG_PRS = 4      'Segmento palabra reservada
Public Const TSEG_PRS2 = 5     'Segmento palabra reservada 2
Public Const TSEG_FUN = 6      'Segmento funcin

'Descriptor de lnea. Se usa para coloreado de sintaxis
Type TdesLin
    tip   As Long       'tipo de lnea
    seg() As TDesSeg    'Vector de descripcin de segmentos
End Type

'Tipos de lnea para TdesLin
Public Const TLIN_DES = 0      'Lnea desconocida, no analizado an
Public Const TLIN_NOR = 1      'Lnea de texto normal (1 solo segmento y color)
Public Const TLIN_MIX = 2      'Lnea con segmentos mixtos
Public Const TLIN_COM = 3      'Lnea de comentario (sin delimitador)
Public Const TLIN_CAD = 4      'Lnea de cadena (sin delimitador)

'Tipo de accin para dehacer
Type Tundo
    acc As Integer  'accin realizada
    pos As Tpostex  'posicin donde se ejecut la accin
    cad As String   'cadena afectada
End Type

'Tipos de acciones, con su accin opuesta
Public Const TU_INS = 1
Public Const TU_ELI = -1
Public Const TU_INSn = 2    'Insertar modo normal
Public Const TU_ELIn = -2   'Eliminar modo normal
Public Const TU_SCOL = 3    'Pasa a modo columna
Public Const TU_SNOR = -3    'Pasa a modo normal

'Estilos de lapiz
Public Const PS_SOLID = 0
Public Const PS_DASH = 1
Public Const PS_DOT = 2
Public Const PS_DASHDOT = 3
Public Const PS_DASHDOTDOT = 4
Public Const PS_NULL = 5
Public Const PS_INSIDEFRAME = 6

Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
Private Const COLOR_3DDKSHADOW = 21     'Color Sombra oscura de los elementos tridimensionales
Private Const COLOR_3DLIGHT = 22        'Color de la cara de los elementos tridimensionales
Private Const COLOR_BTNFACE = 15        'El mismo color que el anterior pero de los botones
Private Const COLOR_BTNHIGHLIGHT = 20   'Color brillante de los elementos tridimensionales
Private Const COLOR_BTNSHADOW = 16      'Color Sombra de los elementos tridimensionales
Private Const COLOR_ACTIVEBORDER = 10   'Color del borde activo
Private Const COLOR_ACTIVECAPTION = 2   'Color de la barra de titulo
Private Const COLOR_BACKGROUND = 1      'Color del escritorio
Private Const COLOR_BTNTEXT = 18        'Color del texto en los botones
Private Const COLOR_CAPTIONTEXT = 9     'Color del texto en las etiquetas
Private Const COLOR_GRADIENTACTIVECAPTION = 27 'Color del lado izquierdo de la barra de titulo cuando esta activo.
Private Const COLOR_GRADIENTINACTIVECAPTION = 28 'Color del lado izquierdo de la barra de titulo cuando esta inactivo. Estas ultimas 2 son nada mas para NT 5.0 y Windows 98, si ven la barra superior del formulario vern un degradado, de un color a otro, bueno ambas variables toman el color del lado izquierdo el primero es cuando esta activo y el segundo cuando esta inactivo.
Private Const COLOR_GRAYTEXT = 17       'Color del texto cuando esta desactivado
Private Const COLOR_HIGHLIGHT = 13      'Color de los tems seleccionados de un control.
Private Const COLOR_HIGHLIGHTTEXT = 14  'Color del texto cuando es seleccionado de un control
Private Const COLOR_INACTIVEBORDER = 11 'Color del borde inactivo
Private Const COLOR_INACTIVECAPTION = 3 'Color del caption inactivo
Private Const COLOR_INACTIVECAPTIONTEXT = 19 'Color del texto inactivo
Private Const COLOR_INFOBK = 24         'Color del fondo de los cuadritos ToolTip
Private Const COLOR_INFOTEXT = 23       'Color del texto de los cuadritos ToolTip
Private Const COLOR_MENU = 4            'Color del fondo del men
Private Const COLOR_MENUTEXT = 4        'Color del texto del men
Private Const COLOR_SCROLLBAR = 0       'Color del scroll bar
Private Const COLOR_WINDOW = 5          'Color del fondo de window (formulario)
Private Const COLOR_WINDOWFRAME = 6     'Color del frame de window (formulario)
Private Const COLOR_WINDOWTEXT = 8      'Color del texto de window (formulario)

'Fin de declaraciones

'*****************************************************************************
'********************* Funciones generales para el editor ********************
Function LeftButton() As Boolean
'Indica si est pulsdo el botn Izquierdo
    LeftButton = (GetAsyncKeyState(vbKeyLButton) And &H8000)
End Function

Function RightButton() As Boolean
'Indica si est pulsdo el botn Derecho
    RightButton = (GetAsyncKeyState(vbKeyRButton) And &H8000)
End Function

Public Sub InsertarCad(lin As String, pos As Integer, cad As String)
'Inserta una cadena a la lnea indicada
    If pos > Len(lin) + 1 Then Exit Sub
    lin = Left$(lin, pos - 1) & cad & Mid$(lin, pos)
End Sub

Public Function EliminarCad(lin As String, pos As Integer, Optional tam As Integer = -1000)
'Elimina caracteres de la lnea indicada. Devuelve la cadena eliminada
    If pos > Len(lin) Then Exit Function
    If pos < 1 Then Exit Function
    If tam = -1000 Then     'elimina hasta el final
        EliminarCad = Mid$(lin, pos)    'toma cadena
        lin = Left$(lin, pos - 1)
    Else
        EliminarCad = Mid$(lin, pos, tam)    'toma cadena
        lin = Left$(lin, pos - 1) & Mid$(lin, pos + tam)
    End If
End Function

Private Sub IntercPostex(p1 As Tpostex, p2 As Tpostex)
'Intercambia los puntos p1 y p2
Dim p As Tpostex
    p = p1
    p1 = p2
    p2 = p
End Sub

Public Function MenorPos(p1 As Tpostex, p2 As Tpostex) As Boolean
'Compara dos posiciones del texto para ver si la primera est antes
    If p1.yt < p2.yt Then
        'No hay ms que comparar, est antes
        MenorPos = True
        Exit Function
    ElseIf p1.yt > p2.yt Then
        'No hay ms que comparar, est despus
        MenorPos = False
        Exit Function
    Else
        'Estn en la misma lnea
        If p1.xt < p2.xt Then MenorPos = True Else MenorPos = False
    End If
End Function

Public Function MayorPos(p1 As Tpostex, p2 As Tpostex) As Boolean
'Compara dos posiciones del texto para ver si la primera est despus
    If p1.yt > p2.yt Then
        'No hay ms que comparar, est despus
        MayorPos = True
        Exit Function
    ElseIf p1.yt < p2.yt Then
        'No hay ms que comparar, est antes
        MayorPos = False
        Exit Function
    Else
        'Estn en la misma lnea
        If p1.xt > p2.xt Then MayorPos = True Else MayorPos = False
    End If
End Function

