Attribute VB_Name = "InterpProces"
'Procesamiento de comandos. Se han incluido varios de los comandos del lenguage
'TTL de las macros del cliente TeraTerm

Option Explicit
Const TESPERA = 100  'Timeout inicial en dcimas de segundos
Public DetEjec As Boolean       'Bandera para detener la ejecucin
Private Timeout As Integer

Public Sub EjecutarMacEdi(Optional MostrarErr As Boolean = True)
'Ejecuta la macro almacenda en el editor.
'Por defecto, muestra los mensajes de error en pantalla.
'Actualiza el encabezado de la ventana principal.
    msjError = ""
    Ejecutando = True   'Marca bandera
    DetEjec = False
    Call frmMain.IniEjecMacro(False)
    c.IniEntorno
    c.CreaContenido frmMain.edMac.Text   'Crea contexto
    c.FijaValorVar 2, TESPERA / 10      'Valor inicial
    Call Procesar
    Ejecutando = False  'Marca bandera
    'Verifica como se ha detenido la macro
    If DetEjec Then
        Call frmMain.FinEjecMacro("Macro detenida")
    Else
        Call frmMain.FinEjecMacro
    End If
    'puede devolver error
    If msjError <> "" Then  'escribe log de errores
        CreaArchivo "error.log", c.fil & vbCrLf & c.col & vbCrLf & msjError
        If MostrarErr Then MsgBox msjError, vbExclamation
    End If
End Sub

Public Sub EjecutarMacArc(Optional MostrarErr As Boolean = True, _
                          Optional MostrarBarra As Boolean = False)
'Ejecuta el archivo de comandos. Si encuentra error, genera el
'mensaje y la ubicacin en el archivo "error.log".
'Por defecto, muestra los mensajes de error en pantalla.
'Actualiza el encabezado de la ventana principal.
    msjError = ""
    If Dir(archivoCom) = "" Then
        msjError = "No se Encuentra archivo de comando: " & archivoCom
        If MostrarErr Then MsgBox msjError, vbExclamation
        Exit Sub
    End If
    Ejecutando = True   'Marca bandera
    DetEjec = False
    Call frmMain.IniEjecMacro(MostrarBarra)
    c.IniEntorno
    c.CreaContenidoArc archivoCom       'Abre archivo
    c.FijaValorVar 2, TESPERA / 10      'Valor inicial
    Call Procesar
    Ejecutando = False  'Marca bandera
    'Verifica como se ha detenido la macro
    If DetEjec Then
        Call frmMain.FinEjecMacro("Macro detenida")
    Else
        Call frmMain.FinEjecMacro
    End If
    'puede devolver error
    If msjError <> "" Then  'escribe log de errores
        CreaArchivo "error.log", c.fil & vbCrLf & c.col & vbCrLf & msjError
        If MostrarErr Then MsgBox msjError, vbExclamation
    End If
End Sub

Public Function Procesar() As String
'Procesa el archivo de comandos. Usa la sintaxis TTL del TeraTerm
'Devuelve el delimitador que termian el procesamiento. Si termina porque ya
'no hay contenido, devuelve cadena vaca.
Dim lin As String
Dim lintmp As String
Dim com As String
Dim par As String       'parmetro
Dim par2 As String      'segundo parmetro
Dim n As Integer, i As Integer
Dim pos As TPosCont
Dim exp As Texpre
    On Error GoTo err_proc:
    Do While Not c.FinCont And Not DetEjec
        c.CapBlancos
        If c.VerCar(2) = CAD_COM_LIN Then
            Call c.CogLinea         'toma comentario
        ElseIf c.VerCar = ";" Then
            c.CogCar        'delimitador de instruccin
        ElseIf c.FinLin Then
            Call c.CogLinea 'delimitador de instruccin
        Else    'Debe ser un identificador
            Timeout = c.LeeValorVar(c.i_timeout) * 10   'actualiza
            pos = c.LeePosContAct
            com = UCase(Trim(c.CogIdentificador))
            Select Case com
            Case "CAPTURE" 'captura la salida en una variable
                exp = c.CogExpresion(0)    'coge handle
                If exp.cat <> CAT_OP_VARIABLE Then
                    msjError = "Se esperaba variable en sentencia CAPTURE": Exit Function
                End If
                If c.Ejec Then
                    'n = FreeFile    'asigna handle ??????????
                    i = c.ExisteVariable(exp.txt)
                    If i <> 0 Then  'Ya existe
                        c.FijaValorVar i, ""
                    Else    'se crea variable
                        i = c.CrearVariableCad(exp.txt)
                    End If
                    nCaptura = i    'Guarda la variable donde se capturar
                End If
            Case "ENDCAPTURE"   'finaliza la captura
                If c.Ejec Then nCaptura = 0    'Desactiva la captura de datos
            Case "WAIT"
                'par = c.CogeElemento() 'coge comando
                par = c.CogExpresion(0).val    'coge parmetro
                If c.Ejec Then  'Ejecuta
                    Call EsperaCad(par, 0)
                    If msjError <> "" Then Exit Function 'sale con error
                End If
            Case "SENDLN"
                'par = c.CogeElemento() 'coge comando
                par = c.CogExpresion(0).val    'coge parmetro
                If c.Ejec Then  'Ejecuta
                    Call EnviaEspera(par)
                    If msjError <> "" Then Exit Function 'sale con error
                End If
            Case "PAUSE"
                n = val(c.CogExpresion(0).val)
                If c.Ejec Then  'Ejecuta
                    Call Espera(n * 100)
                    If msjError <> "" Then Exit Function 'sale con error
                End If
            Case "CONNECT"
                par = c.CogeElemento() 'coge parmetro
                If c.Ejec Then  'Ejecuta
                    frmMain.ConnectToHost par, 23
                    frmMain.Show
                    If msjError <> "" Then Exit Function 'sale con error
                End If
            Case "DISCONNECT"
                If c.Ejec Then
                    Call frmMain.mnuDisconnect_Click
                    If msjError <> "" Then Exit Function 'sale con error
                End If
            Case "FILECLOSE" 'Cierra un archivo
                exp = c.CogExpresion(0)    'coge handle
                If exp.cat <> CAT_OP_VARIABLE Then
                    msjError = "Se esperaba variable en sentencia FILECLOSE": Exit Function
                End If
                If c.Ejec Then
                    i = c.ExisteVariable(exp.txt)   'busca variable
                    If i = 0 Then  'No existe
                        msjError = "No existe variable: " & exp.txt: Exit Function
                    End If
                    n = c.LeeValorVar(i)
                    Close #n    'cierra archivo
                End If
            Case "FILEOPEN" 'Abre un archivo
                exp = c.CogExpresion(0)    'coge handle
                If exp.cat <> CAT_OP_VARIABLE Then
                    msjError = "Se esperaba variable en sentencia FILEOPEN": Exit Function
                End If
                If c.Ejec Then
                    n = FreeFile    'asigna handle
                    i = c.ExisteVariable(exp.txt)
                    If i <> 0 Then  'Ya existe
                        c.FijaValorVar i, CStr(n)
                    Else    'se crea variable
                        Call c.CrearVariableNum(exp.txt, CStr(n))
                    End If
                End If
                par = c.CogExpresion(0).val    'coge nombre
                'Abre archivo
                If c.Ejec Then Open par For Output As #n
            Case "FILEWRITE" 'Escribe en archivo
                exp = c.CogExpresion(0)    'coge handle
                If exp.cat <> CAT_OP_VARIABLE Then
                    msjError = "Se esperaba variable en sentencia FILECLOSE": Exit Function
                End If
                If c.Ejec Then
                    i = c.ExisteVariable(exp.txt)   'busca variable
                    If i = 0 Then  'No existe
                        msjError = "No existe variable: " & exp.txt: Exit Function
                    End If
                    n = c.LeeValorVar(i)    'lee handle
                End If
                par = c.CogExpresion(0).val    'coge lnea
                If c.Ejec Then Print #n, par    'escribe
            Case "LOGOPEN"  'Abre un archivo para registro
                par = c.CogeElemento() 'coge parmetro
                If c.Ejec Then AbrirLog par
            Case "LOGWRITE"  'Escribe en el registro
                par = c.CogeElemento() 'coge parmetro
                If c.Ejec Then Put #nLog, , par & vbCrLf
            Case "LOGCLOSE" 'Cierra registro
                If c.Ejec Then CerrarLog
            Case "LOGPAUSE" 'pausa registro
                If c.Ejec Then PausarLog = True
            Case "LOGSTART" 'reinicia registro
                If c.Ejec Then PausarLog = False
            Case "END"      'Termina el aplicativo
                If c.Ejec Then
                    CerrarLog       'Cierra registro
                    frmMain.mnuDisconnect_Click
                    End
                End If
            Case "STOP"      'Termina la ejecucin de la macro
                If c.Ejec Then
                    Procesar = com  'sale con "STOP" para indicar que debe terminar
                    Exit Do     'sale
                End If
            Case "MESSAGEBOX"
                par = c.CogExpresion(0).val    'coge parmetro
                If msjError <> "" Then Exit Function
                par2 = c.CogLinea()    'Toma ttulo, si hay
                If c.Ejec Then      'ejecuta
                    If par2 <> "" Then MsgBox par, , par2 Else MsgBox par
                End If
            Case "IF"   'condicional
                'toma expresin, evitando las asignaciones (=)
                c.FijaValorVar 1, c.CogExpresion(0, True).val
                If msjError <> "" Then Exit Function
                'forma completa del IF
                If UCase(c.VerIdentificador) <> "THEN" Then
                    msjError = "Se esperaba 'THEN' en sentencia 'IF'": Exit Function
                End If
                c.CogIdentificador  'toma el THEN
                If Not c.Ejec Then  '----procesamiento sin ejecucin
                    par = Procesar()     'toma la parte THEN
                    If par = "" Then
                        msjError = "Inesperado fin de archivo. Se esperaba fin de sentencia 'IF'": Exit Function
                    ElseIf par = "ENDIF" Then
                        'trmino normal
                    ElseIf par = "ELSE" Then
                        par2 = Procesar()     'toma la parte ELSE
                        If par2 = "ENDIF" Then 'trmino normal
                        Else
                            msjError = "Inesperado fin de archivo. Se esperaba ENDIF de sentencia 'IF'": Exit Function
                        End If
                    End If
                Else                '----procesamiento con ejecucin
                    n = c.LeeValorVar(1)    'lee resultado de expresin
                    If n = 0 Then c.Ejec = False Else c.Ejec = True
                    par = Procesar()     'toma la parte THEN
                    If par = "" Then
                        msjError = "Inesperado fin de archivo. Se esperaba fin de sentencia 'IF'": Exit Function
                    ElseIf par = "ENDIF" Then
                        'trmino normal
                    ElseIf par = "ELSE" Then
                        If n = 0 Then c.Ejec = True Else c.Ejec = False
                        par2 = Procesar()     'toma la parte ELSE
                        If par2 = "ENDIF" Then 'trmino normal
                        Else
                            msjError = "Inesperado fin de archivo. Se esperaba ENDIF de sentencia 'IF'": Exit Function
                        End If
                    ElseIf par = "STOP" Then
                        Exit Do 'Se debe terminae la ejecucin
                    End If
                    c.Ejec = True   'mantiene Ejec en TRUE
                End If
            Case "ELSE", "ENDIF"    'delimitador
                Procesar = com
                Exit Function    'sale porque se encontr un delimitador
            Case "EDIT" 'Abre un archivo
                par = c.CogExpresion(0).val    'coge parmetro
                If msjError <> "" Then Exit Function
                If c.Ejec Then
                    frmEditRem.EditaArchivo par
                    frmEditRem.Show
                End If
            Case "DETECT_PROMPT" 'COnfigura la lnea actula como el prompt
                Call frmMain.mnTerDetPr_Click
            Case Else
                'Puede ser una asignacin
                If com <> "" Then    'Es una expresin
                    c.FijPosContAct pos 'retrocede
                    'actualiza "result"
                    par = c.CogExpresion(0).val
                    c.FijaValorVar c.i_result, par
                    If msjError <> "" Then Exit Function
'                    lintmp = c.CogLinea
'                    If lintmp <> "" Then   'Algo no se proces
'                        msjError = "Error en expresin: '" & lintmp & "'"
'                        Exit Function
'                    End If
                Else
                    msjError = "Comando desconocido: '" & com & "'"
                    Exit Function
                End If
            End Select
'            DoEvents
        End If
    Loop
    On Error GoTo 0
    Exit Function
err_proc:
    msjError = Err.Description  'devuelve mensaje
    On Error GoTo 0
End Function

Private Sub Espera(n10mil As Integer)
'Espera la cantidad de "decadas de milisegundos" indicados
Dim tic As Integer
    tic = 0
    While tic < n10mil And Not DetEjec
        DoEvents
        Sleep 10
        tic = tic + 1
    Wend
End Sub

Public Sub EnviaEspera(com As String)
'Enva verificando que haya coneccin. Si no hay conexin espera
'Si hay error, actualiza la bandera "msjError"
Dim tic As Integer
    tic = 0
    While frmMain.Telnet.State <> sckConnected And tic < Timeout And Not DetEjec
        DoEvents
        Sleep 100
        tic = tic + 1
    Wend
    If tic >= Timeout Then
        msjError = "Tiempo de espera de conexin, excedido"
        Exit Sub
    End If
    If DetEjec Then
        msjError = "Ejecucin detenida."
        Exit Sub
    End If
    'Logr la conexin o ya estaba conectado
    frmMain.Telnet.SendData com & Chr(13)
'Debug.Print "enviado: " & com
End Sub

Public Function EsperaCad(com As String, lin0 As Long) As Integer
'Espera a que se reciba una cadena especfica. Se le debe indicar
'un nmero de lnea desde donde buscar. Devuelve el nmero de lnea
'donde encontr.
Dim tic As Integer
Dim nLin As Long
Dim LinFin As String    'Lnea final
    tic = 0
    Do While tic < Timeout And Not DetEjec
        DoEvents
        Sleep 100
        If ultLinea = com Then  've ltima lnea
            ultLinea = ""   'limpia para siguiente bsqueda
            Exit Do
        End If
        tic = tic + 1
    Loop
    If tic >= Timeout Then
        msjError = "Tiempo de espera excedido, para cadena '" & com & "'"
        Exit Function
    End If
    If DetEjec Then
        msjError = "Ejecucin detenida."
        Exit Function
    End If
    'LLeg la cadena esperada.
'Debug.Print "cadena: " & com & " encontrada en " & tic
End Function
