VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPanel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   Clase para la implementacin de un Panel dentro de un formulario.
'Por ahora se he definido solo para que sea un Panel lateral, pero
'podra ampliarse para ser superior o inferior.
'Implementa la funcionalidad de un panel lateral usando un PictureBox.
'Requiere que se implemente el Panel creando un PictureBox con alineamiento
'a la izquierda.
'Una vez creada la clase ya no se debera acceder directamente a las
'propiedades del PictureBox, para dimensionamiento y visibilidad, sino
'que se deben usar las propiedades de la clase.
'El objeto contenedor debe estar tambin con el modo de escala en
'pixels.
'Se requiere adems que se cree un pictureBox adicional de color negro
'para visualizar la barra de desplazamiento.
'                        Creado por Tito Hinostroza    16/05/2011
'                        Modificado por Tito Hinostroza   09/12/2011
'En el formulario contenedor debe iniciarse el Panel con:
'    Set panel = New cPanel      'Crea panel lateral
'    Call panel.Inic(Me, picPanel, picDimen, 100, "PANEL")
'
'Para evitar conflictos con el manejo del puntero de ratn, se debe
'definir OBLIGADAMENTE que los controles que se incluyan en el Picture
'usado como panel (incluyendo el mismo Picture), deben tener fijado la
'propiedad MousePointer a un valor definido <> Default.
'
'Tambin, si se quiere manejar apropiadamente el enfoque, se debe incluir
'una llamada al mtodo: ValidarEnfoque(), en los evento "GotFocus" y
'"LostFocus" de cada control que se encuentre contenido en el Panel.
'

Option Explicit
'--------------------  constantes ---------------------
Private Const ANC_ZON_DIM = 7   'ancho de la zona de dimensionamiento
Private Const ALT_BAR_TIT = 14  'alto de la barra de titulo
'------------------  propiedades pblicas -------------------
Public titulo As String
Public ConEnfoque As Boolean
Public Event PanelCerrado() 'Indica que se ha solicitado cerrar el panel
Public Event PanelDimens()  'Indica que se ha dimensionado el panel
Public Event TomaEnfoque()  'Indica que el panel ha tomado el enfoque
Public Event DejaEnfoque()  'Indica que el panel ha perdido el enfoque

'------------------  propiedades privadas -------------------
Private frmSal As Form  'formulario padre
Private hdc As Long     'manejador de contexto
Private WithEvents pic As PictureBox   'Referencia al PictureBox
Attribute pic.VB_VarHelpID = -1
Private anchoMin As Long    'Ancho mnimo
Private altoMin As Long     'Ancho mnimo
Private mAncho As Single    'Se usan variables adicionales para guardar
Private mAlto As Single     'el tamao del Pic an cuando est con alineamisnto
'Variables para dimensionamiento
Private xDim As Single, DimenX As Boolean
Private yDim As Single, DimenY As Boolean
Private ret_pt As POINTAPI      'punto POINTAPI para uso temporal
Private picDim As PictureBox
Private picDin As PictureBox
Private BotPulsado As Boolean   'botn pulsado
Private ValidandoEnfoque As Boolean 'bandera
Private SinEventos As Boolean   'Bandera para dehabilitar eventos
'colores
'Private colBar As Long  'color de la barra
Private colBot As Long  'color del botn
Private colBotSom As Long  'color de la sombra botn

'*********************** Propiedades ***********************
Public Property Get Width() As Single
'Ancho virtual del control. Da el ancho con que se muestra
'el control excepto cuando el alineamiento lo impide.
    Width = mAncho
End Property
Public Property Let Width(ByVal vNewValue As Single)
    mAncho = vNewValue
    If mAncho < anchoMin Then mAncho = anchoMin   'ancho mnimo
    'cambia ancho si aplica
    If pic.Align = 3 Or pic.Align = 4 Then
        pic.Width = mAncho
    End If
End Property
Public Property Get Ancho() As Single
'Ancho del control real. Da cero cuando el panel no es visible
'o cuando est alineado arriba o abajo.
    If pic.Align = 1 Or pic.Align = 2 Then Ancho = 0
    If pic.Visible Then Ancho = mAncho Else Ancho = 0
End Property
Public Property Get ScaleWidth() As Single
'Ancho del control sin considerar el borde.
    ScaleWidth = Posit(mAncho - 4)
End Property

'--------------Altura---------------
Public Property Get Height() As Single
'Alto virtual del control. Da el alto con que se muestra
'el control excepto cuando el alineamiento lo impide.
    Height = mAlto
End Property
Public Property Let Height(ByVal vNewValue As Single)
    mAlto = vNewValue
    If mAlto < 3 Then mAlto = 3   'ancho mnimo
    'cambia alto si aplica
    If pic.Align = 1 Or pic.Align = 2 Then
        pic.Height = mAlto
    End If
End Property
Public Property Get Alto() As Single
'Alto del control real. Da cero cuando el panel no es visible
'o cuando est alineado a la derecha o izquierda.
    If pic.Align = 3 Or pic.Align = 4 Then Alto = 0
    If pic.Visible Then Alto = mAlto Else Alto = 0
End Property
Public Property Get ScaleHeight() As Single
'Alto del control sin considerar el borde ni la barra de ttulo.
    ScaleHeight = Posit(mAlto - ALT_BAR_TIT)
End Property

'--------------Visibilidad---------------
Public Property Get Visible() As Boolean
    Visible = pic.Visible
End Property
Public Property Let Visible(ByVal vNewValue As Boolean)
    pic.Visible = vNewValue
End Property
'Alineamiento
Public Property Get Align() As Long
    Align = pic.Align
End Property
Public Property Let Align(ByVal vNewValue As Long)
    pic.Align = vNewValue
    Width = mAncho  'Para actualizar tamao
    Height = mAlto  'Para actualizar tamao
End Property

Private Sub Class_Initialize()
    titulo = "PANEL"
    'colBar = vbActiveTitleBar
    colBot = vbButtonFace
    colBotSom = vbButtonShadow
    BotPulsado = False
    mAncho = 100
    mAlto = 50
    ConEnfoque = False
    ValidandoEnfoque = False
    SinEventos = False
End Sub

Public Sub Inic(frm As Form, pBox As PictureBox, picDim0 As PictureBox, _
                    ancMin As Long, titulo0 As String)
    Set frmSal = frm        'toma referencia al formulario padre
    SinEventos = True   'deshabilita temporalmente
    anchoMin = ancMin   'Lee el anchop mnimo
    titulo = titulo0    'Lee el ttulo
    Set pic = pBox      'Toma el PictreBox Asociado
    pic.ScaleMode = vbPixels    'fija escala de trabajo
    pic.BorderStyle = 0     'sin borde para poder trabajar hasta el borde
    pic.AutoRedraw = True  'para poder manejar el evento Paint()
    hdc = pic.hdc       'toma el manejador
    DimenX = False
    Set picDim = picDim0
    picDim.Visible = False  'lo oculta inicialmente
    Call Refrescar
    pic.Align = 3   'inicialmente alineado a la izquierda
    SinEventos = False  'habilita eventos
End Sub

Public Sub Refrescar()
'Dibuja un panel
Dim r As RECT
Dim x1 As Long, y1 As Long
    x1 = pic.ScaleWidth - ANC_ZON_DIM + 3
    y1 = pic.ScaleHeight \ 2    'punto central
    pic.Cls
    '-------Dibuja lnea vertical
    pic.Line (x1, 0)-(x1, pic.ScaleHeight), vbWhite
    '-------Dibuja barra de ttulo
    If ConEnfoque Then
        pic.Line (0, 0)-(pic.ScaleWidth, ALT_BAR_TIT), vbActiveTitleBar, BF
    Else
        pic.Line (0, 0)-(pic.ScaleWidth, ALT_BAR_TIT), vbInactiveTitleBar, BF
    End If
    pic.ForeColor = vbWhite
    pic.CurrentX = 1
    pic.CurrentY = 0
    pic.Print titulo
    Call DibujarBoton   'Botn de cerrar
End Sub

Private Sub InicDimensHoriz(x0 As Single)
    xDim = x0
    DimenX = True
    'pic.MousePointer = vbCustom
    'UBica el control y lo dimensiona
    picDim.Left = x0
    picDim.Top = pic.Top
    picDim.Height = pic.ScaleHeight
    picDim.Width = 5
    picDim.Visible = True
    'Crea control dinmicamente
    'Set picDin = frmMain.Controls.Add("VB.PictureBox", "picDimen__")
    'picDin.Width = 200
    'picDin.Height = 200
    'picDin.Left = 100
    'picDin.Visible = True
    'picDin.ForeColor = vbGreen
End Sub

Private Sub FinDimensHoriz()
    DimenX = False
    pic.MousePointer = vbDefault
    picDim.Visible = False
    Call Refrescar
    'borra control
    'Set picDin = Nothing
    'frmMain.Controls.Remove "picDimen__"
End Sub

'*********************** Mtodos grficos ***********************
Private Sub DibujarBoton()
    If BotPulsado Then
        Call BotnHundido(pic.ScaleWidth - ALT_BAR_TIT, 0, pic.ScaleWidth - 1, ALT_BAR_TIT - 1)
    Else
        Call BotnSaliente(pic.ScaleWidth - ALT_BAR_TIT, 0, pic.ScaleWidth - 1, ALT_BAR_TIT - 1)
    End If
End Sub

Private Sub BotnSaliente(x1 As Long, y1 As Long, x2 As Long, y2 As Long)
'Dibuja un botn
    'Dibuja fondo. El color del borde no importa a este nivel
    pic.Line (x1, y1)-(x2, y2), colBot, BF
    'Dibuja borde
    pic.Line (x1, y1)-(x1, y2), vbWhite 'barra izquierda
    pic.Line (x1, y1)-(x2, y1), vbWhite 'barra arriba
    pic.Line (x2 - 1, y1)-(x2 - 1, y2), colBotSom   'barra derecha
    pic.Line (x1, y2 - 1)-(x2, y2 - 1), colBotSom   'barra abajo
    'Dibuja marca
    x1 = x1 + 1
    y1 = y1 + 1
    x2 = x2 - 2
    y2 = y2 - 2
    pic.Line (x1, y1)-(x2, y2), vbBlack
    pic.Line (x1, y2)-(x2, y1), vbBlack
End Sub

Private Sub BotnHundido(x1 As Long, y1 As Long, x2 As Long, y2 As Long)
'Dibuja un botn hundido
    'Dibuja fondo. El color del borde no importa a este nivel
    pic.Line (x1, y1)-(x2, y2), colBot, BF
    'Dibuja borde
    'FijaLapiz 0, 1, colBotSom
    pic.Line (x1, y1)-(x1, y2), colBotSom   'barra izquierda
    pic.Line (x1, y1)-(x2, y1), colBotSom   'barra arriba
    pic.Line (x2 - 1, y1)-(x2 - 1, y2), vbWhite 'barra derecha
    pic.Line (x1, y2 - 1)-(x2, y2 - 1), vbWhite 'barra abajo
    'Dibuja marca
    x1 = x1 + 2
    y1 = y1 + 2
    x2 = x2 - 1
    y2 = y2 - 1
    pic.Line (x1, y1)-(x2, y2), vbBlack
    pic.Line (x1, y2)-(x2, y1), vbBlack
End Sub

'*********************** Procesamiento de eventos ***********************
Private Sub pic_Resize()
    If SinEventos Then Exit Sub
    RaiseEvent PanelDimens  'redimensionado
End Sub

Private Sub pic_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
'Procesa el evento MouseUp
    If SinEventos Then Exit Sub
    If DimenX Then
        If Posit(x) >= anchoMin Then
            Me.Width = Posit(x + 5)     'asigna validando
        Else
            Me.Width = anchoMin         'asigna validando
        End If
        Call FinDimensHoriz
        'el evento se disparar al cambiar el tamao
'        RaiseEvent PanelDimens  'redimensionado
    End If
    If BotPulsado Then
        BotPulsado = False
        Call DibujarBoton
        If x > pic.Width - ALT_BAR_TIT And y < ALT_BAR_TIT Then
            RaiseEvent PanelCerrado     'dispara evento
        End If
    End If
End Sub

Private Sub pic_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'Procesa el evento MouseDown
    If SinEventos Then Exit Sub
    If x >= pic.Width - ANC_ZON_DIM And y > ALT_BAR_TIT Then
        Call InicDimensHoriz(x)
    ElseIf x > pic.Width - ALT_BAR_TIT And y < ALT_BAR_TIT Then
        If Not BotPulsado Then
            BotPulsado = True
            Call DibujarBoton
        End If
    End If
End Sub

Private Sub pic_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'Procesa el evento MouseMove
Dim i As Integer
    If SinEventos Then Exit Sub
    If Button = 0 Then
        If x >= pic.Width - ANC_ZON_DIM And y > ALT_BAR_TIT Then
            pic.MousePointer = vbSizeWE
        Else
            pic.MousePointer = vbDefault
        End If
    End If
    If DimenX Then
        If Posit(x) >= anchoMin Then
            picDim.Left = Posit(x) + pic.Left
        Else
            picDim.Left = anchoMin + pic.Left
        End If
    End If
End Sub

Private Sub pic_Paint()
'Respuesta el evento "Paint"
    If SinEventos Then Exit Sub
    'If DimenX Then Exit Sub
    Call Refrescar
End Sub

Private Sub pic_GotFocus()
    If SinEventos Then Exit Sub
    Call ValidarEnfoque 'Ve si hay que disparar evento
End Sub

Private Sub pic_LostFocus()
    If SinEventos Then Exit Sub
    Call ValidarEnfoque 'Ve si hay que disparar evento
End Sub

'******************** Manejo del enfoque ******************
Private Function ContenidoEnPic(ctl As Control) As Boolean
'Indica si un control est contenido en el control PIC
'Se usa tratamiento de errores para evaluar si existe la
'propiedad "Container".
    On Error GoTo ErrCEP
    If ctl.Container Is pic Then
        ContenidoEnPic = True
    Else
        ContenidoEnPic = False
    End If
    On Error GoTo 0
    Exit Function
ErrCEP:
    'El objeto no contiene la propiedad "Container"
    'Asumimos que no puede estar contenido en el "pic"
    ContenidoEnPic = False
    On Error GoTo 0
End Function

Public Function Controles() As Collection
'Devuelve los controles contenidos dentro del panel (PIC)
Dim ctl As Control
    For Each ctl In frmSal.Controls
        If ctl.Container Is pic Then
            Controles.Add ctl
        End If
    Next
End Function

Public Function TieneEnfoque() As Boolean
'Indica si alguno de los controles contenidos en el Panel o el
'mismo PictureBox tiene el enfoque
Dim ctl As Control
    'Verifica el PictureBox
    If frmSal.ActiveControl Is pic Then
        TieneEnfoque = True
        Exit Function
    End If
    'Verifica si alguno de los controles contenidos tiene el enfoque
    For Each ctl In frmSal.Controls
        If ContenidoEnPic(ctl) Then
            'Es un control contenido
            If frmSal.ActiveControl Is ctl Then
                TieneEnfoque = True
                Exit Function
            End If
        End If
    Next
    'Ninguno de los controles tiene el enfoque
    TieneEnfoque = False
End Function

Public Sub SetFocus()
'Fuerza a que el panel tome el enfoque
    If pic.Visible Then pic.SetFocus    'pasa el enfoque al PIC
End Sub

'No hay una forma sencilla de detectar cuando el panel toma o pierde
'el enfoque, porque depende de los controles que contiene. Por ello
'se debe llamar a este Procedimiento para validar si se ha producido
'el cambio de enfoque.
'Se Debera llamar a ValidarEnfoque(), cada vez que un control cualquiera
'del formulario cambia su enfoque, pero bastara con procesar los
'eventos de los controles contenidos en el PictureBox.
Public Sub ValidarEnfoque()
Dim ctl As Control
    If ValidandoEnfoque Then Exit Sub   'Para evitar disparar otra vez el evento
    ValidandoEnfoque = True
    If Me.TieneEnfoque Then 'Tiene el enfoque
        If Not ConEnfoque Then
            'El picture toma el enfoque
            ConEnfoque = True
            RaiseEvent TomaEnfoque  'Dispara evento
            Call Refrescar
        End If
    Else    'No tiene el enfoque
        If ConEnfoque Then
            'El picture pierde el enfoque
            ConEnfoque = False
            RaiseEvent DejaEnfoque  'Dispara evento
            Call Refrescar
        End If
    End If
    ValidandoEnfoque = False
End Sub

