VERSION 5.00
Begin VB.UserControl ctlEdit2 
   Alignable       =   -1  'True
   ClientHeight    =   2085
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3105
   MousePointer    =   1  'Arrow
   ScaleHeight     =   139
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   207
   Begin VB.HScrollBar HScroll1 
      CausesValidation=   0   'False
      Height          =   255
      Left            =   0
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1200
      Width           =   1935
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1215
      Left            =   2160
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin VB.Timer Timer1 
      Interval        =   250
      Left            =   1440
      Top             =   360
   End
   Begin VB.PictureBox pic 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1095
      Left            =   285
      MousePointer    =   1  'Arrow
      OLEDropMode     =   1  'Manual
      ScaleHeight     =   1035
      ScaleWidth      =   1275
      TabIndex        =   0
      Top             =   180
      Width           =   1335
   End
   Begin VB.Label lblEstado1 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   0
      TabIndex        =   6
      Top             =   1680
      Width           =   615
   End
   Begin VB.Label lblEstado2 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   600
      TabIndex        =   5
      Top             =   1665
      Width           =   735
   End
   Begin VB.Label lblEstado3 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1185
      TabIndex        =   4
      Top             =   1680
      Width           =   750
   End
   Begin VB.Label lblEstado4 
      BorderStyle     =   1  'Fixed Single
      Height          =   300
      Left            =   1860
      TabIndex        =   3
      Top             =   1665
      Width           =   735
   End
End
Attribute VB_Name = "ctlEdit2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'       Control EDITOR DE TEXTO con soporte para tabulacin, deshacer, Resaltado
'de Sintaxis y Ayuda Contextual.

'Implementa las principales funciones de un editor de texto plano. Slo
'trabaja con tipos de letra de ancho de caracter constante.
'No utiliza ningn control "TextBox" o "RichTextBox". Esta optimizado en velocidad
'y maneja bien archivos de hasta 100000 lneas.
'
'Las principales propiedades son:
'
'"verNumLin".- Permite mostrar el nmero de lnea activando la propiedad
'"verDesVer".- Permite activar la barra de desplazamiento vertical.
'"verDesHor".- Permite activar la barra de desplazamiento horizontal.
'"verEstado".- Activa la barra de estado.
'"bloqText".- Bloquea el contenido de modificacin. Lo convierte en un visor.
'"TipoSelec".- Define el tipo de seleccin 0=Normal; 1=Por columnas

'En el desarrollo del programa se han considerado dos tipos de coordenadas:
' *Coordenadas del cursor.- Refrentes a la posicin relativa del cursor con respecto
'  a la pantalla. La esquina superior izquierda es siempre la posicin (1,1). Las
'  variables que se refieren a coordenadas del cursor, son de tipo xc, yc. No se
'  suele usar este tipo de coordenadas, salvo en casos especiales.
'
' *Coordenadas del texto.- Referentes a la posicin relativa de un caracter con
'  respecto al texto completo como si estuviera impreso en una hoja suficientemente
'  grande. El texto se ve con las tabulaciones expandidas. La posicin (1,1) es
'  siempre el primer caracter del texto. Las variables que se refieren a coordenadas
'  del texto, son de tipo xt, yt.
'
'Preferentemente se busca trabajar en pixeles.

Option Explicit

Const MAX_ANC_LIN = 32766    'Ancho mximo de lnea en caracteres. < 32767
Const TAM_MAX_UNDO = 1000000 'Tamao mximo de bytes usados en "Deshacer"
Const NAC_MAX_UNDO = 60      'Nmero mximo de acciones "Deshacer"

'Direcciones de ajuste horizontal para posicionar el cursor
Const A_NULO = 0
Const A_IZQ_TAB = 1
Const A_DER_TAB = 2

'Caracteres de desplazamiento por palabra
Const CAR_DESP_PAL = "[a-zA-Z0-9_$'.-]"
Const CAR_IDEN_VALM = "[A-Z0-9_$]"    'caracteres vlidos para identificador (mayscula)

Private Const GMEM_MOVEABLE = 2
Private Const GMEM_DDESHARE = &H2000

Public Event ArchivoSoltado(arc As String)  'Evento para archivo soltado
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event CambiaModo()     'Indica una solicitud de cambio de modo. El editor
                              'lo pide con la tecla ALt-C.
Public Event KeyDown(KeyCode As Integer, Shift As Integer)  'Tecla pulsada
Public Event TeclaEnter(lin As String, Shift As Integer) 'Indica la pulsacin de la tecla <Enter>

Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32.dll" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function OpenClipboard Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long

Const CF_TEXT = 1
Const GHND = &H42

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" ( _
    ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
    ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetTextAlign Lib "gdi32" (ByVal hdc As Long, _
    ByVal wFlags As Long) As Long
  
Const TA_LEFT = 0
Const TA_RIGHT = 2
Const TA_CENTER = 6
Const TA_TOP = 0
Const TA_BOTTOM = 8
Const TA_BASELINE = 24
Public ModEnvDir As Boolean 'Modo de envo directo. Propiedad especialmente creada
                            'para esta aplicacin. Sirve para la interaccin con
                            'la consola de Telnet.
'Variables generales
Public archivo As String    'archivo a cargar con el mtodo "CargarArch"



Public nEspTab As Integer   'nmero de espacios por tabulacin
Public verEstado As Boolean   'Muestra barra de estado del editor
Public verNumLin As Boolean 'Muestra nmero de lnea
Public verDesHor As Boolean 'Muestra barra de desplazamiento horizontal
Public verDesVer As Boolean 'Muestra barra de desplazamiento vertical
Public verFonLin As Boolean 'Ver fondo de lnea activa
Public bloqText As Boolean  'bloquea el texto para modificacin
Private tipSelec As Integer  'tipo de seleccin de texto
Public tipArch As Integer   'tipo de archivo: 0->DOS 1->UNIX
Public menuContext As Menu  'referencia al men contextual del Editor

Private ancNLinP As Integer 'ancho de la columna de nmero de lneas en pixeles
'Variables de colores de texto
Private mColFonEdi As Long  'color de fondo del control de edicin
Private mColFonSel As Long  'color del fondo de la seleccin
Private mColLinAct As Long  'color del fondo de la lnea activa
Private mColTxtNor As Long  'color de texto normal
Private mColTxtSel As Long  'color del texto de la seleccin
Private mColFonNli As Long  'color de fondo para nmero de lnea

Private mColTxtCom As Long  'color de comentarios
Private mColTxtCad As Long  'color de constantes cadenas
Private mColPalRes As Long  'color de palabras Reservadas
Private mColPalRes2 As Long  'color de palabras Reservadas
Private mColTxtFun As Long  'color de palabras Reservadas

Public nLin As Long         'nmero de lneas del texto

Private fil1 As Long        'nmero de fila inicial en el control
Private fil2 As Long        'nmero de fila final en el control
Private nfilFin As Long     'nmero de fila final a mostrar en el control (puede ser nFil o fil2)
Private maxLinVis As Integer  'mximo nmero de lneas visibles (que caben en la ventana)

Private col1 As Integer       'nmero de columna inicial en el control
Private col2 As Integer       'nmero de columna final en el control
Private maxColVis As Integer  'mximo nmero de columnas visibles (que caben en la ventana)
Private maxTamLin As Integer  'ancho mximo de las lneas

Private pintando As Boolean   'bandera usada por el evento "Paint"
Private Redibujar As Boolean  'bandera que indica que se debe redibujar el control
Private msjError As String    'Mensaje de error

'Variables de manejo de la seleccin
Public haysel As Boolean    'Indica si hay un bloque seleccionado
Private sel1 As Tpostex     'Posicin inicial de la seleccin
Private sel2 As Tpostex     'Posicin final de la seleccin
Private sel0 As Tpostex     'Posicin donde se empieza a marcar la seleccin
Private sel1ant As Tpostex  'sel1 anterior
Private sel2ant As Tpostex  'sel2 anterior

'Variables de manejo del cursor
Public curXt As Integer    'nmero de caracter que apunta el cursor en coord. del texto
Public curYt As Long       'nmero de lnea que apunta el cursor en coord. del texto
Private curXd As Integer     'coordenada X de cursor deseada. Se usa para desplazarse por lneas
Private curXt_ant As Integer 'posicin anterior X del cursor con respecto a la ventana
Private curYt_ant As Long    'posicin anterior Y del cursor con respecto a la ventana
Private curBorrado As Boolean   'Para controlar el parpadeo del cursor

Private xt0 As Integer      'coordenada X de cursor inicial. Usado para seleccin con ratn
Private yt0 As Long         'coordenada Y de cursor inicial. Usado para seleccin con ratn
Private curtmp As Integer   'contador para temporizar el parpadeo del cursor
Public linact As String    'lnea actual completa apuntada por el cursor
Private cursorOn As Boolean 'bandera para activar o desactivar el cursor

Public anccarP As Long     'ancho de caracter en pixeles
Public altcarP As Long     'ancho de caracter en pixeles

'Variables para control de pantalla
Const MAX_LIN_EDI = 100000      'Mxima cantidad de lneas que soporta el editor
Const MAX_LIN_COL = 1000        'Mxima cantidad de lneas que se soportan con coloreado de sintaxis
Private linrea() As String      'texto cargado en el editor en lneas
Private lincol() As TdesLin     'Descripcin de colores de Lneas para grficar
Private deslin() As TDesSeg     'Para manejo de descripcin de lnea

Private pulsadoI As Boolean     'bandera de botn Izquierdo pulsado
Private ultBotPul As Integer    'tlimo botn pulsado
Private facdesV  As Single      'factor de desplazamiento

'Variables de los mtodos grficos
Private tR As RECT, tTR As RECT

Private hPen As Long            'lapz nuevo
Private hBrush As Long          'brocha para el PIC
Private hFont As Long           'fuente
Private ret_pt As POINTAPI      'punto POINTAPI para uso temporal

'Variables para manejo de tabulaciones
Private ptabexp() As Integer    'posiciones de inicio de las tabulaciones en el texto expandido
Private ptabrea() As Integer    'posiciones real de las tabulaciones en el texto

'Variable para el control de la opcin DESHACER
Private Undos() As Tundo       'Comandos deshacer
Public nUndo As Integer        'Nmero de acciones en Undos
Private nTxtModif As Integer   'Indice al nUndo que da el texto sin modificar
Private Deshaciendo As Boolean

'Variables para el control de la bsqueda
Private PosBus1 As Tpostex  'Posicin inicial del texto buscado.
Private PosBus2 As Tpostex  'Posicin final del texto buscado.
Private CadBus As String    'Cadena de bsqueda
Private CajBus As Boolean   'Bandera de caja para bsqueda
Private PalCBus As Boolean  'Bandera de palabra completa para bsqueda
Private DirBus As Integer   'Direccin de bsqueda
Private PosEnc As Tpostex   'Posicin del texto encontrado. Usado para bsquedas

'Variables para ayuda contextual
Private fContex As frmEdiCtx2 'Referencia al formaulario de ayuda contextual
Private left0 As Long       'para procesar posicin de  ayuda contextual
Private top0 As Long       'para procesar posicin de  ayuda contextual
Public MostfCtx As Boolean  'bandera que indica que se est abriendo

'*************************************************************************************
'********************************FUNCIONES DE BAJO NIVEL******************************
'*************************************************************************************
Private Function Posit(num As Single) As Single
'Devuelve siempre un nmero positivo o cero. Se declara aqu por comodidad
    If num < 0 Then Posit = 0 Else Posit = num
End Function

Public Property Get TipoSelec() As Integer
    TipoSelec = tipSelec
End Property

Public Sub FinAyudContextual()
'Desactiva el men de ayuda contextual
    Call fContex.FinAyudContextual
End Sub

Public Property Let TipoSelec(ByVal vNewValue As Integer)
    If tipSelec <> vNewValue Then
        If vNewValue = 0 Then  'Pasa a modo normal
            GuarAcc TU_SNOR, LeePosCur(), ""     'para deshacer
        Else                'Pasa a modo por columna
            GuarAcc TU_SCOL, LeePosCur(), ""     'para deshacer
        End If
        tipSelec = vNewValue
    End If
End Property
'------------Lectura de colores--------------
Public Property Get ColFonEdi() As Long: ColFonEdi = mColFonEdi: End Property
Public Property Get ColFonSel() As Long: ColFonSel = mColFonSel: End Property
Public Property Get ColLinAct() As Long: ColLinAct = mColLinAct: End Property
Public Property Get ColTxtNor() As Long: ColTxtNor = mColTxtNor: End Property
Public Property Get ColTxtSel() As Long: ColTxtSel = mColTxtSel: End Property
Public Property Get ColFonNli() As Long: ColFonNli = mColFonNli: End Property

Public Property Get ColTxtCom() As Long: ColTxtCom = mColTxtCom: End Property
Public Property Get ColTxtCad() As Long: ColTxtCad = mColTxtCad: End Property
Public Property Get ColPalRes() As Long: ColPalRes = mColPalRes: End Property
Public Property Get ColPalRes2() As Long: ColPalRes2 = mColPalRes2: End Property
Public Property Get ColTxtFun() As Long: ColTxtFun = mColTxtFun: End Property

'------------Escritura de colores--------------
Public Property Let ColFonEdi(ByVal vNewValue As Long)
    If mColFonEdi <> vNewValue Then
        mColFonEdi = vNewValue  'lee nuevo valor
        pic.BackColor = mColFonEdi  'Actualiza color de fondo
    End If
End Property

Public Property Let ColFonSel(ByVal vNewValue As Long): mColFonSel = vNewValue: End Property
Public Property Let ColLinAct(ByVal vNewValue As Long): mColLinAct = vNewValue: End Property
Public Property Let ColTxtSel(ByVal vNewValue As Long): mColTxtSel = vNewValue: End Property
Public Property Let ColTxtNor(ByVal vNewValue As Long): mColTxtNor = vNewValue: End Property
Public Property Let ColFonNli(ByVal vNewValue As Long): mColFonNli = vNewValue: End Property

Public Property Let ColTxtCom(ByVal vNewValue As Long): mColTxtCom = vNewValue: End Property
Public Property Let ColTxtCad(ByVal vNewValue As Long): mColTxtCad = vNewValue: End Property
Public Property Let ColPalRes(ByVal vNewValue As Long): mColPalRes = vNewValue: End Property
Public Property Let ColPalRes2(ByVal vNewValue As Long): mColPalRes2 = vNewValue: End Property
Public Property Let ColTxtFun(ByVal vNewValue As Long): mColTxtFun = vNewValue: End Property
'------------------------------------------------
Private Function MaxCol1() As Integer
'Devuelve el mximo valor que puede tomar "col1"
    'Debera ser maxTamLin - maxColVis + 1, pero el cursor
    'se puede mover hasta len(linea)+1.
    MaxCol1 = maxTamLin - maxColVis + 2
    If MaxCol1 < 1 Then MaxCol1 = 1 'proteccin
End Function

Private Function CarXY(xt As Integer, ByVal yt As Long) As String
'Devuelve el caracter de la posicin X,Y de la ventana visible.
'Coordenadas del cursor
Dim lin As String
    'Verifica si escapa de la pantalla
    If xt < col1 Or xt > col2 Then CarXY = " ": Exit Function
    If yt < 1 Or yt > nLin Then CarXY = " ": Exit Function
    'toma lnea afectada
    lin = linexp(yt)
    'Verifica si escapa de la lnea mostrada
    If xt > Len(lin) Then CarXY = " ": Exit Function
    'Toma caracter
    CarXY = Mid$(lin, xt, 1)
End Function

Private Function CarPos(p As Tpostex) As String
'Devuelve el caracter actual de una posicin. Coordenadas de texto
Dim lin As String
Dim xt As Integer
    lin = linrea(p.yt)    'lee primera lnea
    xt = PosXTreal(p.xt, p.yt)
    CarPos = Mid$(lin, xt, 1)
End Function

Private Function CarPosAnt(p As Tpostex) As String
'Devuelve el caracter anterior a una posicin. Coordenadas de texto
'Si el caracter es el primero de una lnea, se devuelve cadena vaca
Dim lin As String
Dim xt As Integer
    lin = linrea(p.yt)    'lee primera lnea
    xt = PosXTreal(p.xt, p.yt)
    If xt <= 1 Then Exit Function    'proteccin
    CarPosAnt = Mid$(lin, xt - 1, 1)
End Function

Private Function CarPosSig(p As Tpostex) As String
'Devuelve el caracter siguiente a una posicin. Coordenadas de texto
'Si el caracter es el ltimo de una lnea, se devuelve cadena vaca
Dim lin As String
Dim xt As Integer
    lin = linrea(p.yt)    'lee primera lnea
    xt = PosXTreal(p.xt, p.yt)
    If xt >= Len(lin) + 1 Then Exit Function    'proteccin
    CarPosSig = Mid$(lin, xt + 1, 1)
End Function

Private Function ColXY(xt As Integer, yt As Long) As Long
'Devuelve el color de la posicin X,Y en la ventana visible
'Coordenadas del cursor
Dim lin() As TDesSeg
Dim i As Integer
Dim pos As Integer
Dim txt As String
    'Verifica si escapa de la pantalla
    If xt < col1 Or xt > col2 Then Exit Function
    If yt < 1 Or yt > nLin Then Exit Function
    'Lee o actualiza el vector de descripcin
    If lincol(yt).tip = TLIN_DES Then
        'Auqnue no es trabajo de ColXY() ver el color
        'Pueda que a veces tenga que hacerlo
        txt = linexp(yt)                'lee toda la lnea
        ActualDescColFil txt, lin()
        lincol(yt).tip = TLIN_MIX
        lincol(yt).seg = lin    'copia descripcin de lnea
    Else    'ya tiene descripcin de segmento
        lin = lincol(yt).seg
    End If
    
    'Explora el vector de descripcin
    '-------Busca segmento de inicio "i"-------
    i = 1   'Se asume que empieza en el segmento 1
    pos = 1
    For i = 1 To UBound(lin)
        pos = pos + lin(i).tam
        If pos > xt Then
            'Este es el segmento que contiene al caracter.
            ColXY = lin(i).col  'toma color
            Exit Function
        End If
    Next
    'Est al final de la lnea, o no hay descripcin
    ColXY = vbBlack
End Function

Private Sub BorCursorXY()
'Borra el cursor de la posicin (curXt_ant, curYt_ant), redibujando
'el caracter XY (coordenadas de cursor) en la pantalla.
Dim car As String
Dim hdc As Long
Dim posX As Long, posY As Long
    'Verifica si cae fuera de la pantalla
    If curYt_ant < fil1 Or curYt_ant > fil2 Then Exit Sub
    hdc = pic.hdc
    posX = anccarP * (curXt_ant - col1)    '+ ancNLinP
    posY = altcarP * (curYt_ant - fil1)
    'primero dibuja fondo para borrar las marcas anteriores
    If verFonLin And curYt_ant = curYt Then   'Posicin actual
        FijaRelleno mColLinAct
        FijaLapiz PS_SOLID, 1, mColLinAct
    Else
        FijaRelleno mColFonEdi
        FijaLapiz PS_SOLID, 1, mColFonEdi
    End If
    Rectangle hdc, posX, posY, posX + anccarP, posY + altcarP
    'redibuja caracter
    car = CarXY(curXt_ant, curYt_ant)
    pic.ForeColor = ColXY(curXt_ant, curYt_ant)
    SetTextAlign hdc, TA_LEFT
    TextOut hdc, posX, posY, car, Len(car)
    curBorrado = True   'marca bandera
End Sub

Private Sub DibCursorXY()
'Dibuja el smbolo del cursor en la posicin (curXt, curYt)
'en la pantalla. Actualiza (curXt_ant, curYt_ant)
Dim car As String
Dim hdc As Long
Dim posX As Long, posY As Long
Dim posXfin As Long, posYfin As Long
    posX = anccarP * (curXt - col1)    '+ ancNLinP
    posY = altcarP * (curYt - fil1)
'    posXfin = posX + (anccarP - 1)
    posYfin = posY + (altcarP - 1)
    hdc = pic.hdc
    If tipSelec = 1 Then        'Seleccin por columnas
        
        pic.Line (posX, posY)-(posX + 1, posYfin), vbRed, B
    Else    'Seleccin normal
        
        pic.Line (posX, posY)-(posX + 1, posYfin), mColTxtNor, B
    End If
    curBorrado = False   'marca bandera
    'Actualiza posicin donde se dibuj el cursor
    curXt_ant = curXt
    If curYt_ant <> curYt Then
'Debug.Print "Cambio de lnea. " & Time
        Call DibujaLin(curYt_ant, True) 'refresca anterior
        Call DibujaLinActual
        'dibuja porque se ha ocultado
        If tipSelec = 1 Then        'Seleccin por columnas
            pic.Line (posX, posY)-(posX + 1, posYfin), vbRed, B
        Else    'Seleccin normal
            pic.Line (posX, posY)-(posX + 1, posYfin), mColTxtNor, B
        End If
    End If
    curYt_ant = curYt
End Sub

Public Sub XYCursor(x As Long, y As Long)
'Devuelve coordenadas del cursor en Twips.
    x = anccarP * (curXt - col1 + 1) * Screen.TwipsPerPixelX
    y = altcarP * (curYt - fil1 + 1) * Screen.TwipsPerPixelY
End Sub

Private Sub ActivarCursor()
    cursorOn = True
End Sub

Private Sub DesactivarCursor()
'Desactiva el parpadeo del cursor
    'No lo borra, para no interferir con el mtodo de seleccin
    cursorOn = False
End Sub

Public Sub ApagCursor()
'Apaga el cursor en la posicin actual y lo desactiva para parpadeo.
    Call DesactivarCursor
    Call BorCursorXY
End Sub

Public Sub EncenCursor()
'Fuerza a que el cursor aparezca encendido. Activa el parpadeo si es que
'estuviera desactivado
    ActivarCursor       'activa temporizacin de cursor
    curtmp = 0  'para mantener encendico el cursor por 500mseg
    'borra el cursor de la posicin anterior
    Call BorCursorXY
    'Dibuja en la nueva posicin
    Call DibCursorXY
End Sub

Public Function ParentForm() As Form
'Devuelve el formulario padre. Se usa esta funcin para poder prevenir el acceso
'a "Parent" cuando an no est disponible y de paso dar una referencia ms especfica
'como "Form". Si no hay "Parent" definido an, se devuelve "nothing"
    On Error Resume Next
    Set ParentForm = Parent
    On Error GoTo 0
End Function

Private Sub Timer1_Timer()
Dim f As Form
    'Verifica movimiento del objeto contenedor, para procesar ventana
    'de ayuda contextual.
    Set f = ParentForm  'este es el mejor mtodo de acceso al padre
    If Not (f Is Nothing) Then
        'Verifica si se ha movido el padre
        If f.Left <> left0 Or f.Top <> top0 Then
            If Not (fContex Is Nothing) Then Call fContex.FinAyudContextual
        End If
        left0 = f.Left: top0 = f.Top
        'Verifica si la aplicacin ha perdido el enfoque
        If GetActiveWindow() = 0 Then
            Call fContex.FinAyudContextual
        End If
    End If
    'Temporiza el parpadeo del cursor
    If Not cursorOn Then Exit Sub
    curtmp = curtmp + 1     'Lleva la cuenta de 250 mseg
    If curtmp >= 2 Then
        curtmp = 0      'para iniciar otra cuenta de 2 pasos
        If curBorrado Then DibCursorXY Else BorCursorXY
    End If
End Sub

Private Function CursorFueraPantalla() As Boolean
'Verifica si el cursor se encuentra fuera de la pantalla visible
    If curYt < fil1 Or curYt > fil2 Or curXt < col1 Or curXt > col2 Then
        CursorFueraPantalla = True
    End If
End Function

Private Sub FijaCol1(valor As Integer)
'Fija un nuevo valor para "col1" y actualiza "col2". Slo debera cambiarse
'"col1" desde este procedimiento. Equivale a un desplazamiento horizontal sin
'mover el cursor. 'No redibuja
    'Verificaciones de validez
    If valor < 1 Then valor = 1
    If valor > MaxCol1() Then valor = MaxCol1()
    'Asignacin final
    col1 = valor
    col2 = col1 + maxColVis - 1
End Sub

Private Sub ActualizaNLinFin()
'Recalcula la variable "nFilFin".
'Debera llamarse despus de cualquier cambio a "fil1" o si se
'eliminan o aumentan lineas visibles en pantalla
    'valor normal de nfilFin
    nfilFin = fil2
    'valor real de nfilFin si hay menos lneas
    If nfilFin > nLin Then nfilFin = nLin
    'Proteccin por exceso. Limita hasta donde se mueve la pantalla
    If fil1 > nfilFin Then
        fil1 = nfilFin              'Ajusta pantalla
        If fil1 < 1 Then fil1 = 1   'proteccin por debajo
        'ha habido modificacin de fil1, se debe actualizar fil2
        fil2 = fil1 + maxLinVis - 1
    End If
End Sub

Private Sub FijaFil1(valor As Long)
'Fija un nuevo valor para "fil1" y actualiza "fil2". Slo debera cambiarse
'"fil1" desde este procedimiento Equivale a un desplazamiento vertical sin
'mover el cursor. No redibuja
'Desplaza slo en variables. No redibuja
    'verifica validez de desplazamiento
    If valor < 1 Then valor = 1     'limita por arriba
    If valor > nLin Then valor = nLin 'limita
    'Asignacin final
    fil1 = valor
    fil2 = fil1 + maxLinVis - 1
    Call ActualizaNLinFin    'aqu puede cambiar fil1 y fil2
End Sub

Private Sub FijarSel0()
'Fija el punto base de la seleccin, en el punto actual del cursor
    sel0 = LeePosCur()
    sel1 = sel0         'Seleccin sigue al cursor
    sel2 = sel0         'Seleccin sigue al cursor
    sel1ant = sel0      'actualiza anterior
    sel2ant = sel0      'actualiza anterior
End Sub

Private Function LineaEnSel(yt As Long) As Boolean
'Devuelve Verdadero si la linea "yt" est en el bloque de seleccin
    If haysel And sel1.yt <= yt And yt <= sel2.yt Then
        LineaEnSel = True
    Else
        LineaEnSel = False
    End If
End Function

'*****************************************************************************
'*************** FUNCIONES PARA MANEJO DE LA MATRIZ DE LNEAS ****************
'*****************************************************************************
Public Sub LimpiarLineas()
    nLin = 0
    ReDim linrea(0)
    ReDim lincol(0)
    maxTamLin = 1   'Valor inicial
End Sub

Public Property Get linea(i As Long) As String
'Propiedad para devolver el texto de una lnea
    linea = linrea(i)
End Property

Public Property Get nLinActual() As Long
    nLinActual = curYt
End Property

Public Sub EliminarLineas(pos As Long, nelim As Long)
'Elimina lneas en la matriz de cadenas, desplazando los elementos
Dim i As Long
    'protecciones
    If pos > nLin Then Exit Sub     'a eliminar desde ms alla del texto
    If nelim > nLin Then Exit Sub   'a eliminar ms de lo que hay
    If nelim < 1 Then Exit Sub      'a eliminar negativamente
    'Desplaza elementos
    For i = pos To nLin - nelim
        linrea(i) = linrea(i + nelim)
        lincol(i) = lincol(i + nelim)
    Next
    'Actualiza tamao
    nLin = nLin - nelim
    ReDim Preserve linrea(nLin)
    ReDim Preserve lincol(nLin)
End Sub

Private Sub InsertarLineas(pos As Long, nins As Long)
'Inserta lneas, desplazando los elementos. Las lneas se insertan en blanco.
Dim i As Long
    'protecciones
    If pos > nLin Then Exit Sub
    If nins < 1 Then Exit Sub
    nLin = nLin + nins
    ReDim Preserve linrea(nLin)
    ReDim Preserve lincol(nLin)
    'Desplaza elementos
    For i = nLin To pos + nins Step -1
        linrea(i) = linrea(i - nins)
        lincol(i) = lincol(i - nins)
    Next
End Sub

Public Sub AgregaLinea(lin As String)
'Agrega una lnea al final en el control de texto
Dim tamexp As Integer
    nLin = UBound(linrea) + 1   'actualiza nuevo nmero de lneas
    ReDim Preserve linrea(nLin) 'crea espacio
    ReDim Preserve lincol(nLin) 'crea espacio
    linrea(nLin) = lin      'escribe la nueva lnea
    'actualiza ancho mximo de lnea
    tamexp = Len(LineaFin(lin))
    If tamexp > maxTamLin Then maxTamLin = tamexp
    Call ActualizaNLinFin   'Para dibujar correctamente
    Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
End Sub

Public Sub ReinicColEdi()
'Reinicia todas las lneas para que se evale de nuevo el color
Dim i As Long
    For i = 1 To UBound(lincol)
        lincol(i).tip = TLIN_DES
    Next
End Sub

'*****************************************************************************
'***************** FUNCIONES PARA MANEJO DE LAS TABULACIONES *****************
'*****************************************************************************
Private Function linexp(i As Long) As String
'Devuelve la lnea expandida como es vsible, reemplazando las tabulaciones
    linexp = LineaFin(linrea(i))     'expande los tabs
End Function

Public Function LineaFin(txt As String) As String
'Reemplaza la cadena "txt" a como se debe mostrar (reemplaza tabulaciones)
Dim tmp As String
Dim lin() As String
Dim nesp As Integer
Dim i As Integer
    lin = Split(txt, vbTab)       'corta por tabulacines
    For i = 0 To UBound(lin)
        'completa con espacios
        tmp = tmp & lin(i)           'agrega lnea
        If i < UBound(lin) Then 'si no es el ltimo se agrega
            nesp = nEspTab - (Len(lin(i)) Mod nEspTab)  'de 1 a "nEspTab" espacios
            tmp = tmp & String(nesp, " ")   'completa con espacios
        End If
    Next
    LineaFin = tmp
End Function

Public Function posFinTab(x As Integer) As Integer
'Devuelve la posicin inicial (en caracteres) del siguiente caracter
'que sigue a un caracter de tabulacin ubicado en la posicin x
    posFinTab = nEspTab * ((x - 1) \ nEspTab + 1) + 1
End Function

Private Sub ExplorarTabs(yt As Long)
'Explora la lnea "yt", y actualiza las matrices:
' * ptabexp() con las posiciones de inicio de las tabulaciones en el texto expandido.
' * ptabrea() con las posiciones de las tabulaciones en el texto real
' Los ndices de ptabexp() y ptabrea() empiezan en 1
Dim texp As String      'texto expandido
Dim trea As String      'texto real
Dim lin() As String
Dim nesp As Integer
Dim i As Integer
    lin = Split(linrea(yt), vbTab)             'corta por tabulaciones
    If UBound(lin) = -1 Then
        ReDim ptabexp(0)
        ReDim ptabrea(0)
    Else
        ReDim ptabexp(UBound(lin))
        ReDim ptabrea(UBound(lin))
    End If
    For i = 0 To UBound(lin)
        'completa con espacios
        texp = texp & lin(i)                'actualiza lnea
        trea = trea & lin(i) & " "          'actualiza lnea
        If i < UBound(lin) Then             'si no es el ltimo se agrega
            nesp = nEspTab - (Len(lin(i)) Mod nEspTab)  'de 1 a "nEspTab" espacios
            ptabexp(i + 1) = Len(texp) + 1  'guarda posicin de inicio del tab
            texp = texp & String(nesp, " ") 'completa con espacios
            
            ptabrea(i + 1) = Len(trea)
        End If
    Next
End Sub

Public Function PosXTreal(xt As Integer, yt As Long) As Integer
'Devuelve la posicin horizontal real xt (en la cadena sin expandir)
'para la fila "yt" , caracter "xt" en el texto expandido
Dim i As Integer
Dim posIni As Integer
Dim posfin As Integer
Dim posSigCar As Integer
Dim distab As Integer
    '--------------Verifica si hay tabulaciones---------------
    PosXTreal = xt    'valor por defecto
    ExplorarTabs yt   'lee posiciones de tabulacin
    If UBound(ptabexp) = 0 Then 'Si no hay tabulaciones
        Exit Function   'sale con la misma posicin
    End If
    '----------------------------------------------------------
    'Hay al menos una tabulacin. Verifica en que zona
    'de la cadena cae para buscar su posicin real
    '----------------------------------------------------------
    'Verifica para la primera zona
    If xt < ptabexp(1) Then
        PosXTreal = xt    'Ocupa la misma posicin en la cadena real
        Exit Function
    End If
    'Debe estar en las otras zonas
    For i = 1 To UBound(ptabexp)
        'Toma inicio de zona
        posIni = ptabexp(i)
        'Toma fin de zona
        If i < UBound(ptabexp) Then
            posfin = ptabexp(i + 1)
        Else    'Es el tab final
            posfin = Len(linexp(yt)) + 1
        End If
        posSigCar = posFinTab(posIni)
        'Ver si cae en la zon aprohibida de un "tab" en la cadena expandida
        If xt >= posIni And xt < posSigCar Then
            'Est en la zona de la tabulacin expandida
            If xt = posIni Then
                'El cursor est bien ubicado, se inserta antes
                'de la tabulacin
                PosXTreal = ptabrea(i)
                Exit Function
            Else
                'El cursor est en una posicin prohibida
                'Puede ser que se est insertando en modo columnas
                msjError = "Error de ubicacin de cursor"
                PosXTreal = ptabrea(i)   'por ahora se ajusta a la izquierda
                Exit Function
            End If
        'Verifica si cae en el texto despus del tab
        ElseIf xt >= posSigCar And xt < posfin Then
            distab = xt - posSigCar 'distancia a la tabulacin
            PosXTreal = ptabrea(i) + distab + 1
            Exit Function
        End If
    Next
    'Slo debera debera llegar aqu si est al final
    PosXTreal = Len(linrea(yt)) + 1
End Function

Public Function PosXTexp(xt As Integer, yt As Long) As Integer
'Devuelve la posicin horizontal xt en la cadena expandida
'para la fila "yt" , caracter "xt" en el texto real
Dim a() As String
Dim lin As String
    '--------------Verifica si hay tabulaciones---------------
    PosXTexp = xt    'valor por defecto
    If xt <= 1 Then Exit Function   'No puede ser de otra forma
    lin = Left$(linrea(yt), xt - 1) 'lee parte afectada de la lnea
    'La posicin expandida equivale al largo de la cadena
    'afectada expandida.
    PosXTexp = Len(LineaFin(lin)) + 1
End Function

Public Sub TabToSpaces()
'Convierte tabulaciones a espacios en el editor.
Dim i As Long
    For i = 1 To nLin
        linrea(i) = linexp(i)
    Next
    Call InicDeshacer   'Porque esta accin no se puede deshacer
End Sub

'*****************************************************************************
'****************** FUNCIONES PARA DESPLAZAMIENTO DEL CURSOR *****************
'*****************************************************************************

Private Function curSigPal() As Long
'Devuelve la posicin del cursor "xt" (en coordenadas de texto) de la siguiente
'palabra en la lnea actual
Dim x As Long
    x = curXt
    If x < 1 Then Exit Function
    'Termina la palabra actual
    While x <= Len(linact) And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x + 1
    Wend
    'busca siguiente
    While x <= Len(linact) And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
        x = x + 1
    Wend
    curSigPal = x
End Function

Private Function curIniPal() As Long
'Devuelve la posicin del cursor "xt" (en coordenadas de texto) de la
'anterior palabra en la lnea actual
Dim x As Long
    If curXt <= 1 Then Exit Function
    x = curXt
    'busca fin de palabra
    While x > 1 And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
        x = x - 1
    Wend
    If x = curXt Then   'ya estaba al inicio de palabra
        x = x - 1   'retrocede
        If x = 0 Then curIniPal = x: Exit Function
        'Busca fin de palabra anterior
        While x > 1 And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
            x = x - 1
        Wend
    End If
    'Busca inicio de palabra actual
    While x > 1 And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x - 1
    Wend
    If x = 1 Then curIniPal = 1 Else curIniPal = x + 1
End Function

Private Function curIniPal2() As Long
'Devuelve la posicin del cursor "xt" (en coordenadas de texto) del
'inicio de palabra en la posicin actual del cursor
Dim x As Long
    If curXt < 1 Then Exit Function
    x = curXt
    'busca fin de palabra
    If Mid$(linact, x, 1) Like CAR_DESP_PAL Then
        'ya est en medio de palabra
    Else
        'Hay que buscar el inicio
        If x = 1 Then Exit Function 'es el primero
        x = x - 1   'retrocede
        'Busca fin de palabra anterior
        While x > 1 And Not (Mid$(linact, x, 1) Like CAR_DESP_PAL)
            x = x - 1
        Wend
    End If
    'Busca inicio de palabra actual
    While x > 1 And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x - 1
    Wend
    If x = 1 Then curIniPal2 = 1 Else curIniPal2 = x + 1
End Function

Private Function curFinPal() As Long
'Devuelve la posicin del cursor "xt" del caracter que sigue al
'fin del identificador que se encuentra bajo el cursor
Dim x As Long
    If curXt < 1 Then Exit Function
    x = curXt
    'Busca fin de palabra actual
    While x < Len(linact) + 1 And Mid$(linact, x, 1) Like CAR_DESP_PAL
        x = x + 1
    Wend
    curFinPal = x   'funciona inclusive en el caso lmite
End Function

Private Function InicioParrafo(yt As Long, xt As Integer) As Boolean
'Indica si una lnea est al inicio de un prrafo para un valor de xt
    If Len(linexp(yt)) >= xt And Len(linexp(yt - 1)) < xt Then
        InicioParrafo = True
    Else
        InicioParrafo = False
    End If
End Function

Private Function FinalParrafo(yt As Long, xt As Integer) As Boolean
'Indica si una lnea est al final de un prrafo para un valor de xt
    If yt = nLin Then   'No hay lnea siguiente
        If Len(linexp(yt)) >= xt Then
            FinalParrafo = True
        Else
            FinalParrafo = False
        End If
    Else                'Hay lnea siguiente
        If Len(linexp(yt)) >= xt And Len(linexp(yt + 1)) < xt Then
            FinalParrafo = True
        Else
            FinalParrafo = False
        End If
    End If
End Function

Private Function EntreParrafos(yt As Long, xt As Integer) As Boolean
'Indica si una lnea est entre dos prrafos para un valor de xt
    If Len(linexp(yt)) < xt Then
        EntreParrafos = True
    Else
        EntreParrafos = False
    End If
End Function

Private Function curIniPar() As Long
'Devuelve la posicin del cursor "yT" (en coordenadas del texto) del inicio
'del parrafo en la posicin actual del cursor o del fin del prrafo anterior
Dim y As Long
    If curYt = 1 Then Exit Function
    y = curYt
    'Verifica si est al inicio de un prrafo
    If InicioParrafo(y, curXt) Then
        'Buscar el fin del prrafo anterior
        y = y - 1
        'Busca fin de prrafo anterior
        While y > 1 And Len(linexp(y)) < curXt
            y = y - 1
        Wend
        curIniPar = y
        Exit Function   'sale
    End If
    'Si est entre prrafos se mueve hasta el fin del anterior
    If EntreParrafos(y, curXt) Then
        While y > 1 And Len(linexp(y)) < curXt
            y = y - 1
        Wend
        curIniPar = y
        Exit Function   'sale
    End If
    'Busca inicio de prrafo actual
    While y > 1 And Len(linexp(y)) >= curXt
        y = y - 1
    Wend
    If y = 1 Then        'lleg al inicio
        curIniPar = y
    Else    'encontr lmite
        y = y + 1
        curIniPar = y
    End If
End Function

Private Function curFinPar() As Long
'Devuelve la posicin del cursor "yt" (en coordenadas del texto) del fin
'del parrafo en la posicin actual del cursor o del inicio del prrafo siguiente
Dim y As Long
    If curYt = nLin Then curFinPar = curYt: Exit Function
    y = curYt
    'Verifica si est al final de un prrafo
    If FinalParrafo(y, curXt) Then
        'Buscar el inicio del prrafo siguiente
        y = y + 1
        'Busca fin de prrafo anterior
        While y < nLin And Len(linexp(y)) < curXt
            y = y + 1
        Wend
        curFinPar = y
        Exit Function   'sale
    End If
    'Si est entre prrafos se mueve hasta el inicio del siguiente
    If EntreParrafos(y, curXt) Then
        While y < nLin And Len(linexp(y)) < curXt
            y = y + 1
        Wend
        curFinPar = y
        Exit Function   'sale
    End If
    'Busca fin de prrafo actual
    While y < nLin And Len(linexp(y)) >= curXt
        y = y + 1
    Wend
    If Not FinalParrafo(y, curXt) Then        'al inicio
        y = y - 1
    End If
    curFinPar = y
End Function

Public Property Let Text(ByRef txt As String)
'Actualiza el contenido del CONTROL
Dim a() As String
Dim i As Integer
    'inicia contenido en 0 lneas
    Call LimpiarLineas
    If txt <> "" Then
        'asignar texto
        a = Split(txt, vbCrLf)
        For i = 0 To UBound(a)
            AgregaLinea a(i)
        Next
    End If
    Call ActualizaNLinFin   'actualiza lneas visibles
    Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
    'posicin inicial del cursor
    tCursorA2 maxTamLin, nLin
    Call Dibujar
End Property

Public Property Get Text() As String
'Devuelve el contenido del control
'Devuelve el texto seleccionado.
Dim tip0 As Integer
    tip0 = tipSelec 'guarda tipo de seleccion
    tipSelec = 0    'pone en modo normal para copiar todo
    Text = TextBlo(MinPos, MaxPos)
    tipSelec = tip0 'Restaura tipo de seleccion
End Property

'*****************************************************************************
'******************** FUNCIONES PARA MANEJO DE BLOQUES ***********************
'*****************************************************************************
Private Function LeePosCur() As Tpostex
'Lee la posicin actual de cursor en la variable de posicin pos
    LeePosCur.xt = curXt
    LeePosCur.yt = curYt
End Function

Private Function PosNulo(p As Tpostex) As Boolean
'Indica si una posicin no ha sido iniciada
    PosNulo = (p.xt = 0)
End Function

Private Function MinPos() As Tpostex
'Devuelve la posicin menor del texto en el editor
    If nLin > 0 Then
        MinPos.xt = 1
        MinPos.yt = 1
    End If
End Function

Private Function MaxPos() As Tpostex
'Devuelve la posicin mayor del texto en el editor
    MaxPos.yt = nLin
    If nLin > 0 Then
        MaxPos.xt = Len(linexp(nLin)) + 1
    End If
End Function

Private Function TextPosIni(p1 As Tpostex) As String
'Devuelve la primera lnea del bloque que empieza en la posicin p1.
'Slo debe usarse cuando el bloque tiene ms de una lnea
'Devuelve texto sin expandir
Dim x1r As Integer, y1 As Long
    y1 = p1.yt
    x1r = PosXTreal(p1.xt, y1)
    TextPosIni = Mid$(linrea(y1), x1r)       'copia primera lnea
End Function

Private Function TextPosFin(p2 As Tpostex) As String
'Devuelve la ltima lnea del bloque que termina en la posicin p2.
'Slo debe usarse cuando el bloque tiene ms de una lnea
'Devuelve texto sin expandir
Dim x2r As Integer, y2 As Long
    y2 = p2.yt
    x2r = PosXTreal(p2.xt, y2)
    TextPosFin = Mid$(linrea(y2), 1, x2r - 1)  'copia ltima lnea
End Function

Private Function TextPosLin(p1 As Tpostex, p2 As Tpostex) As String
'Devuelve el texto seleccionado del bloque p1-p2.
'Slo debe usarse cuando el bloque est en una sola lnea.
'Devuelve texto sin expandir
Dim y1 As Long
Dim x1r As Integer, x2r As Integer
    y1 = p1.yt      'igual a p2.yt
    x1r = PosXTreal(p1.xt, y1)
    x2r = PosXTreal(p2.xt, y1)
    TextPosLin = Mid$(linrea(y1), x1r, x2r - x1r)  'copia lnea
End Function

Private Function TextPosCol(yt As Long, xt1 As Integer, xt2 As Integer) As String
'Devuelve el texto intermedio de una lnea en el modo columna
'Para extraer el texto intermedio, se expanden primero las tabulaciones
'y se completan con expacios si la lnea es muy pequea.
'xt1 DEBE SER SIEMPRE menor o igual a xt2
Dim x1 As Integer
Dim x2 As Integer
Dim txt As String
    txt = linexp(yt)    'expande las tabulaciones
    If Len(txt) < xt1 Then   'lnea muy pequea
        TextPosCol = String(xt2 - xt1, " ")  'devuelve espacios
    ElseIf Len(txt) < xt2 - 1 Then 'slo se ve parcialmente
        TextPosCol = Mid$(txt & String(xt2 - 1 - Len(txt), " "), xt1)
    Else    'La lnea es suficientemente grande
        TextPosCol = Mid$(txt, xt1, xt2 - xt1)
    End If
End Function

Private Function TamPosBlo(p1 As Tpostex, p2 As Tpostex) As Long
'Devuelve el tamao de un bloque en bytes. Es eficiente an con bloques grandes
'Toma en cuenta el tipo de seleccin actual
'Para el caso de seleccin por columnas, se considera el texto expandido.
'Para el caso de seleccin normal se da el tamao del texto sin expandir
Dim tam As Long
Dim i As Long
    If UBound(linrea) = 0 Then tam = 0: Exit Function
    If tipSelec = 1 Then        'Seleccin por columnas
        'Para el clculo, se fija un tamao uniforme de seleccin
        tam = Abs(p1.xt - p2.xt) + 2  'caracteres por lnea ms el salto de lnea
        i = (p2.yt - p1.yt + 1)   'nmero de lneas
        TamPosBlo = tam * i - 2        'quita el salto final
        Exit Function
    End If
    'Seleccin por filas
    If p1.yt = p2.yt Then   'Bloque en una sola lnea
        If p1.xt = p2.xt Then tam = 0: Exit Function
        tam = Len(TextPosLin(p1, p2))
    Else                    'Bloque en varias lneas
        tam = Len(TextPosIni(p1))            'tamao primera lnea
        For i = p1.yt + 1 To p2.yt - 1
            tam = tam + 2 + Len(linrea(i))   'considera 2 caracteres del salto
        Next
        tam = tam + 2 + Len(TextPosFin(p2))  'tamao ltima lnea
    End If
    TamPosBlo = tam   'Devuelve
End Function

Private Function BloAMem(tam As Long, p1 As Tpostex, p2 As Tpostex) As Long
'Funcion estrella del programa. Se usa para las opciones del portapapeles y
'para la funcionalidad de "deshacer".
'Hace un volcado rpido de un bloque de texto a Memoria. Puede trabajar
'ficientemente con varios miles de lneas.
'Si hubo error en asignar memoria devuelve 0, de otra forma devuelve el
'manejador del bloque de memoria.
'Actualiza la variable "tam" con el tamao del bloque reservado
Dim nbytes As Long  'Nmero de bytes escritos
Dim f As Long
Dim lpMemory As Long
Dim retval As Long
Dim hData As Long   'Manejador de memoria
Dim cad As String   'Cadena a escribir
Dim xt1 As Integer, xt2 As Integer
Dim xtmp As Integer
    '-----------Copia datos a memoria - Metodo1----------
    'Calcula el tamao total del bloque
    tam = TamPosBlo(p1, p2)
    'Asigna espacio en memoria. Es tam+1 porque se le agregar un NULL a la cadena
    hData = GlobalAlloc(GMEM_MOVEABLE Or GMEM_DDESHARE, tam + 1)
    If hData = 0 Then   'No se pudo encontrar memoria
        BloAMem = 0
        Exit Function
    End If
    'Copiamos la cadena al espacio de memoria reservada
    lpMemory = GlobalLock(hData)    'bloquea mientras copia y obtenemos direccin
    If tipSelec = 1 Then        'Seleccin por columnas
        'Lee coordenadas horizontales
        xt1 = p1.xt: xt2 = p2.xt
        If xt1 > xt2 Then   'Verifica si hay que invertir
            xtmp = xt1: xt1 = xt2: xt2 = xtmp
        End If
        cad = TextPosCol(p1.yt, xt1, xt2) 'Lee parte inicial del bloque
        nbytes = Len(cad)       'tamao sin incluir el NULL final
        retval = lstrcpy(lpMemory, cad)     'Copia incluyendo el NULL final
        lpMemory = lpMemory + nbytes        'apunta al NULL final escrito
        For f = p1.yt + 1 To p2.yt
            cad = vbCrLf & TextPosCol(f, xt1, xt2)
            nbytes = Len(cad)       'tamao sin incluir el NULL final
            retval = lstrcpy(lpMemory, cad) 'Copia incluyendo el NULL final
            lpMemory = lpMemory + nbytes    'apunta al NULL final escrito
        Next
    Else    'Seleccin normal
        If p1.yt = p2.yt Then   'Seleccin de una sola lnea
            'Copia incluyendo el NULL final
            retval = lstrcpy(lpMemory, TextPosLin(p1, p2))
        Else
            'Seleccin de varias lneas
            cad = TextPosIni(p1)        'Lee parte inicial del bloque
            nbytes = Len(cad)           'tamao sin incluir el NULL final
            retval = lstrcpy(lpMemory, cad)     'Copia incluyendo el NULL final
            lpMemory = lpMemory + nbytes        'apunta al NULL final escrito
            For f = p1.yt + 1 To p2.yt - 1
                cad = vbCrLf & linrea(f)
                nbytes = Len(cad)       'tamao sin incluir el NULL final
                retval = lstrcpy(lpMemory, cad) 'Copia incluyendo el NULL final
                lpMemory = lpMemory + nbytes    'apunta al NULL final escrito
            Next
            cad = vbCrLf & TextPosFin(p2)       'Lee parte final del bloque
            retval = lstrcpy(lpMemory, cad)     'Copia incluyendo el NULL final
        End If
    End If
    Call GlobalUnlock(hData)            'desbloquea
    BloAMem = hData     'Devuelve manejador
End Function

Private Property Get TextBlo(p1 As Tpostex, p2 As Tpostex) As String
'Devuelve el texto de un bloque, entre las posiciones p1 y p2, considerando
'el modo de edicin (normal o por columnas).
Dim hData As Long   'Manejador de memoria
Dim lpMemory As Long
Dim nbytes As Long
    'Proteccin
    If p1.xt = p2.xt And p1.yt = p2.yt Then Exit Sub
    'Copia bloque a memoria
    hData = BloAMem(nbytes, p1, p2) 'Copia seleccin a memoria
    If hData = 0 Then
        MsgBox "No se puede obtener seleccin. Error asignando memoria", vbCritical
        Exit Property
    End If
    TextBlo = Space(nbytes + 1)     'crea espacio para contener a la cadena y el NULL
    lpMemory = GlobalLock(hData)    'bloquea mientras copia y obtenemos direccin
    lstrcpy TextBlo, lpMemory        'Copia rpidamente a cadena
    Call GlobalUnlock(hData)        'desbloquea
    TextBlo = Left(TextBlo, Len(TextBlo) - 1)    'Quita NULL final
    GlobalFree hData
    Exit Property

'No se usa el mtodo:
'        For i = .yt To  .yt
'            tmp = tmp & vbCrLf & linrea(i)
'        Next
'Porque es muy lento cuando hay muchas lneas
End Property

Public Property Get TextSel() As String
'Devuelve el texto seleccionado.
    If Not haysel Then Exit Property
    TextSel = TextBlo(sel1, sel2)
End Property

'*****************************************************************************
'******************** FUNCIONES DE POSICIONAMIENTO DE CURSOR *****************
'*****************************************************************************

Private Sub AjustaPantalla()
'Ajusta las coordenadas de la pantalla para que sea visible el cursor
'No modifica nada en el caso que el cursor sea visible.
'Actualiza las variables globales "curXt", "curYt"
    'Ubica horizontal
    If curXt < col1 Then
        FijaCol1 curXt
        curXt = col1
    End If
    If curXt > col2 Then
        FijaCol1 curXt - maxColVis + 1
        curXt = col2
    End If
    'Ubica vertical
    If curYt < fil1 Then
        FijaFil1 curYt
        curYt = fil1
    End If
    If curYt > fil2 Then
        FijaFil1 curYt - maxLinVis + 1   'desplaza
        curYt = fil2    'debe actualizarse tambin
    End If
End Sub

Private Sub FijaCursor(ByVal xt As Integer, ByVal yt As Long, _
            Optional ajus_hor As Integer = A_NULO)
'Fija el cursor en la posicin xt, yt.
'Slo permite poner el cursor en una zona vlida del texto (aunque no sea
'visible en la pantalla actual). Si cae fuera del texto lo ajusta a caer dentro.
'No hace desplazamiento de pantalla.
'Actualiza las variables globales "curXt", "curYt" y "linact"
''"ajus_hor" es el ajuste que se desea realizar, puede ser:
'A_NULO ->     Sin ajuste. Puede aparecer en medio de la zona del tab
'A_IZQ_TAB ->  A izquierda cuando hay tabulacin
'A_DER_TAB ->  A derecha cuando hay tabulacin
Dim i As Integer
Dim posSigCar As Integer
    '-----Verifica si hay lneas en el control
    If nLin = 0 Then    'no hace nada, slo posiciona
        curXt = 1: curYt = 1
        linact = ""
        'Muestra estado
        If verEstado Then
            lblEstado2 = "Fil=" & curYt & " Col=" & curXt
        End If
        Exit Sub
    End If
    '-----valida que caiga en una zona vlida del texto
    'calcula y valida "curYt"
    curYt = yt                     'valor inicial
    If curYt < 1 Then curYt = 1    'valida por abajo
    If curYt > nLin Then curYt = nLin  'valida por arriba
    linact = linexp(curYt)          'actualiza lnea actual
    If Len(linact) > maxTamLin Then
        maxTamLin = Len(linact)     'es la lnea mayor
        Call ActLimitesBarDesp      'actualiza barra
    End If
    'calcula y valida "curXt"
    If CLng(xt) > 32767 Then xt = col1  'proteccin
    curXt = xt                      'valor inicial
    If curXt < 1 Then curXt = 1     'valida por abajo
    If curXt > Len(linact) + 1 Then curXt = Len(linact) + 1 'valida por derecha
    '----Realiza los ajustes si se han pedido.
    If ajus_hor <> A_NULO Then  'Hay que realizar ajustes
        'Verifica si cae en posicin prohibida por haber tabulacin
        ExplorarTabs curYt  'lee posiciones de tabulacin
        For i = 1 To UBound(ptabexp)
            'Verifica si cae en la zona prohibida definida por un "tab"
            posSigCar = posFinTab(ptabexp(i))
            If curXt > ptabexp(i) And curXt < posSigCar Then
                If ajus_hor = A_DER_TAB Then
                    curXt = posSigCar   'actualiza "curXt"
                End If
                If ajus_hor = A_IZQ_TAB Then
                    curXt = ptabexp(i)    'actualiza "curXt"
                End If
            End If
        Next
    End If
    'Muestra estado
    If verEstado Then
        lblEstado2 = "Fil=" & curYt & " Col=" & curXt
    End If
End Sub

Private Sub tCursorA(xt As Integer, yt As Long, Optional ajus_hor As Integer = A_IZQ_TAB)
'Funcin similar a FijaCursor(), pero realiza el desplazamiento de
'la pantalla cuando sea necesario para que el cursor siempre aparezca visible
'Actualiza la bandera "Redibujar", cuando se requiere dibujar toda la pantalla.
    FijaCursor xt, yt, ajus_hor      'mueve el cursor
    'verifica si es necesario refrescar la pantalla
    If CursorFueraPantalla Then
        Call AjustaPantalla
        Redibujar = True    'pide que se redibuje
    End If
End Sub

Private Sub tCursorA2(xt As Integer, yt As Long, Optional ajus_hor As Integer = A_IZQ_TAB)
'Versin de tCursorA() que verifica si el cursor queda en una posicin
'horizontal lmite y encuadra la pantalla para que se vea mejor.
'Actualiza la bandera "Redibujar", cuando se requiere dibujar toda la pantalla.
    FijaCursor xt, yt, ajus_hor
    'Verifica si el cursor cae en una zona no visible de la pantalla
    If CursorFueraPantalla Then
        AjustaPantalla
        'Verifica si qued al final de lnea
        If curXt = col2 Then
            FijaCol1 col1 + 12
            AjustaPantalla   'porque puede que se haya ocultado el cursor
                             'y para actualizar curXt
        End If
        'Verifica si cae al inicio
        If curXt = col1 Then
            FijaCol1 col1 - 12  'Intenta desplazar
            AjustaPantalla   'porque puede que se haya ocultado el cursor
                             'y para actualizar curXt
        End If
        Redibujar = True
    End If
End Sub
                        
Private Sub posCursorA(pos As Tpostex, Optional ajus_hor As Integer = A_IZQ_TAB)
'Versin de tCursorA(), pero acepta una posicin de tipo "Tpostex"
    tCursorA pos.xt, pos.yt, ajus_hor
End Sub

Private Sub posCursorA2(pos As Tpostex, Optional ajus_hor As Integer = A_IZQ_TAB)
'Versin de tCursorA2(), pero acepta una posicin de tipo "Tpostex"
    tCursorA2 pos.xt, pos.yt, ajus_hor
End Sub

'Public Sub CursorText(xt As Integer, yt As Long)
''Funcin pblica para fijar la posicin del cursor
'    Redibujar = False
'    tCursorA2 maxTamLin + 1, nLin, A_IZQ_TAB    'para encuadrar desde arriba
'    Call tCursorA2(xt, yt)
'    curXd = curXt     'actualiza posicin deseada
'    Call LimpSelec(True)      'Limpia seleccin
'    'Marca la posicin del cursor antes de una seleccin
'    Call FijarSel0      'Fija punto base
'    Call EncenCursor    'Enciende para que sea visible en la nueva posicin
'    If Redibujar Then Call Refrescar
'End Sub

Public Sub SelectHasta(xt As Integer, yt As Long)
'Funcin pblica para fijar el fin de una seleccin. Se debe habe definido el inicio
'con CursorText
    tCursorA2 xt, yt
    Call ExtenderSel 'Extiende seleccin
End Sub

'*****************************************************************************
'******************** FUNCIONES DE DIBUJO DEL TEXTO  *****************
'*****************************************************************************

Private Sub LeerXPosSel(x1 As Long, x2 As Long)
'Devuelve las coordenadas horizontales x1 y x2 del bloque de seleccin
'a mostrar en pantalla. Devuelve en de pixeles
    'Calcula posicin horizontal de inicio y fin de bloque
    x1 = (sel1.xt - col1) * anccarP
    If x1 < 0 Then x1 = 0
    If x1 > ScaleWidth Then x1 = ScaleWidth
    x2 = (sel2.xt - col1) * anccarP - 1   'incluye slo el recuadro del caracter no el siguiente
    If x2 < 0 Then x2 = 0
    If x2 > ScaleWidth Then x2 = ScaleWidth
End Sub

Private Sub LeerXCurSel(xc1 As Integer, xc2 As Integer)
'Devuelve las coordenadas horizontales xc1 y xc2 del bloque de seleccin
'a mostrar en pantalla. Devuelve en coordenadas de Cursor.
'xc1 es la posicin del caracter en la lnea donde se inicia la seleccin y
'xc2 es la posicin del caracter en la lnea donde termina la seleccin.
    'Calcula posicin horizontal de inicio y fin de bloque
    xc1 = sel1.xt - col1 + 1
    If xc1 < 1 Then xc1 = 1
    If xc1 > maxColVis Then
        xc1 = maxColVis
    End If
    xc2 = sel2.xt - col1 + 1  'incluye slo el recuadro del caracter no el siguiente
    If xc2 < 1 Then xc2 = 1
    If xc2 > maxColVis Then
        xc2 = maxColVis
    End If
End Sub

Private Sub DibBloFonC(yc As Long, xc1 As Integer, xc2 As Integer, col_fon As Long)
'Dibuja un recuadro relleno con color "col_fon". Las coordenadas son de cursor
Dim xp1 As Long, xp2 As Long
Dim yp As Long
    'Valida parmetros
'    If xc2 < 1 Then Exit Sub
'    If xc1 < maxColVis Then Exit Sub
    If xc1 < 1 Then xc1 = 1
    If xc2 > maxColVis + 1 Then xc2 = maxColVis + 1
    'Convierte a pixeles
    xp1 = (xc1 - 1) * anccarP '+ ancNLinP
    xp2 = (xc2 - 1) * anccarP '+ ancNLinP
    yp = (yc - 1) * altcarP 'actualiza coordenada vertical
    FijaRelleno col_fon
    FijaLapiz PS_SOLID, 1, col_fon
    If xp2 = xp1 Then xp2 = xp2 + 2     'para que sea visible la seleccin de 0 columnas
    Rectangle pic.hdc, xp1, yp, xp2, yp + altcarP
End Sub

Private Sub cierraSegm(lin() As TDesSeg, i As Integer, _
                       pfin As Long, col As Long, tip As Integer)
'Cierra un segmento de texto y actualiza "pfin".
'"n" es el tamao actual de la matriz. El segmento a cerrar llega hasta "i-1"
'"pfin" es la posicin de fin del bloque anterior
Dim n As Integer
    If i > pfin + 1 Then  'hay segmento antes?
        n = UBound(lin) + 1
        ReDim Preserve lin(n)
        lin(n).tam = i - pfin - 1
        pfin = i - 1  'actualiza el limite
        lin(n).col = col    'texto normal
        lin(n).tip = tip    'asigna tipo
    End If
End Sub

Private Sub cierraSegm1(lin() As TDesSeg, i As Integer, _
                        pfin As Long, col As Long, tip As Integer)
'Similar a cierraSegm() pero considera que el segmento llega hasta "i"
Dim n As Integer
    If i > pfin + 1 Then   'hay segmento antes?
        n = UBound(lin) + 1
        ReDim Preserve lin(n)
        lin(n).tam = i - pfin
        pfin = i   'actualiza el limite
        lin(n).col = col    'color de texto
        lin(n).tip = tip    'asigna tipo
    End If
End Sub

Private Function cierraSegmId(lin() As TDesSeg, i As Integer, _
                       pfin As Long, col As Long, tip As Integer, _
                       tmp As String, iden As String, largo As Integer) As Boolean
'Cierra un segmento y crea uno nuevo, basado siempre que se encuentre
'un identificador en la cadena "tmp" a partir de la posicin "i".
    If Mid$(tmp, i, largo) = iden And Not (Mid$(tmp, i + largo, 1) Like CAR_IDEN_VALM) Then
        cierraSegm lin(), i, pfin, col, tip   'cierra anterior
        i = i + largo - 1   'adelanta el ndice, se adelantar 1 en el "for"
        'crea segmento de palabra reservada
        cierraSegm1 lin(), i, pfin, mColPalRes, TSEG_PRS
        
        cierraSegmId = True 'indica que se encontr segmento
    Else
        cierraSegmId = False
    End If
End Function

Private Function cierraSegmId2(lin() As TDesSeg, i As Integer, _
                       pfin As Long, col As Long, tip As Integer, _
                       tmp As String, iden As String, largo As Integer) As Boolean
'Igual a "cierraSegmId", pero para el segundo grupo de palabras reservadas
    If Mid$(tmp, i, largo) = iden And Not (Mid$(tmp, i + largo, 1) Like CAR_IDEN_VALM) Then
        cierraSegm lin(), i, pfin, col, tip   'cierra anterior
        i = i + largo - 1   'adelanta el ndice, se adelantar 1 en el "for"
        'crea segmento de palabra reservada
        cierraSegm1 lin(), i, pfin, mColPalRes2, TSEG_PRS2
        
        cierraSegmId2 = True 'indica que se encontr segmento
    Else
        cierraSegmId2 = False
    End If
End Function

Private Sub AnalizarIdentificador(c As String, tmp As String, _
                        lin() As TDesSeg, i As Integer, _
                        pfin As Long, colseg As Long, tipseg As Integer)
'Analiza los identificadores en busca de palabras reservadas
    Select Case c
    Case "A"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ABS", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ASC", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "C"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "CAPTURE", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "CHR", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "COMO", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "CONNECT", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "COS", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "D"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "DISCONNECT", 10) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "DETECT_PROMPT", 13) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "DIVS", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "E"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "EDIT", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ELSE", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "EN", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "END", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ENDCAPTURE", 10) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ENT", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "ENDIF", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "EXP", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "F"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "FILECLOSE", 9) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "FILEOPEN", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "FILEWRITE", 9) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "FILEWRITELN", 11) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "FILT", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "FINCONSULTAR", 12) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "FINDEFINIR", 10) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "FINPARA", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "FRC", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "I"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "IF", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "INPUTSTR", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "L"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LON", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LONL", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LN", 2) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LOGCLOSE", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LOGOPEN", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LOGPAUSE", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LOGSTART", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "LOGWRITE", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "H"
        If cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "HACER", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "M"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "MESSAGEBOX", 10) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "MNS", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "MYS", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "P"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "PAUSE", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "PAUSEM", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "R"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "RDN", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "RESULT", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "RPLA", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "S"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "SEN", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "SEND", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "SENDLN", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "STOP", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "SUBS", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "T"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "TAN", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "TIMEOUT", 7) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "THEN", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "V"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "VAL", 3) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "W"
        If cierraSegmId(lin(), i, pfin, colseg, tipseg, tmp, "WAIT", 4) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    Case "$"
        If cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$CONSULTAR", 10) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$DEFINIR", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$DIR_ACTUAL", 11) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$FECHA_ACTUAL", 13) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$FORMATO", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$INCLUIR", 8) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$PARA", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$PSQL_REINIC", 12) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$REDEF", 6) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$NOM_ACTUAL", 11) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        ElseIf cierraSegmId2(lin(), i, pfin, colseg, tipseg, tmp, "$EXPR", 5) Then
            tipseg = TSEG_DES    'prepara tipo siguiente
        End If
    End Select

End Sub

Private Sub ActualDescColFil(txt As String, lin() As TDesSeg)
'Actualiza el vector descriptor de segmentos de una fila.
'Sirve para facilitar el anlisis semntico y el coloreado de sintaxis.
'Slo soporta filas menores a 32767 caracteres
Dim pfin As Long  'posicin de fin de bloque
Dim i As Integer, n As Integer
Dim colseg As Long      'color de segmento
Dim tipseg As Integer   'tipo de segmento
Dim buscafincad1 As Boolean
Dim buscafincad2 As Boolean
Dim c As String, tmp As String
Dim IniIden As Boolean  'bandera de inicio de identificador
    'n = 0   'nmero de elementos de la matriz
    ReDim lin(0)
    If txt = "" Then Exit Sub
    colseg = mColTxtNor    'inicia color de segmento
    tipseg = TSEG_NOR
    pfin = 0    'Posicin del caracter final del bloque
    tmp = UCase(txt)    'La comparacin se hace ignorando la caja
    
    IniIden = True      'El inicio de la lnea es inicio de identificador
    For i = 1 To Len(txt)
        c = Mid$(tmp, i, 1)    'caracter i
        If buscafincad1 Then   'Estamos dentro de una constante de cadena
            If c = """" Then
                'se toma hasta i para incluir las comillas
                cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_CAD   'cierra
                buscafincad1 = False     'Marca fin de constante cadena
            End If
        ElseIf buscafincad2 Then   'Estamos dentro de una constante de cadena
            If c = "'" Then
                'se toma hasta i para incluir las comillas
                cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_CAD   'cierra
                buscafincad2 = False     'Marca fin de constante cadena
            End If
        ElseIf Mid$(tmp, i, 2) = "//" Then    'Busca comentario
            cierraSegm lin(), i, pfin, colseg, tipseg     'cierra anterior
            'crea segmento final
            n = UBound(lin) + 1
            ReDim Preserve lin(n)
            lin(n).tam = Len(txt) - pfin
            lin(n).col = mColTxtCom    'comentario
            lin(n).tip = TSEG_COM
            Exit Sub    'Ya no hay ms segmentos despus de este
        ElseIf c = """" Then      'Busca comilla
            cierraSegm lin(), i, pfin, colseg, tipseg   'cierra anterior
            buscafincad1 = True  'marca bandera
        ElseIf c = "'" Then      'Busca comilla
            cierraSegm lin(), i, pfin, colseg, tipseg  'cierra anterior
            buscafincad2 = True   'marca bandera
        'busca palabras reservadas
        ElseIf IniIden Then     'Es el inicio de identificador (palabras reservadas)
            AnalizarIdentificador c, tmp, lin(), i, pfin, colseg, tipseg
        End If
        'Valida estado de "IniIden" para el siguiente caracter
        If c Like CAR_IDEN_VALM Then IniIden = False Else IniIden = True
    Next
    'Termin la exploracin, cierra segmento
    If buscafincad1 Then
        'Cadena sin delimitador final
        cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_NOR     'cierra
    ElseIf buscafincad2 Then
        'Cadena sin delimitador final
        cierraSegm1 lin(), i, pfin, mColTxtCad, TSEG_NOR     'cierra
    Else
        cierraSegm lin(), i, pfin, colseg, tipseg
    End If
End Sub

Private Sub DibLinSel(y As Long, yc As Long, yt As Long, linvis As String)
'Dibuja una lnea de texto en modo BN.
'La lnea a dibujar debe estr en el bloque se seleccin
Dim xc1 As Integer, xc2 As Integer
Dim tmp As String
    'Dibuja el fondo con la seleccin
    LeerXCurSel xc1, xc2    'obtiene coordenadas de seleccin
    If tipSelec = 1 Then    '--------Seleccin por columnas
        'Dibuja el texto antes del bloque
        pic.ForeColor = mColTxtNor
        tmp = Left$(linvis, xc1 - 1)    'protege de lneas pequeas
        TextOut pic.hdc, 0, y, tmp, Len(tmp)
        'Dibuja el texto despus del bloque
        tmp = Mid$(linvis, xc2)         'protege de lneas pequeas
        TextOut pic.hdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
        'Dibuja fondo de seleccin
        Call DibBloFonC(yc, xc1, xc2, mColFonSel)
        'Dibuja texto seleccionado
        pic.ForeColor = mColTxtSel
        If xc2 > xc1 Then   'Verificacin de la menor corrdenada
            tmp = Mid$(linvis, xc1, xc2 - xc1)       'protege de lneas pequeas
            TextOut pic.hdc, (xc1 - 1) * anccarP, y, tmp, Len(tmp)
        Else
            tmp = Mid$(linvis, xc2, xc1 - xc2)       'protege de lneas pequeas
            TextOut pic.hdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
        End If
    Else                    '--------Seleccin normal
        'Dibuja el fondo,
        If yt = sel1.yt And yt = sel2.yt Then 'nica lnea con la seleccin
            'Dibuja el texto antes del bloque
            pic.ForeColor = mColTxtNor
            tmp = Left$(linvis, xc1 - 1)    'protege de lneas pequeas
            TextOut pic.hdc, 0, y, tmp, Len(tmp)
            'Dibuja el texto despus del bloque
            tmp = Mid$(linvis, xc2)         'protege de lneas pequeas
            TextOut pic.hdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
            'Dibuja fondo de seleccin
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)
            'Dibuja texto seleccionado
            pic.ForeColor = mColTxtSel
            tmp = Mid$(linvis, xc1, xc2 - xc1)       'protege de lneas pequeas
            TextOut pic.hdc, (xc1 - 1) * anccarP, y, tmp, Len(tmp)
        ElseIf yt = sel1.yt Then    'primera lnea de la selecin
            'Dibuja el texto antes del bloque
            pic.ForeColor = mColTxtNor
            tmp = Left$(linvis, xc1 - 1)    'protege de lneas pequeas
            TextOut pic.hdc, 0, y, tmp, Len(tmp)
            'Dibuja fondo de seleccin
            xc2 = Len(linvis) + 1   'selecciona hasta el final
            xc2 = xc2 + 1           'un caracter ms para indicar que la seleccin va hasta el final
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)
            'Dibuja texto seleccionado
            pic.ForeColor = mColTxtSel
            tmp = Mid$(linvis, xc1)       'protege de lneas pequeas
            TextOut pic.hdc, (xc1 - 1) * anccarP, y, tmp, Len(tmp)
        ElseIf yt = sel2.yt Then    'ltima lnea de la selecin
            'Dibuja el texto despus del bloque
            pic.ForeColor = mColTxtNor
            tmp = Mid$(linvis, xc2)         'protege de lneas pequeas
            TextOut pic.hdc, (xc2 - 1) * anccarP, y, tmp, Len(tmp)
            'Dibuja fondo de seleccin
            xc1 = 1                 'selecciona desde el inicio
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)  'fondo de seleccin
            'Dibuja texto seleccionado
            pic.ForeColor = mColTxtSel
            tmp = Mid$(linvis, 1, xc2 - 1)          'protege de lneas pequeas
            TextOut pic.hdc, 0, y, tmp, Len(tmp)
        ElseIf yt > sel1.yt And yt < sel2.yt Then   'lnea completamente seleccionada
            'Dibuja fondo de seleccin
            xc1 = 1                 'selecciona desde el inicio
            xc2 = Len(linvis) + 1   'selecciona hasta el final
            xc2 = xc2 + 1   'un caracter ms para indicar que la seleccin va hasta el final
            Call DibBloFonC(yc, xc1, xc2, mColFonSel)
            'Dibuja texto seleccionado
            pic.ForeColor = mColTxtSel
            TextOut pic.hdc, 0, y, linvis, Len(linvis)
        Else
            'Aqu significa que la lnea no est en la zona de seleccin
            'Nunca debera darse esta condicin, si se verifica antes de
            'llamar a esta rutina
        End If
    End If
End Sub

Private Sub DibujaLinBN(yt As Long, Optional BorraFondo As Boolean = True)
'Refresca una lnea completa que est en la posicin indicada en coordenadas
'de texto (1..nLin). Por defecto borra el fondo antes de dibujar el texto.
'Dibuja el texto considerando la zona seleccionada.
'El texto se dibuja siempre empezando en la coordenada x=0.
Dim y As Long
Dim yc As Long
Dim linvis As String
Dim lin As String
    'Verifica si escapa del texto
    If yt < 1 Or yt > nLin Then Exit Sub
    yc = yt - fil1 + 1   'Coord. de cursor
    If yc < 1 Or yc > maxLinVis Then Exit Sub   'fuera de pantalla
    'toma lnea afectada
    linvis = Mid(linexp(yt), col1, maxColVis)
    y = (yt - fil1) * altcarP    'posicin vertical en pixels
    'Dibuja fondo de lnea
    If BorraFondo Then Call DibBloFonC(yc, 1, maxColVis + 1, mColFonEdi)
    If haysel Then
        'Dibuja texto con seleccin
        If yt >= sel1.yt And yt <= sel2.yt Then
            Call DibLinSel(y, yc, yt, linvis)
        Else    'Lnea sin seleccin
            'Dibuja el texto sin seleccin
            pic.ForeColor = mColTxtNor
            TextOut pic.hdc, 0, y, linvis, Len(linvis)
        End If
    Else
        'Dibuja el texto sin seleccin
        pic.ForeColor = mColTxtNor
        TextOut pic.hdc, 0, y, linvis, Len(linvis)
    End If
End Sub

Private Sub DibujaLinActual()
'Dibuja la lnea actual (curYt), con el fondo apropiado.
Dim coltmp As Long
    If verFonLin Then
        coltmp = mColFonEdi     'Guarda color
        mColFonEdi = mColLinAct 'Color de lnea activa
        DibujaLin curYt, True
        mColFonEdi = coltmp     'Recupera
    Else
        DibujaLin curYt, True
    End If
End Sub

Private Sub DibujaLin(yt As Long, Optional BorraFondo As Boolean = True)
'Refresca una lnea completa que est en la posicin indicada en coordenadas
'de texto (1..nLin). Por defecto borra el fondo antes de dibujar el texto.
'Dibuja la lnea de texto a partir de su Vector de descripcin, logrando
'texto multicolor.
Dim xc As Integer
Dim yc As Long, yp As Long
Dim i As Integer, j As Integer
Dim seg As String   'texto del segmento
Dim txtVis As String
Dim pos As Integer  'variable para buscar segmento
Dim tamaju As Integer   'tamao ajustado del primer segmento
Dim txt As String
Dim lin() As TDesSeg
    'Verifica si escapa del texto
    If yt < 1 Or yt > nLin Then Exit Sub
    yc = yt - fil1 + 1   'Coord. de cursor
    If yc < 1 Or yc > maxLinVis Then Exit Sub   'fuera de pantalla
    
    'Verifica si hay seleccin para dbujar en B/N
    If LineaEnSel(yt) Then
        'No nos complicamos
        Call DibujaLinBN(yt, BorraFondo)
        Exit Sub
    End If
    
    'analiza toda la lnea porque los colores
    'pueden depender de elementos no visibles
    txt = linexp(yt)                'lee toda la lnea
    If lincol(yt).tip = TLIN_DES Then
        'No hay descripcin, hay que actualizar
        ActualDescColFil txt, lin()
        lincol(yt).tip = TLIN_MIX
        lincol(yt).seg = lin    'copia descripcin de lnea
    Else    'ya tiene descripcin de segmento
        lin() = lincol(yt).seg()
    End If
    
    yp = (yt - fil1) * altcarP  'actualiza coordenada vertical en pixeles
    'Dibuja fondo de lnea
    If BorraFondo Then Call DibBloFonC(yc, 1, maxColVis + 1, mColFonEdi)
    '-------Busca segmento de inicio "i"-------
    i = 1   'Se asume que empieza en el segmento 1
    pos = 1
    For i = 1 To UBound(lin)
        pos = pos + lin(i).tam
        If pos > col1 Then
            'Este es el segmento que contiene el punto inicial.
            'Calcula el tamao ajustado del primer segmento a
            'dibujar que puede estar fragmentado.
            tamaju = pos - col1
            Exit For
        End If
    Next
    txtVis = Mid$(txt, col1, maxColVis)     'texto visible para graficar
    'Si no cae en ningn segmento, i termina con Ubound(lin)+1
    '-------Imprime desde el segmento "i"------
    xc = 1  'caracter inicial
    For j = i To UBound(lin)
        pic.ForeColor = lin(j).col
        If j = i Then
            'Slo para el primer segmento, el tamao puede variar
            seg = Mid$(txtVis, xc, tamaju)       'texto del segmento
            TextOut pic.hdc, (xc - 1) * anccarP, yp, seg, Len(seg)
            xc = xc + tamaju
        Else
            seg = Mid$(txtVis, xc, lin(j).tam)   'texto del segmento
            TextOut pic.hdc, (xc - 1) * anccarP, yp, seg, Len(seg)
            xc = xc + lin(j).tam
        End If
        If xc > maxColVis Then
            Exit For 'ya no es visible
        End If
    Next
End Sub

Private Sub Dibujar(Optional RefresPIC As Boolean = True)
'Dibuja el texto completo que es visible en el control "pic".
'Por defecto limpia el fondo a dibujar
Dim yp As Long
Dim i As Long
Dim textVis As String    'texto visible en la ventana
Dim numlin As String
Dim x1 As Long, x2 As Long
Dim rc As RECT
    'rc.Left = 0: rc.Top = 0    'ya est inicializado
    If RefresPIC Then   'limpia ventana
'        pic.Refresh: Exit Sub   'El "Refresh", llamar a "Paint" y a Dibujar()
        rc.Right = pic.ScaleWidth: rc.Bottom = pic.ScaleHeight
        hBrush = CreateSolidBrush(mColFonEdi)
        FillRect pic.hdc, rc, hBrush 'Es ms rpido que "Rectangle"
    End If
Call RecalculaMaxColVis
    If nLin = 0 Or fil1 = 0 Then Exit Sub
    If maxLinVis = 0 Or maxColVis = 0 Then Exit Sub
    yp = 0
    LeerXPosSel x1, x2
    FijaRelleno mColFonSel   'Relleno para la seleccin
    'Dibuja por lneas
    For i = fil1 To nfilFin
        If i = curYt Then
            DibujaLinActual
        Else
            DibujaLin i, False  'dibuja sin pintar el fondo
        End If
    Next
    If verNumLin Then   'Dibuja nmero de lnea
        'Borra columna
        rc.Right = ancNLinP: rc.Bottom = pic.ScaleHeight
        hBrush = CreateSolidBrush(mColFonNli)
        FillRect UserControl.hdc, rc, hBrush
        UserControl.ForeColor = vbBlack
        'Dibuja nmeros
        yp = 0
        For i = fil1 To nfilFin
            numlin = i
            TextOut UserControl.hdc, 0, yp + 2, numlin, Len(numlin)
            yp = yp + altcarP    'actualiza coordenada vertical
        Next
    End If
    'Actualiza barra de desplazamiento
    pintando = True     'activa bandera para evitar lanzar otra vez el evento "Paint"
    If CInt((fil1 - 1) * facdesV + 1) > VScroll1.Max Then
        'Esta situacin no debera producirse pero, parece que con muchas
        'lineas el redondeo puede ocasionar exceso
        MsgBox "Error de ajuste vertical: " & (fil1 - 1) * facdesV + 1 - VScroll1.Max
        VScroll1.Value = VScroll1.Max
    Else
        VScroll1.Value = (fil1 - 1) * facdesV + 1
    End If
    If col1 > HScroll1.Max Then
        MsgBox "Error de ajuste horizontal."
        HScroll1.Max = col1
        HScroll1.Value = col1
    Else
        HScroll1.Value = col1
    End If
    pintando = False
End Sub

Private Function CurMenorPos(pos As Tpostex) As Boolean
'Compara el cursor actual con una posicin
Dim poscur As Tpostex
    poscur.xt = curXt
    poscur.yt = curYt
    CurMenorPos = MenorPos(poscur, pos)
End Function

Private Function CurMayorPos(pos As Tpostex) As Boolean
'Compara el cursor actual con una posicin
Dim poscur As Tpostex
    poscur.xt = curXt
    poscur.yt = curYt
    CurMayorPos = MayorPos(poscur, pos)
End Function

Private Function PosSigPos(pos As Tpostex, n As Long) As Tpostex
'Devuelve la siguiente posicin a partir de una posicin base,
'proyectado "n" caracteres adelante. Trabaja en coordenadas de texto
'Slo funciona en el modo de selecin normal.
Dim xt As Integer
Dim yt As Long
Dim lin1 As String  'primera lnea
    PosSigPos = pos
    If n = 0 Then Exit Function
    lin1 = linrea(pos.yt)   'lee primera lnea
    xt = PosXTreal(pos.xt, pos.yt)
    If xt + n <= Len(lin1) + 1 Then
        'Caso simple. No se escapa de la lnea
        PosSigPos.yt = pos.yt
        PosSigPos.xt = PosXTexp(xt + n, pos.yt) 'posicin expandida
    Else
        'Caso ms complicado, porque pasa a otras lneas
        n = n - (Len(lin1) + 1 - xt)    'quita tamao del restante de lnea 1
        yt = pos.yt
        While n > 0
            'Aqu deben estar los dos caracteres CR y LF
            n = n - 2   'Los quitamos
            yt = yt + 1     'nos movemos a la siguiente lnea
            If n < 0 Then
                'Rayos!, algo no anda bien
                MsgBox "Error de ajuste de salto de lnea"
                Exit Function
            End If
            'Aqu puede estar la siguiente lnea
            If n = 0 Then
                'Ya no hay ms lneas
                PosSigPos.yt = yt   'en la siguiente
                PosSigPos.xt = 1    'al inicio
                Exit Function
            ElseIf n > 0 Then
                'An no se cubren todos los caracteres
                If n > Len(linrea(yt)) Then
                    'Toma siguiente lnea completa
                    n = n - Len(linrea(yt))
                Else
                    'Es la ltima lnea
                    PosSigPos.yt = yt   'en la siguiente
                    PosSigPos.xt = PosXTexp(n + 1, yt)
                    Exit Function
                End If
            End If
        Wend
    End If
End Function

Public Sub SelecIdentificador(xt As Integer, yt As Long, largo As Long)
'Selecciona una cadena en el editor a partir de la posicin indicada. Recibe coordenadas
'de texto. No redibuja.
Dim p As Tpostex
    p.xt = PosXTexp(xt, yt)     'Necesita la posicin expandida
    p.yt = yt
    'Selecciona cadena
    posCursorA p
    Call FijarSel0      'Fija punto base
    posCursorA2 PosSigPos(p, largo)
    Call ExtenderSel 'Extiende seleccin
End Sub




Private Sub DibTextPos(p1 As Tpostex, p2 As Tpostex)
'Dibuja las lneas entre las posiciones p1 y p2.
'Si p1 es menor que p2, se corrige.
Dim f As Long
    If p1.yt <= p2.yt Then
        For f = p1.yt To p2.yt
            Call DibujaLin(f)
        Next
    Else
        For f = p2.yt To p1.yt
            Call DibujaLin(f)
        Next
    End If
End Sub

Private Sub ActLimitesBarDesp()
'Actualiza los lmites de las barras de desplazamiento
Dim nLinVis As Integer
    'Calcula el nmero de lneas visibles en el editor
    nLinVis = nfilFin - fil1 + 1

    If nLin > 32700 Then
        'Verifica si se puede trabajar con desplazamientos simples
        'de la barra vertical
        facdesV = 1 / (Int(nLin / 32700) + 1)
    Else    'Si se puede
        facdesV = 1     'factor de desplazamiento vertical
    End If
    If nLin + 1 > maxLinVis Then
        VScroll1.enabled = True
        VScroll1.Max = (nLin - nLinVis) * facdesV + 1 'Valor mximo
        If nLinVis > 0 Then VScroll1.LargeChange = nLinVis
    Else
        VScroll1.enabled = False
    End If
    
    If maxTamLin + 1 > maxColVis Then
        HScroll1.enabled = True
        HScroll1.Max = MaxCol1
        If maxColVis > 0 Then HScroll1.LargeChange = maxColVis
    Else    'deshabilita
        HScroll1.enabled = False
    End If
End Sub

'**********************************************************************************
'******************************FUNCIONES DE NIVEL MAYOR****************************
'**********************************************************************************
Public Sub CargarArch(arch As String)
'Mtodo inicial para cargar un archivo de texto en el editor
Dim nar As Integer
Dim linea As String
Dim a() As String
Dim i As Long
    If Dir(arch) = "" Then
        MsgBox "No se encuentra archivo: " & arch
        Exit Sub
    End If
    Call LimpiarLineas
    'abre archivo de datos
    archivo = arch
    nar = FreeFile
    Open archivo For Input As #nar
    lblEstado3.Caption = "DOS"      'Se asume que el tipo es DOS
    'OJOOOOOOOOOOOOOOO que si hay una lnea en blanco al final, no se lee
    'porque "Line Input" lee incluyendo el salto de lnea final si lo encuentra
    Do While Not EOF(nar)
        Line Input #nar, linea
        If InStr(linea, Chr(10)) <> 0 Then
            'Hay saltos de lnea, debe ser un formato unix
            tipArch = 1
            lblEstado3.Caption = "UNIX"
            a = Split(linea, Chr(10))
            For i = 0 To UBound(a)
                AgregaLinea a(i)    'Agregamos lnea
            Next
        Else
            AgregaLinea linea   'Agrega la lnea tal como se lee
        End If
        If nLin > MAX_LIN_EDI Then
            MsgBox "Demasiadas lneas para leer en el editor"
            Exit Do
        End If
    Loop
    Close #nar
    tCursorA 1, 1
    Call ActualizaNLinFin   'actualiza las lneas visible
'    Call UserControl_Resize
    Call Dibujar
    Call InicDeshacer       'Inicia deshacer
    Call FijarTextNoModif   'Fija punto de "No Modificado"
    Call RefresEstadoModif  'Refresca estado
End Sub

Public Sub GuardarArch()
'Mtodo inicial para guardar el archivo de texto del editor
    If archivo = "" Then
        MsgBox "No se ha especificado un nombre para el archivo", vbExclamation
        Exit Sub
    End If
    GuardarArchComo archivo
End Sub

Public Sub GuardarArchComo(nomb As String)
'Mtodo inicial para guardar el archivo de texto del editor
Dim nar As Integer
Dim f As Long
    archivo = nomb  'actualiza nombre actual
    nar = FreeFile
    Open archivo For Output As #nar
    For f = 1 To nLin
        Print #nar, linrea(f)
    Next
    Close #nar
'    Call InicDeshacer       'Inicia deshacer
    Call FijarTextNoModif   'Fija punto de "No Modificado"
    Call RefresEstadoModif  'Refresca estado
End Sub

Private Sub LimpSelec(Optional refres As Boolean = False)
'Quita el rea seleccionada, del control. Por defecto no actualiza la pantalla,
'pero si "refres" es TRUE, se redibuja la pantalla si es necesario
    If haysel Then      'Haba una seleccin
        haysel = False  'desactiva
        If refres Then  'Hay que refrescar
            If sel1.yt = sel2.yt Then   'Slo basta con dibujar la lnea
                Call DibujaLin(sel1.yt)
            Else    'Hay que dibujar varias lneas
                Call Dibujar
            End If
        End If
        sel1 = sel0         'Inicia seleccin nula
        sel2 = sel0         'Inicia seleccin nula
    End If
End Sub

Public Sub SeleccionaTodo()
'Selecciona todo el texto contenido en el editor
    If nLin = 0 Then Exit Sub
    Redibujar = False
    'se mueve al inicio
    tCursorA 1, 1
    Call FijarSel0      'Fija punto base
    'nos movemos al final
    tCursorA2 maxTamLin + 1, nLin
    curXd = curXt      'actualiza posicin deseada
    Call ExtenderSel
End Sub

Public Sub SelecLinea(yt As Long)
'Funcin pblica para seleccionar lnea del texto
    Redibujar = True       'para no complicarnos, dibuja todo
    If haysel Then Call LimpSelec
    'Selecciona lnea
    tCursorA 1, yt
    Call FijarSel0      'Fija punto base
    tCursorA2 maxTamLin + 1, yt
    Call ExtenderSel 'Extiende seleccin
End Sub

Public Sub PegaSeleccion()
'Pega el texto seleccionado al control
'No hay problema en pegar selecciones grandes de texto
    On Error GoTo errPegSel
    CurInsertar Clipboard.GetText
    On Error GoTo 0
    Exit Sub
errPegSel:
    MsgBox "Error Leyendo el portapapeles.", vbExclamation
    On Error GoTo 0
End Sub

Public Sub CortaSeleccion()
'Elimina el texto seleccionado y copia la seleccin al portatpapeles
    Call CopiaSeleccion
    If haysel Then Call CurEliminar
End Sub

Public Sub CopiaSeleccion()
'Copia el texto seleccionado al portapapeles
Dim hData As Long   'Manejador de memoria
Dim nbytes As Long
    If nLin = 0 Then Exit Sub   'por seguridad
    '---------Obtiene seleccin-------------
    'Copia seleccin a memoria
    hData = BloAMem(nbytes, sel1, sel2)
    If hData = 0 Then
        MsgBox "No se puede copiar texto. Error asignando memoria", vbCritical
        Exit Sub
    End If
    '---------Copia al portapapeles-------------
    If OpenClipboard(0) Then
        Call EmptyClipboard
        'SetClipboardData CF_METAFILEPICT, hGlobal
        Call SetClipboardData(CF_TEXT, hData)
        'No es necesario ya liberar "hData", porque el portapapapeles lo har
        'cuando ya no lo necesite
        Call CloseClipboard
    Else    'Fallo abrir el Portapapeles
        'Liberamos la memoria porque no la vamos a usar
        GlobalFree hData
    End If
End Sub

Private Function ElimBloq(s1 As Tpostex, s2 As Tpostex) As Long
'Elimina el bloque de texto definido por s1 y s2. Actualiza s1 y s2
'No realiza refresco de pantalla. Devuelve las filas eliminadas.
Dim f1 As Long, f2 As Long
Dim f As Long
Dim xt1 As Integer, xt2 As Integer
Dim xtmp As Integer
Dim tmp As String
    f1 = s1.yt    'posicin vertical
    f2 = s2.yt    'posicin vertical
    If tipSelec = 1 Then    '---------Seleccin por columnas----------
        'calcula posiciones horizontales en el texto
        xt1 = s1.xt: xt2 = s2.xt
        If xt1 > xt2 Then   'Verifica si hay que invertir
            xtmp = xt1: xt1 = xt2: xt2 = xtmp
        End If
        'Quita seleccin de las lneas afectadas
        For f = f1 To f2
            'Para no complicarnos con las tabulaciones, expandimos toda la lnea
            'antes de eliminar. Lo optimo sera analizar que tabulaciones son
            'afectadas y expandirlas slo a ellas.
            linrea(f) = LineaFin(linrea(f))
            EliminarCad linrea(f), xt1, xt2 - xt1
        Next
        ElimBloq = f2 - f1 + 1 'nmero de filas eliminadas
    Else              '---------------Seleccin normal----------------
        'calcula posiciones horizontales reales
        'se asume que siempre s1 est antes que s2
        xt1 = PosXTreal(s1.xt, s1.yt)
        xt2 = PosXTreal(s2.xt, s2.yt)
        'Elimina de acuerdo a la posicin
        If f1 = f2 Then     'Estn en la misma fila
            EliminarCad linrea(f1), xt1, xt2 - xt1
            ElimBloq = 1   'zlo se elimina de una fila
        ElseIf f1 < f2 Then
            'Procesa fila contiene inicio de seleccin
            EliminarCad linrea(f1), xt1
            'Procesa fila contiene fin de seleccin
            EliminarCad linrea(f2), 1, xt2 - 1
            'Elimina las filas intermedias
            If linrea(f2) = "" Then
                '-----Se eliminan la fila final completa
                EliminarLineas f1 + 1, f2 - f1
            Else
                '-----Se eliminan filas a medias. Hay que juntar
                'rescata lo que va a quedar de la fila final
                tmp = linrea(f2)
                'elimina hasta la fila final
                EliminarLineas f1 + 1, f2 - f1
                'agrega lo que rescat
                linrea(f1) = linrea(f1) & tmp
            End If
            ElimBloq = f2 - f1 + 1 'nmero de filas eliminadas
        End If
    End If
    'Actualiza nuevas posiciones de seleccin
    s2 = s1
    'Actualiza por si han desaparecido lneas de la pantalla
    Call ActualizaNLinFin
End Function

Private Function ElimSelecDib(Optional refres As Boolean = True) As Long
'Elimina la zona seleccionada. Actualiza las variables sel1 y sel2
'Refresca la pantalla por defecto. Devuelve las filas eliminadas.
'Se asume que la seleccin debe contener al cursor actual.
Dim f As Long
Dim yt2 As Long
Dim nfilsel As Long
    If bloqText Then Exit Function   'Hay proteccin
    yt2 = sel2.yt   'Guarda posicin final antes de eliminar
                    'bloque, por si se necesita
    nfilsel = ElimBloq(sel1, sel2)
    If nfilsel = 1 Then    'slo modific una lnea
        lincol(curYt).tip = TLIN_DES    'Fuerza a actualizar colores
        Redibujar = False   'prepara bandera
        'ubica de nuevo el cursor para validar posicin
        posCursorA2 sel1    'Aqu se puede actualizar "Redibujar"
    Else    'Se han modificado varias lneas
        'Actualiza estado de sintaxis
        If tipSelec = 1 Then    'Varias filas alteradas
            For f = sel1.yt To yt2
                lincol(f).tip = TLIN_DES     'Actualizar en la 1ra lnea
            Next
        Else
            lincol(sel1.yt).tip = TLIN_DES    'Actualizar en la 1ra lnea
        End If
        'ubica cursor
        posCursorA2 sel1
        Redibujar = True    'Fuerza a redibujar
    End If
    haysel = False  'antes de dibujar, para refrescar correctamente
    If refres Then  'Verifica si se debe refrescar
        If Redibujar Then
            'Ha habido movimiento de pantalla o se han eliminado varias lneas
            Call Dibujar
'            Call ActualizaNLinFin    'Para dibujar correctamente
            Call ActLimitesBarDesp 'actualiza lmites de Scroll Bar's
        Else    'Slo es necesario refrescar la lnea afectada
            Call DibujaLinActual
        End If
        Call EncenCursor    'el cursor estaba desactivado
    End If
    Call FijarSel0      'Fija punto base de seleccin
    ElimSelecDib = nfilsel  'Devuelve filas eliminadas
End Function

Public Sub CurInsertar(cad As String)
'Inserta una cadena en la posicin actual del cursor
'Guarda informacin para deshacer
Dim xt As Integer, yt As Long
Dim xtr As Integer
Dim tmp As String
Dim f As Long
Dim lcad() As String
Dim ncad As Long
Dim tam As Integer  'Tamao de cadena
Dim pcur As Tpostex 'Guarda posicin de cursor
Dim pmax As Tpostex 'Guarda posicin de cursor
Dim nadi As Long    'Lneas adicionales
Dim s1 As Tpostex, s2 As Tpostex    'para seleccin
'Dim yt2 As Long     'yt2 para el modo multilnea
Dim nfilsel As Long
    If bloqText Then Exit Sub   'Hay proteccin
    
'    If cad = "" Then Exit Sub
    If nLin = 0 Then    'caso especial. No hay nada
        'Es el primer caracter que se crea
        AgregaLinea ""
        maxTamLin = 1
        FijaCursor 1, 1
        curXd = 1     'Inicia posicin X deseada de cursor
        Call FijarSel0  'inicia parmetros de seleccin
    End If
    'Verifica si hay texto seleccionado
    If haysel Then
        'Se debe primero eliminar el texto selecionado.
        GuarAcc TU_ELI, sel1, TextSel()  'para deshacer
        s1 = sel1: s2 = sel2    'Guardar por si acaso
        nfilsel = ElimSelecDib(False) 'Elimina sin refrescar
        'Verifica si hay Insercin en modo multilnea
        If tipSelec = 1 And nfilsel > 1 And InStr(cad, vbCrLf) = 0 Then
            'Crea rpidamente una cadena de varias lneas
            ReDim lcad(1 To nfilsel)
            For f = 1 To nfilsel: lcad(f) = cad: Next
            tmp = Join(lcad, vbCrLf)
            'Inserta en la posicin actual, se hace recursivamente para
            'evitar lidiar con el "deshacer" y los detalles del refresco.
            CurInsertar tmp     'Llamada recursiva
            'Restaura la seleccin para poder seguir escribiendo
            s1.xt = s1.xt + Len(cad)    'corrige desplazamiento
            's2.xt = s2.xt + Len(cad)    'corrige desplazamiento
            s2.xt = s1.xt   'debe haber siempre cero columnas
            sel1 = s1: sel2 = s2
            haysel = True
            Call Refrescar
            Exit Sub        'No hay ms que hacer
        End If
    End If
    'Calcula posicin horizontal real en la cadena considerando
    'tabulaciones. Se hace despus de eliminar una posible seleccin
    'para tener la nueva posicin
    'Toma posiciones en el texto
    xt = curXt
    yt = curYt
    If xt < 1 Or yt < 1 Then Exit Sub
    xtr = PosXTreal(xt, yt)
    'Inserta cadena en el texto
    If InStr(cad, vbCrLf) = 0 Then
        If Len(linrea(yt)) + Len(cad) > MAX_ANC_LIN Then   'Proteccin
            MsgBox "ERROR: Lnea muy larga"
            Exit Sub
        End If
        GuarAcc TU_INS, LeePosCur, cad   'Guarda accin para deshacer
        '------- Insertar Cadena de una sola lnea -----------
        InsertarCad linrea(yt), xtr, cad
        lincol(yt).tip = TLIN_DES   'Fuerza a actualizar colores
        linact = linexp(yt)    'actualiza lnea actual porque se ha cambiado
                               'Se debe hacer antes de llamar a DesplazaCursor()
        'Actualiza tamao de lnea ms larga
        'Se deba hacer antes de DesplazaCursor() para tener actualizada
        'la barra de desplazamiento antes de dibujar
        If Len(linact) > maxTamLin Then
            maxTamLin = Len(linact)
            Call ActLimitesBarDesp  'actualiza barra
        End If
        If Redibujar Then   'Verifica si es necesario dibujar todo
            Call Dibujar
        Else
            Call DibujaLinActual        'Refresca la lnea actual
        End If
        DesplazaCursor DIR_DER, Len(cad)    'Mueve cursor
    Else
        '------ Insertar cadena de varias lneas ---------
        If tipSelec = 1 Then '---------------Modo por columnas---------------
            pcur = LeePosCur    'Guarda posicin actual de cursor
            pmax = MaxPos       'Guarda posicin del final
            lcad = Split(cad, vbCrLf)  'separa en lneas
            ncad = UBound(lcad) 'ltimo ndice
            'Agrega fila por fila
            nadi = 0 'inicia contador
            For f = 0 To ncad
                If yt + f > nLin Then   'No hay lnea. hay que agregarla
                    Call AgregaLinea(Space(xt - 1)) 'se le da el tamao necesario
                    nadi = nadi + 1
                Else    'Ya hay lnea.
                    'No nos complicamos y expandemos las tabulaciones
                    'Aqu podemos tener problemas con deshacer
                    linrea(yt + f) = linexp(yt + f)
                    tam = Len(linrea(yt + f))   'guarda tamao
                    If tam < xt - 1 Then
                        'Cadena muy pequea, completar con espacios
                        linrea(yt + f) = linrea(yt + f) & Space(xt - tam - 1)
                    End If
                End If
                InsertarCad linrea(yt + f), xt, lcad(f)
                lincol(yt + f).tip = TLIN_DES 'Fuerza a actualizar colores
            Next
            If nadi > 0 Then    'Hubo lneas agregadas?
                'Guarda la accin de deshacer de golpe
                For f = 1 To nadi
                    'Puede ser lento para miles de lneas
                    tmp = tmp & vbCrLf & Space(xt - 1)
                Next
                GuarAcc TU_INSn, pmax, tmp  'Insertar normal
            End If
            GuarAcc TU_INS, pcur, cad    'Guarda accin principal para deshacer
            'mueve cursor al final de la cadena pegada
            tCursorA2 xt + Len(lcad(0)), curYt + ncad
            curXd = curXt      'actualiza posicin deseada
            Call ActualizaNLinFin   'Para dibujar correctamente
            Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
            Call FijarSel0      'Fija punto base, como lo hara "DesplazaCursor()"
            'Ha cambiado bastante, mejor actualizamos todo
            Call Dibujar
            Call EncenCursor    'Enciende para que sea visible en la nueva posicin
        Else                 '---------------Modo normal---------------------
            GuarAcc TU_INS, LeePosCur, cad   'Guarda accin para deshacer
            lcad = Split(cad, vbCrLf)  'separa en lneas
            ncad = UBound(lcad)     'ltimo ndice
            tmp = linrea(yt)        'lee lnea afectada
            'Inserta las lneas necesarias en la posicin del cursor
            InsertarLineas yt, ncad
            'corta lnea y agrega lnea inicial del portapapeles
            linrea(yt) = Mid$(tmp, 1, xtr - 1) & lcad(0)
            lincol(yt).tip = TLIN_DES 'Fuerza a actualizar colores
            'actualiza lneas internmedias
            For f = 1 To ncad - 1
                linrea(yt + f) = lcad(f)
                lincol(yt + f).tip = TLIN_DES 'Para forzar a analizar colores
            Next
            'actualiza lnea final
            linrea(yt + ncad) = lcad(ncad) & Mid$(tmp, xtr)
            lincol(yt + ncad).tip = TLIN_DES 'Fuerza a actualizar colores
            'mueve cursor al final de la cadena pegada
            tCursorA Len(lcad(ncad)) + 1, curYt + ncad
            curXd = curXt      'actualiza posicin deseada
            Call ActualizaNLinFin   'Para dibujar correctamente
            Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
            Call FijarSel0      'Fija punto base, como lo hara "DesplazaCursor()"
            'Ha cambiado bastante, mejor actualizamos todo
            Call Dibujar
            Call EncenCursor    'Enciende para que sea visible en la nueva posicin
        End If
    End If
End Sub

Public Sub CurEliminar(Optional forzardib As Boolean = False)
'Elimina un caracter en la posicin actual del cursor.
'"forzardib" indica que se fuerza a redibujar toda la pantalla
'Guarda informacin para deshacer
Dim xt As Integer
Dim yt As Long
Dim xtr As Integer
Dim tmp As String
    If bloqText Then Exit Sub   'Hay proteccin
    '---------Si hay seleccin, slo elimina y sale-------------
    If haysel Then
        GuarAcc TU_ELI, sel1, TextSel() 'para deshacer
        Call ElimSelecDib
        Exit Sub
    End If
    '-------No hay seleccin, se debe eliminar lo solicitado------
    If nLin = 0 Then Exit Sub   'no hay nada que eliminar
    'Toma posiciones en el texto
    xt = curXt
    yt = curYt
    If xt < 1 Or yt < 1 Then Exit Sub
    'Calcula posicin horizontal real en la cadena considerando tabulaciones
    xtr = PosXTreal(xt, yt)
    If xtr = Len(linrea(yt)) + 1 And yt < nLin Then
        GuarAcc TU_ELI, LeePosCur(), vbCrLf    'para deshacer
        'Esta al final de la lnea y hay ms lneas.
        'copia contenido de lnea siguiente
        tmp = linrea(yt + 1)
        'agrega a lnea actual
        linrea(yt) = linrea(yt) & tmp
        lincol(yt).tip = TLIN_DES  'Fuerza a actualizar colores
        'reposiciona cursor para validar y actualizar "linact"
        tCursorA xt, yt
        curXd = curXt      'actualiza posicin deseada
        'Eliminamos la siguiente lnea
        EliminarLineas yt + 1, 1
        Call ActualizaNLinFin
        Call ActLimitesBarDesp  'Actualiza lmites de Scroll Bar's
        Call FijarSel0      'Fija punto base, como lo hara "DesplazaCursor()"
        Call Dibujar    'Refresca. En realidad slo podra ser necesario dibujar
                        'slo las lneas de abajo.
    Else    'Caso de eliminacin normal
        tmp = EliminarCad(linrea(yt), xtr, 1)
        lincol(yt).tip = TLIN_DES  'Fuerza a actualizar colores
        GuarAcc TU_ELI, LeePosCur(), tmp   'para deshacer
        linact = linexp(yt)    'actualiza lnea actual porque se ha cambiado
        'Se debera actualizar "maxTamLin", si es que disminuye
        'pero es un proceso muy pesado para hacerse aqu
        If forzardib Then   'Dibujar todo?
            Call Dibujar    'Dibuja todo
        Else    'Slo dibuja la lnea afectada
            Call DibujaLinActual    'Refresca lnea
        End If
        'El cursor se queda en su lugar
    End If
    Call EncenCursor    'Lo hace visible para visualizar mejor
End Sub

Public Sub CurEliminarCad(cad As String)
'Elimina "n" caracteres desde la posicin actual del cursor en el control .
'El valor "n" se determina por el tamao de "cad" y por el tipo de seleccin
'No se debera usar para editar el texto del editor, sino slo para
'las opciones de "deshacer"
Dim p1 As Tpostex, p2 As Tpostex
Dim n As Long
Dim a() As String
Dim f As Long
Dim yt2 As Long
    If bloqText Then Exit Sub       'Hay proteccin
    If Len(cad) = 0 Then Exit Sub   'Verificacin
    'Define el bloque a eliminar
    p1 = LeePosCur                  'Toma inicio de bloque
    If tipSelec = 1 Then '---------------Modo por columnas---------------
       a = Split(cad, vbCrLf)       'separa cadena
       p2.yt = p1.yt + UBound(a)    'calcula lmite
       p2.xt = p1.xt + Len(a(0))    'calcula lmite
       
    Else                 '---------------Modo normal---------------
        n = Len(cad)
        p2 = PosSigPos(p1, n)    'calcula lmite de bloque
    End If
    yt2 = p2.yt     'Guarda fila final
    '-----------------Actualiza Pantalla--------------------
    If ElimBloq(p1, p2) = 1 Then    'slo modific una lnea
        lincol(p1.yt).tip = TLIN_DES  'Para actualizar colores
        Redibujar = False   'prepara bandera
        'ubica de nuevo el cursor para validar posicin
        posCursorA2 p1
        If Redibujar Then
            'Ha habido movimiento de pantalla
            Call Dibujar
        Else    'Slo es necesario refrescar la lnea afectada
            Call DibujaLinActual
        End If
    Else    'Se han modificado varias lneas
        lincol(p1.yt).tip = TLIN_DES  'Para actualizar colores
        If tipSelec = 1 Then
            'Eliminacin en varias lneas, marca las siguientes
            For f = p1.yt + 1 To yt2
                lincol(f).tip = TLIN_DES
            Next
        End If
        'ubica cursor
        posCursorA2 sel1
        Call Dibujar           'Refresca todo
        Call ActualizaNLinFin  'Para dibujar correctamente
        Call ActLimitesBarDesp 'actualiza lmites de Scroll Bar's
    End If
    Call FijarSel0      'Fija punto base de seleccin
    Call EncenCursor    'el cursor estaba desactivado
End Sub

Public Sub CurEliminarB()
'Elimina un caracter en la posicin actual del cursor, hacia atrs
Dim alinicio As Boolean
    If bloqText Then Exit Sub   'Hay proteccin
    '---------Si hay seleccin, slo elimina y sale-------------
    If haysel Then ElimSelecDib: Exit Sub
    '-------No hay seleccin, se debe eliminar lo solicitado------
    If nLin = 0 Then Exit Sub   'no hay nada que eliminar
    'Retrocede el cursor
    Redibujar = False   'inicia bandera
    If curXt = 1 Then   'Est al inicio de lnea
        If curYt > 1 Then       'hay lnea anterior
            tCursorA2 Len(linexp(curYt - 1)) + 1, curYt - 1
            curXd = curXt      'actualiza posicin deseada
        Else
            alinicio = True     'est al inicio
        End If
    Else
        tCursorA2 curXt - 1, curYt
        curXd = curXt      'actualiza posicin deseada
    End If
    Call FijarSel0      'Fija punto base, como lo hara "DesplazaCursor()"
    'Elimina en la nueva posicin. Indicando si es necesario redibujar
    If Not alinicio Then    'Verifica si se puede
        Call CurEliminar(Redibujar)    'Elimina en la nueva posicin
    End If
End Sub

'*************************************************************************************
'************************* FUNCIONES PARA OPCIONES DE BSQUEDA ***********************
'*************************************************************************************

Private Function BuscarCadPos(bus As String, p1 As Tpostex, p2 As Tpostex, _
                    Optional ignCaja As Boolean = True) As Tpostex
'Busca una cadena de texto cargado en el editor, en el bloque definido
'por pos1 y pos2, a partir de la posicin pos1 hacia adelante.
'Devuelve la posicin donde empieza la cadena encontrada. Si no encuentra,
'devuelve (0,0)
Dim cad As String
Dim pos As Integer
Dim f As Long
Dim cmp As VbCompareMethod
    If MenorPos(p2, p1) Then Exit Function
    If ignCaja Then
        cmp = vbTextCompare
    Else
        cmp = vbBinaryCompare
    End If
    If p1.yt = p2.yt Then    'Texto de una sola lnea-------
        cad = TextPosLin(p1, p2)
        pos = InStr(1, cad, bus, cmp) 'busca
        If pos <> 0 Then
            BuscarCadPos.xt = p1.xt + PosXTexp(pos, p1.yt)
            BuscarCadPos.yt = p1.yt
            Exit Function
        End If
    Else                     'Hay varias lneas---------------
        'busca en lnea inicial
        cad = TextPosIni(p1)
        pos = InStr(1, cad, bus, cmp)   'busca
        If pos <> 0 Then
            BuscarCadPos.xt = p1.xt + PosXTexp(pos, p1.yt) - 1
            BuscarCadPos.yt = p1.yt
            Exit Function
        End If
        'busca en lneas intermedias
        For f = p1.yt + 1 To p2.yt - 1
            cad = linrea(f)
            pos = InStr(1, cad, bus, cmp) 'busca
            If pos <> 0 Then
                BuscarCadPos.xt = PosXTexp(pos, f)
                BuscarCadPos.yt = f
                Exit Function
            End If
        Next
        'busca en lnea final
        cad = TextPosFin(p2)
        pos = InStr(1, cad, bus, cmp) 'busca
        If pos <> 0 Then
            BuscarCadPos.xt = PosXTexp(pos, p2.yt)
            BuscarCadPos.yt = p2.yt
            Exit Function
        End If
    End If
End Function

Public Sub InicBuscar(bus As String, _
                      Optional ambito As Integer = AMB_TODO, _
                      Optional ignCaja As Boolean = True, _
                      Optional palComp As Boolean = False)
'Inicia una bsqueda definiendo sus parmetros.
'La cadena "bus" debe ser de una sola lnea.
    If ambito = AMB_TODO Then
        'Se buscar en todo el texto
        PosBus1 = MinPos
        PosBus2 = MaxPos
    ElseIf ambito = AMB_SELE Then
        'Se buscar en la seleccin
        PosBus1 = sel1
        PosBus2 = sel2
    End If
    PosEnc = PosBus1    'Fija posicin inicial para buscar
    CadBus = bus        'Guarda cadena de bsqueda
    CajBus = ignCaja    'Guarda parmetro de caja
    PalCBus = palComp
End Sub

Public Function BuscarSig() As String
'Realiza una bsqueda iniciada con "InicBuscar"
'La bsqueda se hace a partir de la posicin donde se dej en la ltima bsqueda.
'Devuelve la cadena de bsqueda.
Dim p As Tpostex
Dim p2 As Tpostex
    PosEnc = LeePosCur()    'Busca desde el cursor
    'Protecciones
    If PosNulo(PosEnc) Then Exit Function
    If PosNulo(PosBus2) Then Exit Function
    If MayorPos(PosBus2, MaxPos) Then PosBus2 = MaxPos
    If MayorPos(PosEnc, PosBus2) Then Exit Function
    'bsqueda
    If PalCBus Then 'Debe ser palabra completa
        p = BuscarCadPos(CadBus, PosEnc, PosBus2, CajBus)
        Do While p.xt <> 0
            p2 = PosSigPos(p, Len(CadBus))
            If EsPalabraCompleta(p, p2) Then Exit Do
            PosEnc = p2
            p = BuscarCadPos(CadBus, PosEnc, PosBus2, CajBus)
        Loop
    Else    'Bsqueda normal
        p = BuscarCadPos(CadBus, PosEnc, PosBus2, CajBus)
        If p.xt <> 0 Then p2 = PosSigPos(p, Len(CadBus))
    End If
    'verifica si encontr
    If p.xt <> 0 Then
        Redibujar = True       'para no complicarnos, dibuja todo
        If haysel Then Call LimpSelec
        'Selecciona cadena
        posCursorA p
        Call FijarSel0      'Fija punto base
        posCursorA2 p2
        Call ExtenderSel 'Extiende seleccin
        BuscarSig = CadBus  'devuelve cadena
    Else
        BuscarSig = CadBus  'devuelve cadena
        MsgBox "No se encuentra el texto: '" & CadBus & "'", vbExclamation
    End If
End Function

Private Function EsPalabraCompleta(p1 As Tpostex, p2 As Tpostex) As Boolean
'Indica si la palabra en la posicin [p,p+lar] es una palabra completa, es decir,
'que no est en medio de un identificador
Dim Cant As String
Dim Csig As String
    If p1.xt = 0 Then Exit Function
    Cant = UCase(CarPosAnt(p1)) 'caracter anterior
    Csig = UCase(CarPos(p2))    'caracter siguiente
    If Not (Cant Like CAR_IDEN_VALM) And Not (Csig Like CAR_IDEN_VALM) Then
        EsPalabraCompleta = True
    End If
End Function

'*************************************************************************************
'************************* FUNCIONES PARA EL MANEJO DE DESHACER **********************
'*************************************************************************************
Private Sub RefresEstadoModif()
'Refresca estado de la modificacin del texto
    If verEstado Then
        If TextModificado Then
            'Se verifica primero para evitar redibujar el control
            If lblEstado1.Caption <> "Modificado" Then
                lblEstado1.ForeColor = vbRed
                lblEstado1.Caption = "Modificado"
            End If
        Else
            If lblEstado1.Caption <> "Guardado" Then
                lblEstado1.ForeColor = RGB(0, 128, 0)
                lblEstado1.Caption = "Guardado"
            End If
        End If
    End If
End Sub

Private Sub elimUndos(n As Integer)
'Elimina "n" acciones al inicio de la matriz Undos().
'La eliminacin se hace siempre desde la accin 1, al inicio de la matriz.
Dim i As Integer
    If n > nUndo Then n = nUndo 'proteccin
    If n <= 0 Then Exit Sub     'por proteccin y evitar prdida de tiempo cuando n=0
    'Desplaza elementos
    For i = 1 To nUndo - n
        Undos(i) = Undos(i + n)
    Next
    'Elimina elementos finales
    nUndo = nUndo - n
    ReDim Preserve Undos(nUndo)
    'Mantiene la distancia con nTxtModif
    'obsrevar que nTxtModif, puede ser negativo, lo que significa que
    'ya no se puede recuperar el estado de "texto no modificado" porque
    'ya no se tienen la cantidad de acciones disponibles que se necesitan
    'para llegar a este estado.
    nTxtModif = nTxtModif - n
End Sub

Private Sub InicDeshacer()
'Inicia la herramienta DEHACER. Debe llamarse al inicio del editor
'y cuando ya no se pueden (o deben) recuperar los cambios anteriores
    elimUndos nUndo     'Elimina todas las acciones que puedan existir
    Deshaciendo = False
End Sub

Private Sub FijarTextNoModif()
'Fija el punto en que el el texto no est modificado. Es decir
'el texto que no requiere grabacin.
'Debera llamarse en el momento de abrir un archivo o grabarse.
    nTxtModif = nUndo   'Apunta al ndice nUndo actual.
End Sub

Public Function TextModificado() As Boolean
'Indica si el texto ha sufrido modificacin
    If nUndo = nTxtModif Then
        TextModificado = False   'El texto est como al inicio
    Else
        TextModificado = True    'Se ha modificado el texto
    End If
End Function

Private Sub GuarAcc(acc As Integer, pos As Tpostex, cad As String)
'Guarda una accin de modificacin del texto para poder deshacerla luego
'Se debe llamar cada vez que se realiza un cambio en el texto
    If Deshaciendo Then Exit Sub    'No guarda acciones de tipo deshacer
    If TamMemDeshacer > TAM_MAX_UNDO Then
        InicDeshacer    'Proteccin a grabar muchas acciones
    End If
    If nUndo > NAC_MAX_UNDO Then
        'Se alcanz el tamao mximo de acciones a deshacer
        elimUndos 1     'elimina la ms antigua
    End If
    nUndo = nUndo + 1   'incrementa contador de acciones
    ReDim Preserve Undos(nUndo) 'agrega elemento
    Undos(nUndo).acc = acc
    Undos(nUndo).pos = pos
    Undos(nUndo).cad = cad  'Copia cadena de la accin.
'Debug.Print "*accion" & nUndo & "(" & pos.xt & "," & pos.yt & "):" & cad
    Call RefresEstadoModif   'Actualiza estado
End Sub

Private Sub EjecAcc(acc As Integer, pos As Tpostex, cad As String)
'Ejecuta una accin de modificacin del texto de tipo Tundo
Dim tipsel As Integer     'Modo de Seleccin
    Deshaciendo = True  'Para evitar guardar las acciones del "deshacer"
    Select Case acc
    Case TU_INS     'Inserta texto
        Redibujar = False
        posCursorA2 pos 'ubica cursor
        CurInsertar cad 'Inserta la cadena indicada
'Debug.Print ">insertar(" & pos.xt & "," & pos.yt & "):" & cad
    Case TU_INSn    'Inserta texto en modo normal
        tipsel = tipSelec      'Guarda tipo de seleccin
        tipSelec = 0
        Redibujar = False
        posCursorA2 pos 'ubica cursor
        CurInsertar cad 'Inserta la cadena indicada
        tipSelec = tipsel   'Restaura tipo de seleccin
    Case TU_ELI     'Elimina texto
        Redibujar = False
        posCursorA2 pos 'ubica cursor
        CurEliminarCad cad   'Elimina la cadena indicada
'Debug.Print ">eliminar(" & pos.xt & "," & pos.yt & "):" & cad
    Case TU_ELIn    'Elimina en modo normal
        tipsel = tipSelec      'Guarda tipo de seleccin
        tipSelec = 0
        Redibujar = False
        posCursorA2 pos 'ubica cursor
        CurEliminarCad cad   'Elimina la cadena indicada
        tipSelec = tipsel   'Restaura tipo de seleccin
    Case TU_SNOR    'Pasa a modo normal
        tipSelec = 0
    Case TU_SCOL    'Pasa a modo por columnas
        tipSelec = 1
    End Select
    Deshaciendo = False
End Sub

Private Sub EjecutarAcc(acc As Tundo)
'Ejecuta una accin de tipo Tundo
    EjecAcc acc.acc, acc.pos, acc.cad
End Sub

Private Sub DeshacerAcc(acc As Tundo)
'Deshace una accin de tipo Tundo
    EjecAcc -acc.acc, acc.pos, acc.cad
End Sub

Public Sub Deshacer()
'Deshace una accin previamente realizada
    If nUndo > 0 Then
        DeshacerAcc Undos(nUndo)
        nUndo = nUndo - 1   'decrementa
        ReDim Preserve Undos(nUndo)  'elimina siguiente accin
    End If
    Call RefresEstadoModif
End Sub

Private Function TamMemDeshacer() As Long
'Devuelve la cantidad de caracteres (no de bytes) usados en la
'grabacin de las acciones de "deshacer".
Dim tmp As Long
Dim i As Integer
    For i = 1 To nUndo
        tmp = tmp + Len(Undos(i).cad)
    Next
    TamMemDeshacer = tmp
End Function

'*************************************************************************************
'***************************** CDIGO DE RESPUESTA A EVENTOS *************************
'*************************************************************************************
Private Sub UserControl_GotFocus(): Call EncenCursor: End Sub
Private Sub UserControl_LostFocus(): Call ApagCursor: End Sub

Private Sub pic_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
'Se ha soltado un archivo
Dim arc As String
    If Data.GetFormat(vbCFFiles) Then
        'Hay nombre de archivos
        arc = Data.Files(1)     'Devuelve el primer archivo
        'Dispara evento
        RaiseEvent ArchivoSoltado(arc)
    End If
End Sub

Private Sub pic_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'Se ha hecho click en el control
Dim xt As Integer
Dim yt As Long
'    If x < ancNLinP Then
'        'MsgBox "En columna de lneas"
'        Exit Sub
'    End If
    
    'Movemos el cursor en la posicin indicada
    xt = Round(x / anccarP) + col1
    yt = Int(y / altcarP) + fil1
    Redibujar = False
    tCursorA2 xt, yt
    curXd = curXt      'actualiza posicin deseada
    If Button = 1 Then
        '---------botn izquierdo----------
        If Shift = 1 Then   'Con shift encendido
            Call ExtenderSel
        Else
            Call LimpSelec(True)        'Limpia seleccin
            'Marca la posicin del cursor antes de una seleccin
            Call FijarSel0
            If Redibujar Then Call Refrescar
            Call EncenCursor    'Enciende para que sea visible en la nueva posicin
        End If
        'Inicia bandera para arrastre
        pulsadoI = True
        xt0 = xt: yt0 = yt  'Inicia coordenadas para movimiento
    Else
        '---------botn derecho----------
    End If
    ultBotPul = Button  'Actualiza ltimo botn pulsado
    Call fContex.MouseDown(curXt, curYt)   'Pasa evento
End Sub

Private Sub pic_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim xt As Integer
Dim yt As Long
'    If X  < ancNLinP Then
'        Exit Sub
'    End If
    If pulsadoI Then
        'Para indicar arrastre
'        UserControl.MousePointer = vbNoDrop
        '-----Contina seleccin----
        'Movemos el cursor en la posicin indicada
        xt = Int(x / anccarP) + col1
        yt = Int(y / altcarP) + fil1
        If xt0 = xt And yt0 = yt Then Exit Sub
        Redibujar = False
        tCursorA2 xt, yt      'Para realizar desplazamiento
        Call ExtenderSel
    End If
    xt0 = xt: yt0 = yt
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub pic_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    
    If Button = 1 Then
        pulsadoI = False
'        UserControl.MousePointer = vbDefault    'Termina arrastre
    ElseIf Button = 2 Then
        'Activa men contextual si es que hay
        If Not (menuContext Is Nothing) Then
            PopupMenu menuContext
        End If
    End If
End Sub

Private Sub pic_DblClick()
    
    If ultBotPul = 1 Then
        '------Doble click izquierdo ---------
        Redibujar = False
        tCursorA2 curIniPal2(), curYt
        Call FijarSel0
        tCursorA2 curFinPal(), curYt
        Call ApagCursor 'Para que no interfiera
        Call ExtenderSel
    End If
End Sub

Private Sub UserControl_Initialize()
Dim tm As TEXTMETRIC
'MsgBox parent.Name
    'Carga men contextual
    Set fContex = New frmEdiCtx2
    Load fContex    'Debe estar cargado para funcionar
    fContex.Iniciar Me, UserControl.hWnd
    pic.ScaleMode = vbPixels
    UserControl.ScaleMode = vbPixels
    facdesV = 1
    Call LimpiarLineas
    
    verEstado = False
    verDesVer = False
    verDesHor = False
    
    FijaFil1 1      'fil1= 1
    FijaCol1 1      'col1= 1
    nEspTab = 6     '6 espacios para tabulacin
    
    
    
    
    
    'Inicia colores del editor
    mColFonEdi = vbWhite  'vbblack     'fondo de editor
    mColTxtNor = vbBlack  'vbWhite     'texto normal
    mColFonSel = RGB(130, 130, 255) 'fondo de seleccin
    mColLinAct = RGB(255, 255, 128) 'fondo de lnea actual
    mColTxtSel = vbWhite
    mColFonNli = RGB(210, 210, 210)
    mColTxtCom = RGB(128, 128, 128)
    mColTxtCad = RGB(90, 90, 255)
    mColPalRes = RGB(0, 190, 0)     'verde oscuro
    mColPalRes2 = vbRed     'verde oscuro
    mColTxtFun = RGB(0, 190, 0)     'verde oscuro
    
    pic.BackColor = mColFonEdi
    
    'Define el tipo de texto
'    Call FijaTexto(mColTxtNor, 9, 0, "Courier New")
'    UserControl.Font = "Courier New"
'    UserControl.FontSize = 9
    Call FijaTexto(mColTxtNor, 10, 0, "Fixedsys")
    UserControl.Font = "Fixedsys"   'Si no se le asigna as, no funciona bien
    UserControl.FontSize = 10       'el "GetTextMetrics"
    
    Call GetTextMetrics(pic.hdc, tm)
    anccarP = tm.tmAveCharWidth  'Siempre en pixels
    altcarP = tm.tmHeight        'Siempre en pixels
    
    maxTamLin = 0   'no hay lneas cargadas an
    VScroll1.Min = 1
    HScroll1.Min = 1
    pintando = False
    
    'inicia cursor
    curXt_ant = 1
    curYt_ant = 1
    FijaCursor 1, 1
    curXd = 1     'Inicia posicin X deseada de cursor
    Call FijarSel0  'inicia parmetros de seleccin
    ActivarCursor
    Call InicDeshacer
    Call InicBuscar("")
    
    tipArch = 0     'Tipo DOS
    'Posiciones fijas de la barra de estado
    VScroll1.Top = 0
    HScroll1.Left = 0
    lblEstado1.Left = 0
    lblEstado1.Width = 1500     'ScaleWidth
    lblEstado2.Left = 1500
    lblEstado2.Width = 1500
    lblEstado3.Left = 180
    lblEstado3.Width = 50
    lblEstado4.Left = 230
    'lblEstado4.Width = 230
    pic.Top = 0     'Ubica el picture en el control
End Sub

Private Sub UserControl_Terminate()
'Elimina objetos creados
    DeleteObject hPen
    DeleteObject hFont
    DeleteObject hBrush
    'desactiva por si acaso
    If Not (fContex Is Nothing) Then Unload fContex

End Sub

Public Sub Refrescar()
'Actualiza la apriencia y el contenido del control
    Call UserControl_Resize
End Sub

Private Sub pic_Paint()
    'Dibuja sin refrescar PIC para evitar llamadas recursivas
    'Adems se supone que si se refresca es porque se ha borrado
    'la informacin.
    Call Dibujar(False)
End Sub

Private Sub RecalculaMaxColVis()
'Realiza el Redimensionamiento horizontal, calculando "maxColVis" de acuerdo
'a si se debe mostrar el nmero de lnea y al nmero de lneas totales .
Dim ancVScroll As Long
    If verDesVer Then
        ancVScroll = VScroll1.Width
    Else
        ancVScroll = 0
    End If
    If verNumLin Then
        If nLin > 100000 Then
            ancNLinP = 47
        ElseIf nLin > 10000 Then
            ancNLinP = 40
        ElseIf nLin > 1000 Then
            ancNLinP = 33
        ElseIf nLin > 100 Then
            ancNLinP = 26
        Else
            ancNLinP = 19
        End If
    Else
        ancNLinP = 2    'deja un pequeo espacio lateral
    End If
    'posiciona el "pic"
    pic.Left = ancNLinP
    pic.Width = Posit(ScaleWidth - ancVScroll - ancNLinP)
    maxColVis = pic.Width \ anccarP
    col2 = col1 + maxColVis - 1     'actualiza col2
End Sub

Private Sub UserControl_Show()
'Se produce cuando se carga el formulario contenedor
End Sub

Private Sub UserControl_Hide()
'Cuando se descarga el formulario contenedor
    Call fContex.FinAyudContextual
    If Not (fContex Is Nothing) Then Unload fContex
End Sub

Private Sub UserControl_ExitFocus()
'Cuando se oculta el formulario padre o pierde el enfoque
    If ParentForm Is Nothing Then
        Call fContex.FinAyudContextual
    Else    'Hay padre activo
        'Perdi el enfoque, pudo haber sido porque se ha mostrado el mismo
        'formulario de lista.
        If Not MostfCtx Then
            If Screen.ActiveForm Is fContex Then
                'Se ha activado la lista, puede ser por un "click"
            Else
                Call fContex.FinAyudContextual
            End If
        End If
        MostfCtx = False
    End If
End Sub

Private Sub UserControl_Resize()
Dim altHScroll As Single   'alto de HScroll1
Dim altEstado As Single   'alto de HScroll1
Dim ancVScroll As Single  'ancho de VScroll1
    'Fija tamao variable de lblEstado4
    lblEstado4.Width = Posit(ScaleWidth - 220)
    'Fija ancho de Barra de desplazamiento horizontal
    If verDesVer Then
        HScroll1.Width = Posit(ScaleWidth - VScroll1.Width)
    Else
        HScroll1.Width = ScaleWidth
    End If
    'si se quiere dejar espacio para algo
    'HScroll1.Width = Posit(ScaleWidth - VScroll1.Width - 500)
    'Posicin de barra de desplazamiento vertical
    If verDesVer Then
        If verEstado Then
            VScroll1.Height = Posit(ScaleHeight - lblEstado1.Height)
        Else
            VScroll1.Height = ScaleHeight
        End If
        ancVScroll = VScroll1.Width
        VScroll1.Left = ScaleWidth - ancVScroll
        VScroll1.Visible = True
    Else
        ancVScroll = 0
        VScroll1.Visible = False
    End If
    Call RecalculaMaxColVis
    'Redimensionamiento vertical
    If verDesHor Then
        altHScroll = HScroll1.Height
        'an no se sabe la posicin vertical de HScroll1
        HScroll1.Visible = True
    Else
        altHScroll = 0
        HScroll1.Visible = False
    End If
    If verEstado Then   'Muestra barra de estado
        altEstado = lblEstado1.Height
        lblEstado1.Top = ScaleHeight - altEstado
        lblEstado2.Top = ScaleHeight - altEstado
        lblEstado3.Top = ScaleHeight - altEstado
        lblEstado4.Top = ScaleHeight - altEstado
        lblEstado1.Visible = True
        lblEstado2.Visible = True
        lblEstado3.Visible = True
        lblEstado4.Visible = True
    Else
        altEstado = 0
        lblEstado1.Visible = False
        lblEstado2.Visible = False
        lblEstado3.Visible = False
        lblEstado4.Visible = False
    End If
    pic.Height = Posit(ScaleHeight - altHScroll - altEstado)
    'pic.Left = ancNLinP
    'pic.Width = Posit(ScaleWidth - ancVScroll - ancNLinP)
    HScroll1.Top = pic.Height
    'mximo que se puede mostrar
    maxLinVis = pic.ScaleHeight \ altcarP
    If maxLinVis = 0 Then
        Exit Sub  'Probablemente minimizado o demasiado pequeo
    End If
    fil2 = fil1 + maxLinVis - 1
    Call ActualizaNLinFin   'actualiza las lneas visible
    Call Dibujar            'refresca por si acaso. Aqu se puede cambiar el
                            'dimensionamiento horizontal
    Call ActLimitesBarDesp  'actualiza lmites de Scroll Bar's
End Sub

Private Sub pic_KeyDown(KeyCode As Integer, Shift As Integer)
Dim conShift As Boolean
Dim conCtrl As Boolean
    RaiseEvent KeyDown(KeyCode, Shift)  'dispara evento
    If KeyCode = 67 And Shift = 4 Then
        RaiseEvent CambiaModo   'Peticin de cambio de modo
    End If
    If KeyCode = 16 Then Exit Sub   'Ignora <Shift> solo
    If KeyCode = 17 Then Exit Sub   'Ignora <Ctrl> solo
    If KeyCode = 18 Then Exit Sub   'Ignora <Alt> solo
    If (Shift And 1) = 1 Then conShift = True
    If (Shift And 2) = 2 Then conCtrl = True
    If fContex.KeyDown(KeyCode, Shift) Then
        'No procesamos la tecla porque ya lo proces el men de ayuda
        Exit Sub
    End If
    Select Case KeyCode
    'Teclas de desplazamiento
    Case 39 'flecha derecha
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_DERPAL, , conShift
        Else
            DesplazaCursor DIR_DER, , conShift
        End If
    Case 37 'flecha izquierda
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_IZQPAL, , conShift
        Else
            DesplazaCursor DIR_IZQ, , conShift
        End If
    Case 40 'flecha abajo
        If conCtrl Then
            DesplazaCursor DIR_ABAPAR, , conShift
        Else
            DesplazaCursor DIR_ABA, , conShift
        End If
    Case 38 'flecha arriba
        If conCtrl Then
            DesplazaCursor DIR_ARRPAR, , conShift
        Else
            DesplazaCursor DIR_ARR, , conShift
        End If
    Case 34     'pag.abajo
        DesplazaCursor DIR_PABA, maxLinVis - 1, conShift
    Case 33     'pag.arriba
        DesplazaCursor DIR_PARR, maxLinVis - 1, conShift
    Case 36     'inicio
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_HOM, , conShift
        Else
            DesplazaCursor DIR_INI, , conShift
        End If
    Case 35     'fin
        If conCtrl Then    'Ctrl
            DesplazaCursor DIR_END, , conShift
        Else
            DesplazaCursor DIR_FIN, , conShift
        End If
    Case 116    'F5 refresca
        Call Dibujar    'Dibuja el control
    'de modificacin
    Case 46     'DEL
        If conShift Then
            Call CortaSeleccion
        Else
            Call CurEliminar
        End If
    Case 45     'INSERT
        If conCtrl Then
            Call CopiaSeleccion
        ElseIf conShift Then
            Call PegaSeleccion
        End If
    Case 13
        RaiseEvent TeclaEnter(linact, Shift)
        If ModEnvDir And Shift = 0 Then   'En este modo, primero va al final
            If curYt = nLin Then    'Est al final
                DesplazaCursor DIR_FIN, , conShift
                CurInsertar vbCrLf  'Se inserta salto
            Else    'Hay ms lneas, no se inserta
                DesplazaCursor DIR_ABA, , conShift
            End If
        Else
            CurInsertar vbCrLf
        End If
    Case 8
        Call CurEliminarB
    End Select
    Call fContex.KeyDown2(KeyCode, Shift)
End Sub

Private Sub pic_KeyPress(KeyAscii As Integer)
'Procesa una tecla pulsada
    
    If KeyAscii >= 32 Or KeyAscii = 9 Then
'        If Not HayAyudC Then
            CurInsertar Chr(KeyAscii)
'        End If
    End If
'    If KeyAscii = 27 And Not HayAyudC Then
'        RaiseEvent TeclaEscape  'Evento de escape
'    End If
    Call fContex.KeyPress(KeyAscii)
End Sub

'-----Eventos del desplazamiento
Private Sub VScroll1_Change()
Dim dy As Long
    If pintando Then Exit Sub   'Se est en medio de un redibujo
    dy = VScroll1.Value / facdesV - fil1
    FijaFil1 fil1 + dy
    Call Dibujar    'Dibuja el control
End Sub

Private Sub HScroll1_Change()
Dim dx As Integer
    If pintando Then Exit Sub   'Se est en medio de un redibujo
    dx = HScroll1.Value - col1
    FijaCol1 col1 + dx  'desplaza
    Call Dibujar    'Dibuja el control
End Sub

'*************************************************************************************
'****************** FUNCIONES GRFICAS Y DE DESPLAZAMIENTO DEL CURSOR ****************
'*************************************************************************************
Private Sub FijaLapiz(estilo As Long, Ancho As Long, color As Long)
'Establece el lpiz actual de dibujo
Dim hdc As Long
    hdc = pic.hdc
    If hPen <> 0 Then DeleteObject hPen     'si ya hay un lpiz, lo elimina
    hPen = CreatePen(estilo, Ancho, color)
    SelectObject hdc, hPen                  'queda pendiente eliminarlo
End Sub

Private Sub FijaRelleno(colorr As Long)
'Establece el relleno actual
Dim hdc As Long
    hdc = pic.hdc
    If hBrush <> 0 Then DeleteObject hBrush 'si hay relleno, lo elimina
    hBrush = CreateSolidBrush(colorr)
    SelectObject hdc, hBrush                'queda pendiente eliminarlo
End Sub

Private Sub FijaTexto(color As Long, tam As Long, nDegrees As Single, _
              Optional Letra As String = "Times New Roman", _
              Optional negrita As Boolean = False, _
              Optional cursiva As Boolean = False, _
              Optional subrayado As Boolean = False)
    pic.ForeColor = color
    pic.Font.SIZE = tam
    pic.Font.Name = Letra
End Sub

Private Sub DesplazaCursor(direccion As Integer, Optional paso As Long = 1, _
                           Optional actselec As Boolean = False)
'Mueve el cursor en la pantalla, considerando que deba caer en una posicin
'vlida. Desplaza y refresca la pantalla si es necesario
'Implementado a responder los desplazamientos por teclado. Se ha diseado
'para que los rerfrescos de pantalla sean slo cuando es necesario.
Dim posi As Integer 'posicin inicial
Dim lin As String   'linea de trabajo
    Redibujar = False       'inicia para verificar si se debe redibujar
    'Verifica si escapa de la pantalla o de zona vlida
    Select Case direccion
    Case DIR_IZQ
        If curXt = 1 And curYt > 1 Then   'Esta al inicio de lnea y hay anterior
            tCursorA2 Len(linexp(curYt - 1)) + 1, curYt - 1, A_IZQ_TAB
        Else
            tCursorA2 curXt - paso, curYt, A_IZQ_TAB
        End If
        curXd = curXt     'actualiza posicin deseada
    Case DIR_DER
        If curXt >= Len(linact) + 1 And curYt < nLin Then  'Final de lnea y hay siguiente
            tCursorA2 1, curYt + 1, A_DER_TAB
        Else
            tCursorA2 curXt + paso, curYt, A_DER_TAB
        End If
        curXd = curXt     'actualiza posicin deseada
    Case DIR_ARR
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curYt - paso, A_IZQ_TAB
    Case DIR_ABA
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curYt + paso, A_IZQ_TAB
    Case DIR_PARR   'Pgina arriba
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        VerticalScroll CInt(-paso)
        tCursorA2 curXt, curYt - paso, A_IZQ_TAB
    Case DIR_PABA   'Pgina abajo
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        VerticalScroll CInt(paso)
        tCursorA2 curXt, curYt + paso, A_IZQ_TAB
    Case DIR_ARRPAR
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curIniPar(), A_IZQ_TAB
    Case DIR_ABAPAR
        If curXd <> curXt Then curXt = curXd  'intenta recuperar posicin
        tCursorA2 curXt, curFinPar(), A_IZQ_TAB
    Case DIR_INI    'lleva hasta el inicio de la lnea
        tCursorA 1, curYt, A_IZQ_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_FIN    'lleva hasta el final de la lnea
        tCursorA maxTamLin + 1, curYt, A_DER_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_HOM    'Al inicio del texto
        tCursorA 1, 1, A_IZQ_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_END    'Al final del texto
        tCursorA2 maxTamLin + 1, nLin, A_IZQ_TAB
        curXd = curXt     'actualiza posicin deseada
    Case DIR_IZQPAL
        If curXt = 1 And curYt > 1 Then   'Esta al inicio de lnea y hay anterior
            tCursorA2 Len(linexp(curYt - 1)) + 1, curYt - 1, A_IZQ_TAB
        Else
            tCursorA2 curIniPal(), curYt, A_IZQ_TAB
        End If
        curXd = curXt     'actualiza posicin deseada
    Case DIR_DERPAL 'A la derecha por palabra
        If curXt >= Len(linact) + 1 And curYt < nLin Then  'Final de lnea y hay siguiente
            tCursorA2 1, curYt + 1, A_DER_TAB
        Else
            tCursorA2 curSigPal(), curYt, A_IZQ_TAB
        End If
        curXd = curXt      'actualiza posicin deseada
    End Select
    'Procesa el dibujo de la seleccin
    If actselec Then    'Activar seleccin
        Call ExtenderSel
    Else
        If Redibujar Then   'Se movi la pantalla, redibujamos todo
            Call LimpSelec  'Aprovechamos para limpiar si hay seleccin
            Call Dibujar
        Else
            Call LimpSelec(True)      'Limpia seleccin
        End If
        'Marca la posicin del cursor antes de una seleccin
        Call FijarSel0      'Fija punto base
        Call EncenCursor    'Enciende para que sea visible en la nueva posicin
    End If
End Sub

Private Sub ExtenderSel()
'Refresca el texto del control considerando que la posicin actual del cursor define
'un lmite (inicial o final) en el bloque de seleccin. El otro lmite es "sel0" que
'debe haber sido previamente fijado.
'Lo que se trata de hacer con este procedimiento es evitar llamar innecesariamente
'a Dibujar(). Pero si la variable "Redibujar" est en true, se redibuja todo
'incondicionalmente.
Dim Ptmp As Tpostex      'define el intervalo de la zona a dibujar
    If tipSelec = 1 Then Redibujar = True   'Fuerza actualizacin Total en este modo
    Call DesactivarCursor   'Se desactiva para no interferir
    haysel = True   'se marca la bandera
    If CurMenorPos(sel0) Then   '--------Cursor antes de sel0---------
        If MayorPos(sel2, sel0) Then    'Pas de despus a antes
            Ptmp = sel2     'guarda lmite de dibujo
            sel1 = LeePosCur()    'Inicio de la seleccin est ahora en el cursor
            sel2 = sel0
            If Redibujar Then Call Dibujar Else Call DibTextPos(sel1, Ptmp)
        Else 'Seleccin sigue de Cursor a sel0 (slo aumenta o disminuye)
            sel1 = LeePosCur()     'Inicio de la seleccin est ahora en el cursor
            sel2 = sel0
            'Verifica si se dibuja todo o slo las lneas afectadas
            If Redibujar Then Call Dibujar Else Call DibTextPos(sel1, sel1ant)
        End If
    ElseIf CurMayorPos(sel0) Then   '--------Cursor despus de sel0---------
        If MenorPos(sel1, sel0) Then 'Pas de antes a despus.
            Ptmp = sel1     'guarda lmite de dibujo
            sel1 = sel0
            sel2 = LeePosCur()     'Fin de la seleccin est ahora en el cursor
            If Redibujar Then Call Dibujar Else Call DibTextPos(Ptmp, sel2)
        Else 'Seleccin sigue de sel0 a Cursor (slo aumenta o disminuye)
            sel1 = sel0
            sel2 = LeePosCur()    'Fin de la seleccin est ahora en el cursor
            'Verifica si se dibuja todo o slo las lneas afectadas
            If Redibujar Then Call Dibujar Else Call DibTextPos(sel2, sel2ant)
        End If
    Else            '--------Cursor en la misma posicin---------
        'No hay nada que procesar, slo ver si hay que borrar
        sel1 = sel0
        sel2 = sel0
        If Redibujar Then Call Dibujar Else Call DibTextPos(sel1ant, sel2ant)
    End If
    'actualiza anteriores
    sel1ant = sel1
    sel2ant = sel2
    'muestra estado de seleccin
    If verEstado Then
        If sel1.xt = sel2.xt And sel1.yt = sel2.yt Then
            lblEstado4 = "sin seleccin"
        Else
            lblEstado4 = CStr(sel2.xt - sel1.xt) & " Col. seleccionados"
        End If
    End If
End Sub

Public Sub VerticalScroll(dy As Integer)
'Funcin pblica para realizar un desplazamiento vertical de la pantalla.
'Se ha creado pensando en el desplazamiento con el evento "MouseWheel"
Dim vFinal As Integer
    vFinal = VScroll1.Value + dy
    If vFinal > VScroll1.Max Then vFinal = VScroll1.Max
    If vFinal < VScroll1.Min Then vFinal = VScroll1.Min
    VScroll1.Value = vFinal
End Sub

'Private Sub HScroll1_GotFocus()
''Si por si acaso toma el enfoque, hay que devolverlo
'    'No funciona:     Call UserControl.SetFocus
'    UserControl.HScroll1.Visible = False
'    UserControl.HScroll1.Visible = True
'End Sub

'Private Sub VScroll1_GotFocus()
''Si por si acaso toma el enfoque, hay que devolverlo
'    'No funciona:     Call UserControl.SetFocus
'    UserControl.VScroll1.Visible = False
'    UserControl.VScroll1.Visible = True
'End Sub

Public Function CadPropiedades() As String
'Devuelve una cadena con las principales propiedades del editor
Dim tmp As String
    tmp = B2f(verEstado) & W & B2f(verDesHor) & W & B2f(verDesVer) & W & _
          B2f(verNumLin) & W & W & W & _
          mColFonEdi & W & mColFonSel & W & mColTxtNor & W & _
          mColTxtSel & W & mColFonNli & W & W & _
          mColTxtCom & W & mColTxtCad & W & mColPalRes & W & _
          mColPalRes2 & W & mColTxtFun & W & W
    CadPropiedades = tmp
End Function

Public Sub LeePropiedades(cad As String)
'Carga las principales propiedades del editor de una cadena
Dim a() As String
    a = Split(cad, W)
    verEstado = f2B(a(0))
    verDesHor = f2B(a(1))
    verDesVer = f2B(a(2))
    verNumLin = f2B(a(3))
    
    mColFonEdi = a(6)
    mColFonSel = a(7)
    mColTxtNor = a(8)
    mColTxtSel = a(9)
    mColFonNli = a(10)
    
    mColTxtCom = a(12)
    mColTxtCad = a(13)
    mColPalRes = a(14)
    mColPalRes2 = a(15)
    mColTxtFun = a(16)
End Sub

Public Property Get enabled() As Boolean
    enabled = pic.enabled
End Property

Public Property Let enabled(ByVal vNewValue As Boolean)
    pic.enabled = vNewValue
    HScroll1.enabled = vNewValue
    VScroll1.enabled = vNewValue
End Property
