#! /bin/bash

# Proceso para captura de los reportes del STP.
# La idea consiste en enviar comandos temporizados a la sesin Telnet y capturar 
# la salida interceptando los mensajes.
#                                  Creado por:     Tito Hinostroza  20/05/2008
#                                  Modificado por: Tito Hinostroza  30/05/2008

#lee parmetros
STP=$1
LOG=$2
HH=$3
#HH="2000"
PORT=$4

USUARIO="jvilchez"

if [ "$STP" == "LV" ]; then
	IP="10.10.72.10"
	CLAVE="Marzo_10"
fi

if [ "$STP" == "SB" ]; then
	IP="10.10.164.73"
	CLAVE="Marzo_10"
fi


nar=0;		#nmero de enlaces
nre=0;		#nmero de reintentos
nso=0;		#nmero de sobretiempos

lista="lista_lsn_${STP}.txt"

#archivo de salida temporal
salida="${STP}_${HH}.tmp"

(sleep 2;
echo "${PORT}\r";
sleep 3;
echo "login:uid=$USUARIO\r";
sleep 2;

#verifica si acept
cola=`tail -4 $salida`;
cad=`echo $cola | grep "System busy" | wc -l`;
if [ "$cad" == "       1" ]; then
	#estuvo ocupado, lo intentamos otra vez
	echo "login:uid=$USUARIO\r";
	sleep 2;
fi;

echo "$CLAVE\r";
sleep 3;

for LSN in `cat $lista`
do
	#enva comando para reporte de lsn
	echo "rept-meas:type=comp:enttype=link:period=specific:hh=$HH:lsn=$LSN\r";
	sleep 1;	#espera al shell
	#espera respuesta
	n=1;
	while [ $n -lt 90 ]     #espera hasta 90 segundos, luego termina s o s.
	do
		cola=`tail -4 $salida`;
		enlace=`echo $LSN | awk '{print substr($0 "        ",1,12) }'`

		#busca marca de fin "END OF ON-DEMAND". Se usa "wc" porque 
		#el "grep" slo muestra lnea en blanco
		cad=`echo $cola | grep "END OF ON-DEMAND" | wc -l`;
		if [ "$cad" == "       1" ]; then
			echo "Capturando lsn:${enlace}. ---> CAPTURA EXITOSA." >> $LOG;
			break;
		fi;

		cad=`echo $cola | grep "Unknown LSN" | wc -l`;
		if [ "$cad" == "       1" ]; then
			echo "Capturando lsn:${enlace}. LSN desconocido. "  >> $LOG;
			break;
		fi;

		cad=`echo $cola | grep "System busy" | wc -l`;
		if [ "$cad" == "       1" ]; then
			nre=`expr $nre + 1`
			echo "Capturando lsn:${enlace}. Sistema Ocupado. Reintentando... "  >> $LOG;
			sleep 10
			n=1;	#para iniciar nuevo conto y lanzar de nuevo el comando
			echo "rept-meas:type=comp:enttype=link:period=specific:hh=$HH:lsn=$LSN\r";
			sleep 1;	#espera al shell
			continue;
		fi;

		cad=`echo $cola | grep "On demand report currently being" | wc -l`;
		if [ "$cad" == "       1" ]; then
			nre=`expr $nre + 1`
			echo "Capturando lsn:${enlace}. Otro reporte en curso. Reintentando... "  >> $LOG;
			sleep 10
			n=1;	#para iniciar nuevo conto y lanzar de nuevo el comando
			echo "rept-meas:type=comp:enttype=link:period=specific:hh=$HH:lsn=$LSN\r";
			sleep 1;	#espera al shell
			continue;
		fi;

		cad=`echo $cola | grep "Connection closed." | wc -l`;
		if [ "$cad" == "       1" ]; then
			echo "Capturando lsn:${enlace}. Conexin cerrada. "  >> $LOG;
			exit 	#no tiene sentido seguir leyendo
		fi;
	
		cad=`echo $cola | grep "Authority Violation" | wc -l`;
		if [ "$cad" == "       1" ]; then
			echo "Capturando lsn:${enlace}. Sesin no iniciada. "  >> $LOG;
			exit	#no tiene sentido seguir leyendo
		fi;
		
		sleep 1;
		n=`expr $n + 1`
		if [ "$n" == "90" ]; then
			nso=`expr $nso + 1`
			echo "Capturando lsn:${enlace}. Cortado por sobretiempo." >> $LOG;
		fi;
	done;
#	sleep 1;	#espera al shell
	nar=`expr $nar + 1`
done;
echo "===========Captura Terminada===========" >> $LOG;
echo "Enlaces Procesados: $nar . Reintentos: $nre . Sobretiempos: $nso" >> $LOG;
) | telnet $IP > $salida
###
